#ifndef APLICACIO_H
#define APLICACIO_H

#include <qmainwindow.h>
#include <qvbox.h>
#include <qvbuttongroup.h>
#include <qradiobutton.h>
#include <qspinbox.h>

#include "editorterreny.h"
#include "visorwin.h"
#include "terreny.h"
#include "visio.h"
#include "configdialeg.h"

class QToolBar;
class QPopupMenu;

/*************************************************************************************************************************/
/*                                      class AplicacioWin: public QMainWindow                                           */
/*Classe principal que genera la finestra inicial en la qual es crea la superfície en 2D i per tant la malla corresponent*/
/*************************************************************************************************************************/

class AplicacioWin: public QMainWindow
{
    Q_OBJECT
public:
    AplicacioWin();
    ~AplicacioWin();

protected:
    void closeEvent( QCloseEvent * );
    void keyPressEvent( QKeyEvent * );

private slots:
    void closeWindow();

    void nouTerreny();
    void nouTerrenyAleatori();

    void mostraTerreny();

    void carregaTerreny();

    void desaTerreny();
    void desaTerrenyCom();

    void desaImatge();

    void canviaMode( QAction * );
    void canviaCalculs( QAction * ); //Visibilitat - Distàncies
    void configura();

    void about();
    void aboutQt();
  
    void actualitzaCoords( double, double );
    void mostraInformacioVisibilitatICoords( int ,bool,double,double );
    void visualitzaCorbes( bool );
    void tipusVisualitzacio();
    void visualitzaTextura( bool );
    void calculaDistancies();
    void inserirPuntCamiMinim();
    void calculaCamiMinim();
    void realitzarJocProves();
    
    void boto1Desactivat();
    void boto2Desactivat();
    void boto3Desactivat();

private:
    QString fitxer;
    EditorTerreny* editor;
    VisorWin*  visor;  
    Terreny* terreny;      
    Visio * visio;
//     RegionsHiperboliques* regions_hiperboliques;   
     
    QToolBar* fileTools;
    ConfigInfo prefs;
    QAction* selectAction;
    QAction* vertexsAction;
    QAction* triangAction;
    QAction* renderAction; 
    QAction* corbesAction;
    QAction* texturaAction;
    QAction* veureTexturaAction;
    QAction* puntVisio;
    QAction* segmentVisio;
    QAction* poligonVisio;
    QAction* poligonalVisio;
    QAction* visibilitatAction;
    QAction* distanciesAction;
    QAction *camiMinimAction;
    QAction *jocProvesAction;
    QAction *visioAction;
    QAction *tipusVisualitzacioAction;
    QAction *calcularDistanciesAction;
    QAction *inserirPuntCamiMinimAction;

            
    QRadioButton * unio;
    QRadioButton * interseccio;
    QRadioButton * counting;
    QRadioButton * combinat;
    QRadioButton * segment;
};


#endif
