#include "aresta.h"

/******************************************************************************************/
/*   Aresta::Aresta()                                                                     */
/*Constructor que inicialitza cadascuna de les variables globals de l'objecte aresta creat*/
/******************************************************************************************/

Aresta::Aresta ()  
{
	origen.modifica_coordenades(0.0, 0.0, 0.0);
	
	desti.modifica_coordenades(0.0, 0.0, 0.0);
}

/******************************************************************************/
/*   Aresta::Aresta( Punt, Punt)                                              */
/*Constructor amb parametres que inicialitza els punts que defineixen l'aresta*/
/******************************************************************************/

Aresta::Aresta (Punt a, Punt b) 
{
	origen = a;
	desti = b;
}

/*************************************************/
/*   Punt Aresta::getOrigen( )                   */
/*Metode que retorna el punt d'origen de l'aresta*/
/*************************************************/

Punt Aresta::getOrigen() 
{
	return origen;
}

/**********************************************/
/*   Punt Aresta::getDesti()                  */
/*Metode que retorna el punt desti de l'aresta*/
/**********************************************/

Punt Aresta::getDesti() 
{
	return desti;
}

/**********************************************************/
/*   void Aresta::setOrigen(Punt)                         */
/*Metode que permet modificar el punt d'origen de l'aresta*/
/**********************************************************/

void Aresta::setOrigen(Punt a) 
{
	origen = a;
}

/********************************************/
/*   Punt Aresta::punt_mig()                */
/*Metode que retorna el punt mig de l'aresta*/
/********************************************/

Punt Aresta::punt_mig() 
{
	Punt mig((origen.x()+desti.x())/2, (origen.y()+desti.y())/2, (origen.z()+desti.z())/2);
	return mig;
}

/**********************************************************/
/*   void Aresta::setDesti(Punt)                          */
/*Metode que permet modificar el punt de desti de l'aresta*/
/**********************************************************/

void Aresta::setDesti(Punt b) 
{
	desti = b;
}

/****************************************/
/*   void Aresta::midaAresta()          */
/*Metode que calcula la mida de l'aresta*/
/****************************************/

double Aresta::midaAresta()
{
	return (sqrt( ((origen.x() - desti.x()) * (origen.x() - desti.x())) +
                      ((origen.y() - desti.y()) * (origen.y() - desti.y())) +
                      ((origen.z() - desti.z()) * (origen.z() - desti.z()))
               ));
}
