#include "configcorbesdialeg.h"

#include <qvariant.h>
#include <qpushbutton.h>
#include <qgroupbox.h>
#include <qtable.h>
#include <qcheckbox.h>
#include <qlineedit.h>
#include <qlabel.h>
#include <qspinbox.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qcolordialog.h>
#include <qcolor.h>

#define PERTURBACIO   0.0000001

/********************************************************************************************************/
/*   ConfigCorbesDialeg::ConfigCorbesDialeg( QWidget* parent, const char* name, bool modal, WFlags fl ) */
/*    : QDialog( parent, name, modal, fl )                                                              */
/*Constructor de la classe, el qual crea la finestra desplegable amb els diferents botons i opcions     */
/********************************************************************************************************/

ConfigCorbesDialeg::ConfigCorbesDialeg( QWidget* parent, const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "configCorbesDialeg" );
    configCorbesDialegLayout = new QVBoxLayout( this, 11, 6, "configCorbesDialegLayout"); 

    groupBox1 = new QGroupBox( this, "groupBox1" );
    groupBox1->setColumnLayout(0, Qt::Vertical );
    groupBox1->layout()->setSpacing( 6 );
    groupBox1->layout()->setMargin( 11 );
    groupBox1Layout = new QGridLayout( groupBox1->layout() );
    groupBox1Layout->setAlignment( Qt::AlignTop );

    layout17 = new QHBoxLayout( 0, 0, 6, "layout17"); 

    taulaInfo = new QTable( groupBox1, "taulaInfo" );
    taulaInfo->setNumCols( taulaInfo->numCols() + 1 );
    taulaInfo->horizontalHeader()->setLabel( taulaInfo->numCols() - 1, tr( "Valor" ) );
    taulaInfo->setNumCols( taulaInfo->numCols() + 1 );
    taulaInfo->horizontalHeader()->setLabel( taulaInfo->numCols() - 1, tr( "Color" ) );
    taulaInfo->setNumRows( taulaInfo->numRows() + 1 );
    taulaInfo->verticalHeader()->setLabel( taulaInfo->numRows() - 1, tr( "0" ) );
    taulaInfo->setNumRows( 1 );
    taulaInfo->setNumCols( 2 );
    taulaInfo->setShowGrid( TRUE );
    layout17->addWidget( taulaInfo );

    layout16 = new QVBoxLayout( 0, 0, 6, "layout16"); 

    bAfegir = new QPushButton( groupBox1, "bAfegir" );
    layout16->addWidget( bAfegir );

    bEliminar = new QPushButton( groupBox1, "bEliminar" );
    layout16->addWidget( bEliminar );
    spacer4 = new QSpacerItem( 120, 110, QSizePolicy::Minimum, QSizePolicy::Expanding );
    layout16->addItem( spacer4 );
    layout17->addLayout( layout16 );

    groupBox1Layout->addMultiCellLayout( layout17, 0, 0, 0, 1 );
    spacer3 = new QSpacerItem( 460, 16, QSizePolicy::Minimum, QSizePolicy::Expanding );
    groupBox1Layout->addMultiCell( spacer3, 1, 1, 0, 1 );
    spacer6_2 = new QSpacerItem( 290, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    groupBox1Layout->addItem( spacer6_2, 5, 1 );

    bGenerador = new QPushButton( groupBox1, "bGenerador" );
    bGenerador->setEnabled( TRUE );

    groupBox1Layout->addWidget( bGenerador, 5, 0 );

    layout21 = new QVBoxLayout( 0, 0, 6, "layout21"); 

    checkGeneraValors = new QCheckBox( groupBox1, "checkGeneraValors" );
    layout21->addWidget( checkGeneraValors );

    layout15 = new QGridLayout( 0, 1, 1, 0, 6, "layout15"); 

    nivellMaximEdit = new QLineEdit( groupBox1, "nivellMaximEdit" );
    nivellMaximEdit->setEnabled( FALSE );

    layout15->addWidget( nivellMaximEdit, 1, 1 );

    textLabel1 = new QLabel( groupBox1, "textLabel1" );

    layout15->addWidget( textLabel1, 0, 0 );
    spacer7 = new QSpacerItem( 150, 50, QSizePolicy::Expanding, QSizePolicy::Minimum );
    layout15->addMultiCell( spacer7, 0, 1, 2, 2 );

    spinRang = new QSpinBox( groupBox1, "spinRang" );
    spinRang->setEnabled( FALSE );
    spinRang->setMaxValue( 50 );
    spinRang->setMinValue( 1 );

    layout15->addWidget( spinRang, 0, 1 );

    textLabel1_2 = new QLabel( groupBox1, "textLabel1_2" );

    layout15->addWidget( textLabel1_2, 1, 0 );
    layout21->addLayout( layout15 );

    groupBox1Layout->addMultiCellLayout( layout21, 2, 2, 0, 1 );

    layout20 = new QVBoxLayout( 0, 0, 6, "layout20"); 

    checkGeneraGradient = new QCheckBox( groupBox1, "checkGeneraGradient" );
    layout20->addWidget( checkGeneraGradient );

    layout19 = new QGridLayout( 0, 1, 1, 0, 6, "layout19"); 

    bColorInicial = new QPushButton( groupBox1, "bColorInicial" );
    bColorInicial->setEnabled( FALSE );
    bColorInicial->setPaletteBackgroundColor( QColor( 85, 255, 255 ) );

    layout19->addWidget( bColorInicial, 0, 1 );
    spacer5 = new QSpacerItem( 450, 16, QSizePolicy::Minimum, QSizePolicy::Expanding );
    layout19->addMultiCell( spacer5, 1, 1, 0, 2 );

    textLabel2 = new QLabel( groupBox1, "textLabel2" );

    layout19->addWidget( textLabel2, 0, 0 );

    bColorFinal = new QPushButton( groupBox1, "bColorFinal" );
    bColorFinal->setEnabled( FALSE );
    bColorFinal->setPaletteBackgroundColor( QColor( 0, 170, 0 ) );

    layout19->addWidget( bColorFinal, 0, 2 );
    layout20->addLayout( layout19 );

    groupBox1Layout->addMultiCellLayout( layout20, 4, 4, 0, 1 );
    spacer9 = new QSpacerItem( 470, 16, QSizePolicy::Minimum, QSizePolicy::Expanding );
    groupBox1Layout->addMultiCell( spacer9, 3, 3, 0, 1 );
    configCorbesDialegLayout->addWidget( groupBox1 );

    layout19_2 = new QHBoxLayout( 0, 0, 6, "layout19_2"); 

    bAjuda = new QPushButton( this, "bAjuda" );
    layout19_2->addWidget( bAjuda );
    spacer6 = new QSpacerItem( 200, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    layout19_2->addItem( spacer6 );

    bAccepta = new QPushButton( this, "bAccepta" );
    layout19_2->addWidget( bAccepta );

    bCancela = new QPushButton( this, "bCancela" );
    layout19_2->addWidget( bCancela );
    configCorbesDialegLayout->addLayout( layout19_2 );
    languageChange();
    resize( QSize(526, 598).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( checkGeneraValors, SIGNAL( toggled(bool) ), spinRang, SLOT( setEnabled(bool) ) );
    connect( taulaInfo, SIGNAL( doubleClicked(int,int,int,const QPoint& ) ), taulaInfo, SLOT( insertRows(int,int) ) );
    connect( taulaInfo, SIGNAL( clicked ( int, int, int, const QPoint& ) ), this, SLOT( setColor( int,int ) ) );
    connect( bAccepta, SIGNAL( clicked() ), this, SLOT( accept() ) );
    connect( bCancela, SIGNAL( clicked() ), this, SLOT( reject() ) );
    connect( bGenerador, SIGNAL( clicked() ), this, SLOT( generaNivells() ) );
    connect( bAfegir, SIGNAL( clicked() ), this, SLOT( afegeixNivell() ) );
    connect( bEliminar, SIGNAL( clicked() ), this, SLOT( eliminaNivell() ) );
    connect( checkGeneraGradient, SIGNAL( toggled(bool) ), bColorInicial, SLOT( setEnabled(bool) ) );
    connect( checkGeneraGradient, SIGNAL( toggled(bool) ), bColorFinal, SLOT( setEnabled(bool) ) );
    connect( checkGeneraValors, SIGNAL( toggled(bool) ), nivellMaximEdit, SLOT( setEnabled(bool) ) );
    connect( bColorInicial, SIGNAL( clicked() ), this, SLOT( canviaColorI( )));
    connect( bColorFinal, SIGNAL( clicked() ), this, SLOT( canviaColorF( )));
}

/*********************************************************************************/
/*   ConfigCorbesDialeg::~ConfigCorbesDialeg()                                   */
/*Destructor de la classe que no necesita esborrar res ja que no hi ha cap punter*/
/*********************************************************************************/

ConfigCorbesDialeg::~ConfigCorbesDialeg() {}

/*****************************************************/
/*   void ConfigCorbesDialeg::languageChange()       */
/*Metode que permet modificar el llenguatge utilitzat*/
/*****************************************************/

void ConfigCorbesDialeg::languageChange()
{
    setCaption( trUtf8( "\x43\x6f\x6e\x66\x69\x67\x75\x72\x61\x63\x69\xc3\xb3\x20\x43\x6f\x72\x62\x65\x73\x20\x64\x65\x20\x4e\x69\x76\x65\x6c\x6c" ) );
    groupBox1->setTitle( trUtf8( "\x49\x6e\x66\x6f\x72\x6d\x61\x63\x69\xc3\xb3\x20\x64\x65\x6c\x73\x20\x4e\x69\x76\x65\x6c\x6c\x73" ) );
    taulaInfo->horizontalHeader()->setLabel( 0, tr( "Valor" ) );
    taulaInfo->horizontalHeader()->setLabel( 1, tr( "Color" ) );
    taulaInfo->verticalHeader()->setLabel( 0, tr( "1" ) );
    bAfegir->setText( tr( "Afegeix Nivell" ) );
    bEliminar->setText( tr( "Elimina Nivell" ) );
    bGenerador->setText( tr( "Genera nivells" ) );
    checkGeneraValors->setText( tr( "Genera valors de nivell aleatoriament." ) );
    nivellMaximEdit->setText( tr( "20.0" ) );
    textLabel1->setText( trUtf8( "\x4e\xc3\xba\x6d\x65\x72\x6f\x20\x64\x65\x20\x6e\x69\x76\x65\x6c\x6c\x73\x3a" ) );
    textLabel1_2->setText( trUtf8( "\x56\x61\x6c\x6f\x72\x20\x6e\x69\x76\x65\x6c\x6c\x20\x6d\xc3\xa0\x78\x69\x6d\x3a" ) );
    checkGeneraGradient->setText( tr( "Genera gradient." ) );
    bColorInicial->setText( tr( "Color Inicial" ) );
    textLabel2->setText( tr( "Colors per generar gradient:" ) );
    bColorFinal->setText( tr( "Color Final" ) );
    bAjuda->setText( tr( "A&juda" ) );
    bAjuda->setAccel( QKeySequence( tr( "Alt+J" ) ) );
    bAccepta->setText( tr( "&Accepta" ) );
    bAccepta->setAccel( QKeySequence( tr( "Alt+A" ) ) );
    bCancela->setText( trUtf8( "\x26\x43\x61\x6e\x63\x65\x6c\xc2\xb7\x6c\x61" ) );
    bCancela->setAccel( QKeySequence( tr( "Alt+C" ) ) );
}

/*********************************************************************/
/*   void ConfigCorbesDialeg::generaNivells()                        */
/*Metode que permet generar els nivells segons les opcions escollides*/
/*********************************************************************/

void ConfigCorbesDialeg::generaNivells()
{
    QColor color, colorI, colorF;
    QRect rect = taulaInfo->cellRect( 0, 1 );
    QPixmap pix(rect.width(), rect.height());  
    int r, g, b;
    bool ok;        
    
    if( checkGeneraValors->isChecked() )
    {
      taulaInfo->setNumRows(spinRang->value());
      double maxim_nivell = nivellMaximEdit->text().toDouble( &ok );
      if ( ok )
      {
        for( int i = 0; i < taulaInfo->numRows(); i++ )
        {
          taulaInfo->setText( i, 0, QString("%1").arg((maxim_nivell/taulaInfo->numRows())*(i+1)) );
        }
      }      
      else qDebug("Valor maxim de nivell incorrecte.");
    }
    
    if( taulaInfo->numRows() == 0 ) return;
    
    if( checkGeneraGradient->isChecked() )
    {
       colorI = bColorInicial->paletteBackgroundColor();   
       colorF = bColorFinal->paletteBackgroundColor();       
       for(int i = 0; i < taulaInfo->numRows(); i++ )
       {
	  r = colorI.red() + (int)(( colorF.red() - colorI.red() ) * (i/((float)taulaInfo->numRows()-1.0)));
	  g = colorI.green() + (int)(( colorF.green() - colorI.green()) * (i/((float)taulaInfo->numRows()-1.0)));
          b = colorI.blue() + (int)(( colorF.blue() - colorI.blue()) * (i/((float)taulaInfo->numRows()-1.0)));
	  color.setRgb( r, g, b);
          pix.fill( color );
          taulaInfo->setText( i, 1, color.name() );
          taulaInfo->setPixmap( i, 1, pix );       
       }  
    }
}

/***************************************************************************/
/*   void ConfigCorbesDialeg::afegeixNivell()                              */
/*Metode que permet insertar el nou nivell a la taula i crear una nova fila*/
/***************************************************************************/

void ConfigCorbesDialeg::afegeixNivell()
{
    taulaInfo->insertRows( taulaInfo->numRows() );
}

/***************************************************/
/*   void ConfigCorbesDialeg::eliminaNivell()      */
/*Metode que permet eliminar un nivell de la taula */
/***************************************************/

void ConfigCorbesDialeg::eliminaNivell()
{
    taulaInfo->removeRow( taulaInfo->currentRow() );
}

/***************************************************************/
/*   void ConfigCorbesDialeg::setNivells( const Nivells &nv )  */
/*Metode que permet assignar els nivells sobre la taula d'info */
/***************************************************************/

void ConfigCorbesDialeg::setNivells( const Nivells &nv )
{
    QColor color;
    QRect rect = taulaInfo->cellRect( 0, 1 );
    QPixmap pix(rect.width(), rect.height());    

    if( nv.size() < 2 ) return;

    taulaInfo->setNumRows(nv.size()-1);
  
    for( int i = 1; i < nv.size(); i++ )
    {  
       if( !iguals( nv[i].valor, 0 ) )     
       {
          pix.fill( nv[i].color );
          taulaInfo->setText( i-1, 0, QString("%1").arg(nv[i].valor) );
          taulaInfo->setText( i-1, 1, (nv[i].color).name() );
          taulaInfo->setPixmap( i-1, 1, pix );
       }
    } 
}

/*************************************************************/
/*   Nivells ConfigCorbesDialeg::getNivells()                */
/*Metode que permet obtenir els nivells en el format Nivells */
/*************************************************************/

Nivells ConfigCorbesDialeg::getNivells()
{
  Nivells nvs;
  double value;
  QColor color; 
  bool ok;

  color.setNamedColor( taulaInfo->text( 0, 1 ) );
  nvs.push_back( Nivell( -0.0000001, color ) );
  for( int i = 0; i < taulaInfo->numRows(); i++ )
  {
     value = taulaInfo->text(i, 0).toDouble(&ok);
     if (ok && value != 0)
     {
        color.setNamedColor( taulaInfo->text( i, 1 ) );
        nvs.push_back( Nivell( value + PERTURBACIO, color ) );
     }
  } 

  sort( nvs.begin(), nvs.end(), menor );

  return nvs;
}

/**********************************************************************/
/*   void ConfigCorbesDialeg::setColor( int fila, int col )           */
/*Metode que permet assignar el color seleccionat per fer el gradient */
/**********************************************************************/

void ConfigCorbesDialeg::setColor( int fila, int col )
{
  QRect rect = taulaInfo->cellRect( fila, 1 );
  QPixmap pix(rect.width(), rect.height());
  QColor color;  

  if( col == 0 ) return;

  if( !( taulaInfo->text( fila, 1 ).isEmpty() ) )  color.setNamedColor( taulaInfo->text( fila, 1 ) );
  else color.setRgb(0, 0, 0); 
   
  color = QColorDialog::getColor( color, this, "Tria_Color" );
  if ( color.isValid() ) 
  {        
      taulaInfo->setText( fila, col, color.name() );
      pix.fill(color);
      taulaInfo->setPixmap( fila, col, pix );    
  } 
}

/**********************************************/
/*   void ConfigCorbesDialeg::canviaColorI()  */
/*Metode que permet modificar el color inicial*/
/**********************************************/

void ConfigCorbesDialeg::canviaColorI()
{
  QColor color = bColorInicial->paletteBackgroundColor();
  color = QColorDialog::getColor( color, this, "Tria_Color" );
  if ( color.isValid() ) 
  {        
      bColorInicial->setPaletteBackgroundColor( color );
  } 
}

/*********************************************/
/*   void ConfigCorbesDialeg::canviaColorF() */
/*Metode que permet modificar el color final */
/*********************************************/

void ConfigCorbesDialeg::canviaColorF()
{
  QColor color = bColorFinal->paletteBackgroundColor();
  color = QColorDialog::getColor( color, this, "Tria_Color" );
  if ( color.isValid() ) 
  {        
      bColorFinal->setPaletteBackgroundColor( color );
  } 
}
