#ifndef CONFIGCORBESDIALEG_H
#define CONFIGCORBESDIALEG_H

#include <qvariant.h>
#include <qdialog.h>
#include "corbesnivell.h"

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QSpacerItem;
class QGroupBox;
class QTable;
class QPushButton;
class QCheckBox;
class QLineEdit;
class QLabel;
class QSpinBox;

/***********************************************************************************************************/
/*                                 class ConfigCorbesDialeg : public QDialog                               */
/*Classe que descriu una finestra de dialeg que permet generar les corbes de nivell desitjades per l'usuari*/
/***********************************************************************************************************/

class ConfigCorbesDialeg : public QDialog
{
    Q_OBJECT

public:
    ConfigCorbesDialeg( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~ConfigCorbesDialeg();

    QGroupBox* groupBox1;
    QTable* taulaInfo;
    QPushButton* bAfegir;
    QPushButton* bEliminar;
    QPushButton* bGenerador;
    QCheckBox* checkGeneraValors;
    QLineEdit* nivellMaximEdit;
    QLabel* textLabel1;
    QSpinBox* spinRang;
    QLabel* textLabel1_2;
    QCheckBox* checkGeneraGradient;
    QPushButton* bColorInicial;
    QLabel* textLabel2;
    QPushButton* bColorFinal;
    QPushButton* bAjuda;
    QPushButton* bAccepta;
    QPushButton* bCancela;

    void setNivells( const Nivells &nv );
    Nivells getNivells();
        
protected:
    QVBoxLayout* configCorbesDialegLayout;
    QGridLayout* groupBox1Layout;
    QSpacerItem* spacer3;
    QSpacerItem* spacer6_2;
    QSpacerItem* spacer9;
    QHBoxLayout* layout17;
    QVBoxLayout* layout16;
    QSpacerItem* spacer4;
    QVBoxLayout* layout21;
    QGridLayout* layout15;
    QSpacerItem* spacer7;
    QVBoxLayout* layout20;
    QGridLayout* layout19;
    QSpacerItem* spacer5;
    QHBoxLayout* layout19_2;
    QSpacerItem* spacer6;

protected slots:
    virtual void languageChange();

private slots:
    void generaNivells();
    void afegeixNivell();
    void eliminaNivell();
    void setColor( int, int );
    void canviaColorI();//QPushButton * );
    void canviaColorF();//QPushButton * );
};

#endif // CONFIGCORBESDIALEG_H
