#include "configdialeg.h"
#include <qvariant.h>
#include <qpushbutton.h>
#include <qtabwidget.h>
#include <qwidget.h>
#include <qgroupbox.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qbuttongroup.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qcolordialog.h>
#include <qmessagebox.h>

/***************************************************************************************************/
/*   ConfigDialeg::ConfigDialeg( QWidget* parent, const char* name, bool modal, WFlags fl )        */
/*    : QDialog( parent, name, modal, fl )                                                         */
/*Constructor de la classe, el qual crea la finestra desplegable amb els diferents botons i opcions*/
/***************************************************************************************************/

ConfigDialeg::ConfigDialeg( QWidget* parent, const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "ConfigDialeg" );
    setSizeGripEnabled( TRUE );
    ConfigDialegLayout = new QVBoxLayout( this, 11, 6, "ConfigDialegLayout"); 

    tabWidget2 = new QTabWidget( this, "tabWidget2" );

    tab = new QWidget( tabWidget2, "tab" );
    tabLayout = new QVBoxLayout( tab, 11, 6, "tabLayout"); 

    groupBox1 = new QGroupBox( tab, "groupBox1" );
    groupBox1->setColumnLayout(0, Qt::Vertical );
    groupBox1->layout()->setSpacing( 6 );
    groupBox1->layout()->setMargin( 11 );
    groupBox1Layout = new QHBoxLayout( groupBox1->layout() );
    groupBox1Layout->setAlignment( Qt::AlignTop );

    layout20 = new QVBoxLayout( 0, 0, 6, "layout20"); 

    textLabel2 = new QLabel( groupBox1, "textLabel2" );
    layout20->addWidget( textLabel2 );

    textLabel3 = new QLabel( groupBox1, "textLabel3" );
    layout20->addWidget( textLabel3 );

    textLabel4 = new QLabel( groupBox1, "textLabel4" );
    layout20->addWidget( textLabel4 );
    groupBox1Layout->addLayout( layout20 );

    layout16 = new QVBoxLayout( 0, 0, 6, "layout16"); 

    xminEdit = new QLineEdit( groupBox1, "xminEdit" );
    layout16->addWidget( xminEdit );

    yminEdit = new QLineEdit( groupBox1, "yminEdit" );
    layout16->addWidget( yminEdit );

    zminEdit = new QLineEdit( groupBox1, "zminEdit" );
    layout16->addWidget( zminEdit );
    groupBox1Layout->addLayout( layout16 );
    spacer12 = new QSpacerItem( 16, 80, QSizePolicy::Expanding, QSizePolicy::Minimum );
    groupBox1Layout->addItem( spacer12 );

    layout18 = new QVBoxLayout( 0, 0, 6, "layout18"); 

    textLabel1_2 = new QLabel( groupBox1, "textLabel1_2" );
    layout18->addWidget( textLabel1_2 );

    textLabel2_2 = new QLabel( groupBox1, "textLabel2_2" );
    layout18->addWidget( textLabel2_2 );

    textLabel3_2 = new QLabel( groupBox1, "textLabel3_2" );
    layout18->addWidget( textLabel3_2 );
    groupBox1Layout->addLayout( layout18 );

    layout17 = new QVBoxLayout( 0, 0, 6, "layout17"); 

    xmaxEdit = new QLineEdit( groupBox1, "xmaxEdit" );
    layout17->addWidget( xmaxEdit );

    ymaxEdit = new QLineEdit( groupBox1, "ymaxEdit" );
    layout17->addWidget( ymaxEdit );

    zmaxEdit = new QLineEdit( groupBox1, "zmaxEdit" );
    layout17->addWidget( zmaxEdit );
    groupBox1Layout->addLayout( layout17 );
    tabLayout->addWidget( groupBox1 );
    spacer3 = new QSpacerItem( 460, 140, QSizePolicy::Minimum, QSizePolicy::Expanding );
    tabLayout->addItem( spacer3 );
    tabWidget2->insertTab( tab, QString::fromLatin1("") );

    tab_2 = new QWidget( tabWidget2, "tab_2" );
    tabLayout_2 = new QVBoxLayout( tab_2, 11, 6, "tabLayout_2"); 

    grupColors = new QButtonGroup( tab_2, "grupColors" );
    grupColors->setColumnLayout(0, Qt::Vertical );
    grupColors->layout()->setSpacing( 6 );
    grupColors->layout()->setMargin( 11 );
    grupColorsLayout = new QHBoxLayout( grupColors->layout() );
    grupColorsLayout->setAlignment( Qt::AlignTop );

    layout18_2 = new QVBoxLayout( 0, 0, 6, "layout18_2"); 

    textLabel5_2 = new QLabel( grupColors, "textLabel5_2" );
    layout18_2->addWidget( textLabel5_2 );

    textLabel6 = new QLabel( grupColors, "textLabel6" );
    layout18_2->addWidget( textLabel6 );

    textLabel9 = new QLabel( grupColors, "textLabel9" );
    layout18_2->addWidget( textLabel9 );

    textLabel1 = new QLabel( grupColors, "textLabel1" );
    layout18_2->addWidget( textLabel1 );
    grupColorsLayout->addLayout( layout18_2 );

    layout17_2 = new QVBoxLayout( 0, 0, 6, "layout17_2"); 

    botoColorFons2d = new QPushButton( grupColors, "botoColorFons2d" );
    botoColorFons2d->setPaletteBackgroundColor( QColor( 0, 0, 0 ) );
    layout17_2->addWidget( botoColorFons2d );

    botoColorLinies2d = new QPushButton( grupColors, "botoColorLinies2d" );
    botoColorLinies2d->setPaletteBackgroundColor( QColor( 0, 0, 255 ) );
    layout17_2->addWidget( botoColorLinies2d );

    botoColorPunts2d = new QPushButton( grupColors, "botoColorPunts2d" );
    botoColorPunts2d->setPaletteBackgroundColor( QColor( 0, 255, 0 ) );
    layout17_2->addWidget( botoColorPunts2d );

    botoColorSelect = new QPushButton( grupColors, "botoColorSelect" );
    botoColorSelect->setPaletteBackgroundColor( QColor( 255, 0, 0 ) );
    layout17_2->addWidget( botoColorSelect );
    grupColorsLayout->addLayout( layout17_2 );
    spacer14 = new QSpacerItem( 308, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    grupColorsLayout->addItem( spacer14 );
    tabLayout_2->addWidget( grupColors );
    spacer16 = new QSpacerItem( 470, 50, QSizePolicy::Minimum, QSizePolicy::Expanding );
    tabLayout_2->addItem( spacer16 );
    tabWidget2->insertTab( tab_2, QString::fromLatin1("") );
    ConfigDialegLayout->addWidget( tabWidget2 );


    
    ///////////// NOU
    
    tab_4 = new QWidget( tabWidget2, "tab_4" );
    tabLayout_4 = new QVBoxLayout( tab_4, 11, 6, "tabLayout"); 

    groupBox4 = new QGroupBox( tab_4, "groupBox4" );
    groupBox4->setColumnLayout(0, Qt::Vertical );
    groupBox4->layout()->setSpacing( 6 );
    groupBox4->layout()->setMargin( 11 );
    groupBox4Layout = new QHBoxLayout( groupBox4->layout() );
    groupBox4Layout->setAlignment( Qt::AlignTop );

    layout4_1= new QVBoxLayout( 0, 0, 6, "layout4_1"); 

    textLabel4_1 = new QLabel( groupBox4, "textLabel4_1" );
    layout4_1->addWidget( textLabel4_1 );

    textLabel4_2 = new QLabel( groupBox4, "textLabel4_2" );
    layout4_1->addWidget( textLabel4_2 );

    groupBox4Layout->addLayout( layout4_1 );

    layout4_2 = new QVBoxLayout( 0, 0, 6, "layout4_2"); 

    filaEdit = new QLineEdit( groupBox4, "filaEdit" );
    layout4_2->addWidget( filaEdit );

    colEdit = new QLineEdit( groupBox4, "colEdit" );
    layout4_2->addWidget( colEdit );
    
    groupBox4Layout->addLayout( layout4_2 );
    tabLayout_4->addWidget( groupBox4 );
    spacer4_1 = new QSpacerItem( 460, 140, QSizePolicy::Minimum, QSizePolicy::Expanding );
    tabLayout_4->addItem( spacer4_1);
    tabWidget2->insertTab( tab_4, QString::fromLatin1("") );

    
        tab_3 = new QWidget( tabWidget2, "tab_3" );
    tabLayout_3 = new QVBoxLayout( tab_3, 11, 6, "tabLayout"); 

    groupBox2 = new QGroupBox( tab_3, "groupBox2" );
    groupBox2->setColumnLayout(0, Qt::Vertical );
    groupBox2->layout()->setSpacing( 6 );
    groupBox2->layout()->setMargin( 11 );
    groupBox2Layout = new QHBoxLayout( groupBox2->layout() );
    groupBox2Layout->setAlignment( Qt::AlignTop );

    layout30 = new QVBoxLayout( 0, 0, 6, "layout30"); 

    textLabel32 = new QLabel( groupBox2, "textLabel32" );
    layout30->addWidget( textLabel32 );

    textLabel33 = new QLabel( groupBox2, "textLabel33" );
    layout30->addWidget( textLabel33 );

    groupBox2Layout->addLayout( layout30 );

    layout40 = new QVBoxLayout( 0, 0, 6, "layout40"); 

    lmxEdit = new QLineEdit( groupBox2, "lmxEdit" );
    layout40->addWidget( lmxEdit );

    lmyEdit = new QLineEdit( groupBox2, "lmyEdit" );
    layout40->addWidget( lmyEdit );
    
    groupBox2Layout->addLayout( layout40 );
    tabLayout_3->addWidget( groupBox2 );
    spacer13 = new QSpacerItem( 460, 140, QSizePolicy::Minimum, QSizePolicy::Expanding );
    tabLayout_3->addItem( spacer13 );
    tabWidget2->insertTab( tab_3, QString::fromLatin1("") );
    
    Layout1 = new QHBoxLayout( 0, 0, 6, "Layout1"); 

    botoHelp = new QPushButton( this, "botoHelp" );
    botoHelp->setAutoDefault( TRUE );
    Layout1->addWidget( botoHelp );
    Horizontal_Spacing2 = new QSpacerItem( 20, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    Layout1->addItem( Horizontal_Spacing2 );

    botoOk = new QPushButton( this, "botoOk" );
    botoOk->setAutoDefault( TRUE );
    botoOk->setDefault( TRUE );
    Layout1->addWidget( botoOk );

    botoCancel = new QPushButton( this, "botoCancel" );
    botoCancel->setAutoDefault( TRUE );
    Layout1->addWidget( botoCancel );
    ConfigDialegLayout->addLayout( Layout1 );
    languageChange();
    resize( QSize(552, 401).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( botoCancel, SIGNAL( clicked() ), this, SLOT( reject() ) );
    connect( botoOk, SIGNAL( clicked() ), this, SLOT( comprovarInfo() ) );
    connect( grupColors, SIGNAL( clicked(int) ), this, SLOT( triaColors(int) ) );

    // buddies
    textLabel2->setBuddy( xminEdit );
    textLabel3->setBuddy( yminEdit );
    textLabel4->setBuddy( zminEdit );
    textLabel1_2->setBuddy( xmaxEdit );
    textLabel2_2->setBuddy( ymaxEdit );
    textLabel3_2->setBuddy( zmaxEdit );
    textLabel5_2->setBuddy( botoColorFons2d );
    textLabel6->setBuddy( botoColorLinies2d );
    textLabel9->setBuddy( botoColorPunts2d );
    textLabel32->setBuddy( lmxEdit );
    textLabel33->setBuddy( lmyEdit ); 
    textLabel4_1->setBuddy(filaEdit);
    textLabel4_2->setBuddy(colEdit);
}

/*********************************************************************************/
/*   ConfigDialeg::~ConfigDialeg()                                               */
/*Destructor de la classe que no necesita esborrar res ja que no hi ha cap punter*/
/*********************************************************************************/

ConfigDialeg::~ConfigDialeg() {}

/*****************************************************/
/*   void ConfigDialeg::languageChange()             */
/*Metode que permet modificar el llenguatge utilitzat*/
/*****************************************************/

void ConfigDialeg::languageChange()
{
    setCaption( trUtf8( "\x43\x6f\x6e\x66\x69\x67\x75\x72\x61\x63\x69\xc3\xb3" ) );
    groupBox1->setTitle( tr( "Limits de l'espai" ) );
    textLabel2->setText( trUtf8( "\x43\x6f\x6f\x72\x64\x65\x6e\x61\x64\x61\x20\x26\x58\x20\x4d\xc3\xad\x6e\x69\x6d\x61\x3a" ) );
    textLabel3->setText( trUtf8( "\x43\x6f\x6f\x72\x26\x64\x65\x6e\x61\x64\x61\x20\x59\x20\x4d\xc3\xad\x6e\x69\x6d\x61\x3a" ) );
    textLabel4->setText( trUtf8( "\x43\x6f\x6f\x72\x64\x65\x6e\x61\x64\x61\x20\x26\x5a\x20\x4d\xc3\xad\x6e\x69\x6d\x61\x3a" ) );
    xminEdit->setText( tr( "0.0" ) );
    yminEdit->setText( tr( "0.0" ) );
    zminEdit->setText( tr( "0.0" ) );
    textLabel1_2->setText( trUtf8( "\x43\x6f\x6f\x72\x64\x65\x26\x6e\x61\x64\x61\x20\x58\x20\x4d\xc3\xa0\x78\x69\x6d\x61\x3a" ) );
    textLabel2_2->setText( trUtf8( "\x43\x6f\x6f\x72\x64\x65\x6e\x61\x64\x61\x20\x59\x20\x4d\x26\xc3\xa0\x78\x69\x6d\x61\x3a" ) );
    textLabel3_2->setText( trUtf8( "\x43\x6f\x6f\x72\x64\x65\x6e\x61\x64\x61\x20\x5a\x20\x4d\xc3\xa0\x78\x26\x69\x6d\x61\x3a" ) );
    xmaxEdit->setText( tr( "20.0" ) );
    ymaxEdit->setText( tr( "20.0" ) );
    zmaxEdit->setText( tr( "20.0" ) );
//     tabWidget2->changeTab( tab, tr( "Dimensions de l'espai" ) );
    tabWidget2->changeTab( tab, tr( "Espai" ) );
    
    grupColors->setTitle( tr( "Colors Visor 2D" ) );
    textLabel5_2->setText( tr( "Color &de Fons:" ) );
    textLabel6->setText( tr( "Color L&inies:" ) );
    textLabel9->setText( tr( "Color P&unts:" ) );
    textLabel1->setText( trUtf8( "\x43\x6f\x6c\x6f\x72\x20\x64\x65\x20\x53\x65\x6c\x65\x63\x63\x69\xc3\xb3\x3a" ) );
    botoColorFons2d->setText( QString::null );
    botoColorFons2d->setAccel( QKeySequence( QString::null ) );
    botoColorLinies2d->setText( QString::null );
    botoColorLinies2d->setAccel( QKeySequence( QString::null ) );
    botoColorPunts2d->setText( QString::null );
    botoColorPunts2d->setAccel( QKeySequence( QString::null ) );
    botoColorSelect->setText( QString::null );
//     tabWidget2->changeTab( tab_2, tr( "Colors de l'editor" ) );
    tabWidget2->changeTab( tab_2, tr( "Colors" ) );

     groupBox4->setTitle( tr( "Dimensions de la graella on es guarda la informacio" ) );
    textLabel4_1->setText( tr( "Files:" ) );
    textLabel4_2->setText( tr( "Columnes:" ) );
    filaEdit->setText( tr( "500" ) );
    colEdit->setText( tr( "500" ) );
    tabWidget2->changeTab( tab_4, tr( "Graella" ) );
        
    groupBox2->setTitle( tr( "Discretitzacio per mida de segments" ) );
    textLabel32->setText( tr( "Longitud maxima del segment de visio:" ) );
    textLabel33->setText( tr( "Longitud maxima del segment del terreny:" ) );
    lmxEdit->setText( tr( "15.0" ) );
    lmyEdit->setText( tr( "20.0" ) );
    tabWidget2->changeTab( tab_3, tr( "Discretitzacio" ) );
    
   
        
    
    botoHelp->setText( tr( "A&juda" ) );
    botoHelp->setAccel( QKeySequence( tr( "Alt+J" ) ) );
    botoOk->setText( tr( "&Accepta" ) );
    botoOk->setAccel( QKeySequence( tr( "Alt+A" ) ) );
    botoCancel->setText( trUtf8( "\x26\x43\x61\x6e\x63\x65\x6c\xc2\xb7\x6c\x61" ) );
    botoCancel->setAccel( QKeySequence( tr( "Alt+C" ) ) );
}

/**************************************************************************************************/
/*   ConfigInfo ConfigDialeg::dades()                                                             */
/*Metode que retorna les dades introduides per l'usuari en forma d'estructura del tipus ConfigInfo*/
/**************************************************************************************************/

ConfigInfo ConfigDialeg::dades()
{    
    return conf;
}

/***********************************************************************************/
/*   void ConfigDialeg::triaColors( int id )                                       */
/*Metode que desplega el menu de colors pq l'usuari trii el que vulgui per cada cas*/
/***********************************************************************************/

void ConfigDialeg::triaColors( int id )
{
    QButton* boto = grupColors->find( id );
    qWarning("%d", id);
    QColor color = QColorDialog::getColor( boto->paletteBackgroundColor(), this, "Tria_Color" );
    if ( color.isValid() ) 
    {       
       boto->setPaletteBackgroundColor( color );
    }
}

/*****************************************************************/
/*   void ConfigDialeg::setDades( ConfigInfo &ci)                */
/*Assignacio dels valors introduits dins de l'estructura de dades*/
/*****************************************************************/

void ConfigDialeg::setDades( ConfigInfo &ci)
{
    botoColorFons2d->setPaletteBackgroundColor( ci.cfons2d );
    botoColorLinies2d->setPaletteBackgroundColor( ci.clinies2d );
    botoColorPunts2d->setPaletteBackgroundColor( ci.cpunts2d );
    botoColorSelect->setPaletteBackgroundColor( ci.cseleccio );
 
    xminEdit->setText( QString("%1").arg(ci.xmin) );
    yminEdit->setText( QString("%1").arg(ci.ymin) );
    zminEdit->setText( QString("%1").arg(ci.zmin) );
    xmaxEdit->setText( QString("%1").arg(ci.xmax) );
    ymaxEdit->setText( QString("%1").arg(ci.ymax) );
    zmaxEdit->setText( QString("%1").arg(ci.zmax) );
    
    lmxEdit->setText( QString("%1").arg(ci.lmx) );
    lmyEdit->setText( QString("%1").arg(ci.lmy) );

    filaEdit->setText( QString("%1").arg(ci.files) );
    colEdit->setText( QString("%1").arg(ci.columnes) );
    
    
    conf = ci;
}

/***************************************************/
/*   void ConfigDialeg::comprovarInfo()            */
/*Metode que comprova el valor de les dades de conf*/
/***************************************************/

void ConfigDialeg::comprovarInfo()
{
    double valor;
    bool ok;

    conf.cfons2d = botoColorFons2d->paletteBackgroundColor();
    conf.clinies2d = botoColorLinies2d->paletteBackgroundColor();
    conf.cpunts2d = botoColorPunts2d->paletteBackgroundColor();
    conf.cseleccio = botoColorSelect->paletteBackgroundColor();
 
    valor = xminEdit->text().toDouble(&ok);
    if ( ok )
    {
       conf.xmin = valor;
    }
    valor = yminEdit->text().toDouble(&ok);
    if ( ok )
    {
       conf.ymin = valor;
    }
    valor = zminEdit->text().toDouble(&ok);
    if ( ok )
    {
       conf.zmin = valor;
    }
    valor = xmaxEdit->text().toDouble(&ok);
    if ( ok )
    {
       conf.xmax = valor;
    }
    valor = ymaxEdit->text().toDouble(&ok);
    if ( ok )
    {
       conf.ymax = valor;
    }
    valor = zmaxEdit->text().toDouble(&ok);
    if ( ok )
    {
       conf.zmax = valor;
    }
    valor = lmxEdit->text().toDouble(&ok);
    if ( ok )
    {
       conf.lmx = valor;
    }
    valor = lmyEdit->text().toDouble(&ok);
    if ( ok )
    {
       conf.lmy = valor;
    }
    valor = filaEdit->text().toInt(&ok);
    if ( ok )
    {
       conf.files = valor;
    }
    valor = colEdit->text().toInt(&ok);
    if ( ok )
    {
       conf.columnes = valor;
    }
    if( mesPetit( conf.xmin, conf.xmax) && mesPetit( conf.ymin, conf.ymax) && !mesGran( conf.zmin, conf.zmax ) )
    {
      accept();
    }  
    else if( conf.lmx>0. && conf.lmy>0.)
    {
      accept();
    }
    else if(conf.files>0&&conf.columnes>0)
    	accept();
    else
    {
       QMessageBox::warning(this, tr("Modelatge de terrenys"),
                            tr("Limits de l'espai incorrectes"),
			    tr("Accepta"), QString::null, QString::null, 0, -1);   
    }
}
