#include "configvisordialeg.h"

#include <qvariant.h>
#include <qpushbutton.h>
#include <qtabwidget.h>
#include <qwidget.h>
#include <qbuttongroup.h>
#include <qlabel.h>
#include <qgroupbox.h>
#include <qslider.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>

#include "qcolordialog.h"
#include "qmessagebox.h"

/********************************************************************************************************/
/*   ConfigVisorDialeg::ConfigVisorDialeg( QWidget* parent, const char* name, bool modal, WFlags fl )   */
/*    : QDialog( parent, name, modal, fl )                                                              */
/*Constructor de la classe, el qual crea la finestra desplegable amb els diferents botons i opcions     */
/********************************************************************************************************/

ConfigVisorDialeg::ConfigVisorDialeg( QWidget* parent, const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "ConfigVisorDialeg" );
    setSizeGripEnabled( TRUE );
    ConfigVisorDialegLayout = new QVBoxLayout( this, 11, 6, "ConfigVisorDialegLayout"); 

    tabWidget2 = new QTabWidget( this, "tabWidget2" );

    tab = new QWidget( tabWidget2, "tab" );
    tabLayout = new QVBoxLayout( tab, 11, 6, "tabLayout"); 

    grupColors = new QButtonGroup( tab, "grupColors" );
    grupColors->setColumnLayout(0, Qt::Vertical );
    grupColors->layout()->setSpacing( 6 );
    grupColors->layout()->setMargin( 11 );
    grupColorsLayout = new QHBoxLayout( grupColors->layout() );
    grupColorsLayout->setAlignment( Qt::AlignTop );

    layout6 = new QVBoxLayout( 0, 0, 6, "layout6"); 

    textLabel2 = new QLabel( grupColors, "textLabel2" );
    layout6->addWidget( textLabel2 );

    textLabel3 = new QLabel( grupColors, "textLabel3" );
    layout6->addWidget( textLabel3 );

    textLabel4 = new QLabel( grupColors, "textLabel4" );
    layout6->addWidget( textLabel4 );
    grupColorsLayout->addLayout( layout6 );

    layout5 = new QVBoxLayout( 0, 0, 6, "layout5"); 

    botoFons = new QPushButton( grupColors, "botoFons" );
    botoFons->setPaletteBackgroundColor( QColor( 0, 0, 0 ) );
    layout5->addWidget( botoFons );

    botoModel = new QPushButton( grupColors, "botoModel" );
    botoModel->setPaletteBackgroundColor( QColor( 170, 85, 0 ) );
    layout5->addWidget( botoModel );

    botoQuadre = new QPushButton( grupColors, "botoQuadre" );
    botoQuadre->setPaletteBackgroundColor( QColor( 255, 255, 255 ) );
    layout5->addWidget( botoQuadre );
    grupColorsLayout->addLayout( layout5 );
    spacer2 = new QSpacerItem( 190, 71, QSizePolicy::Expanding, QSizePolicy::Minimum );
    grupColorsLayout->addItem( spacer2 );
    tabLayout->addWidget( grupColors );

    colorsEixos = new QButtonGroup( tab, "colorsEixos" );
    colorsEixos->setColumnLayout(0, Qt::Vertical );
    colorsEixos->layout()->setSpacing( 6 );
    colorsEixos->layout()->setMargin( 11 );
    colorsEixosLayout = new QHBoxLayout( colorsEixos->layout() );
    colorsEixosLayout->setAlignment( Qt::AlignTop );

    layout8 = new QVBoxLayout( 0, 0, 6, "layout8"); 

    textLabel5 = new QLabel( colorsEixos, "textLabel5" );
    layout8->addWidget( textLabel5 );

    textLabel6 = new QLabel( colorsEixos, "textLabel6" );
    layout8->addWidget( textLabel6 );

    textLabel7 = new QLabel( colorsEixos, "textLabel7" );
    layout8->addWidget( textLabel7 );
    colorsEixosLayout->addLayout( layout8 );

    layout7 = new QVBoxLayout( 0, 0, 6, "layout7"); 

    botoEixX = new QPushButton( colorsEixos, "bEixX" );
    botoEixX->setPaletteBackgroundColor( QColor( 255, 0, 0 ) );
    layout7->addWidget( botoEixX );

    botoEixY = new QPushButton( colorsEixos, "bEixY" );
    botoEixY->setPaletteBackgroundColor( QColor( 0, 255, 0 ) );
    layout7->addWidget( botoEixY );

    botoEixZ = new QPushButton( colorsEixos, "bEixZ" );
    botoEixZ->setPaletteBackgroundColor( QColor( 0, 0, 255 ) );
    layout7->addWidget( botoEixZ );
    colorsEixosLayout->addLayout( layout7 );
    spacer3 = new QSpacerItem( 190, 90, QSizePolicy::Expanding, QSizePolicy::Minimum );
    colorsEixosLayout->addItem( spacer3 );
    tabLayout->addWidget( colorsEixos );
    spacer7 = new QSpacerItem( 370, 50, QSizePolicy::Minimum, QSizePolicy::Expanding );
    tabLayout->addItem( spacer7 );
    tabWidget2->insertTab( tab, QString::fromLatin1("") );

    tab_2 = new QWidget( tabWidget2, "tab_2" );
    tabLayout_2 = new QVBoxLayout( tab_2, 11, 6, "tabLayout_2"); 

    groupBox8 = new QGroupBox( tab_2, "groupBox8" );
    groupBox8->setColumnLayout(0, Qt::Vertical );
    groupBox8->layout()->setSpacing( 6 );
    groupBox8->layout()->setMargin( 11 );
    groupBox8Layout = new QGridLayout( groupBox8->layout() );
    groupBox8Layout->setAlignment( Qt::AlignTop );
    spacer16_2 = new QSpacerItem( 210, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    groupBox8Layout->addItem( spacer16_2, 1, 1 );

    textLabel5_3 = new QLabel( groupBox8, "textLabel5_3" );

    groupBox8Layout->addWidget( textLabel5_3, 1, 2 );

    resolucioSlider = new QSlider( groupBox8, "resolucioSlider" );
    resolucioSlider->setMinValue( 1 );
    resolucioSlider->setMaxValue( 10 );
    resolucioSlider->setPageStep( 1 );
    resolucioSlider->setOrientation( QSlider::Horizontal );
    resolucioSlider->setTickmarks( QSlider::Below );
    resolucioSlider->setTickInterval( 1 );

    groupBox8Layout->addMultiCellWidget( resolucioSlider, 0, 0, 0, 2 );

    textLabel4_2 = new QLabel( groupBox8, "textLabel4_2" );

    groupBox8Layout->addWidget( textLabel4_2, 1, 0 );
    tabLayout_2->addWidget( groupBox8 );
    spacer8 = new QSpacerItem( 350, 190, QSizePolicy::Minimum, QSizePolicy::Expanding );
    tabLayout_2->addItem( spacer8 );
    tabWidget2->insertTab( tab_2, QString::fromLatin1("") );
    ConfigVisorDialegLayout->addWidget( tabWidget2 );

    Layout1 = new QHBoxLayout( 0, 0, 6, "Layout1"); 

    buttonHelp = new QPushButton( this, "buttonHelp" );
    buttonHelp->setAutoDefault( TRUE );
    Layout1->addWidget( buttonHelp );
    Horizontal_Spacing2 = new QSpacerItem( 422, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    Layout1->addItem( Horizontal_Spacing2 );

    buttonOk = new QPushButton( this, "buttonOk" );
    buttonOk->setAutoDefault( TRUE );
    buttonOk->setDefault( TRUE );
    Layout1->addWidget( buttonOk );

    buttonCancel = new QPushButton( this, "buttonCancel" );
    buttonCancel->setAutoDefault( TRUE );
    Layout1->addWidget( buttonCancel );
    ConfigVisorDialegLayout->addLayout( Layout1 );
    languageChange();
    resize( QSize(462, 430).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( buttonOk, SIGNAL( clicked() ), this, SLOT( accept() ) );
    connect( buttonCancel, SIGNAL( clicked() ), this, SLOT( reject() ) );
    connect( grupColors, SIGNAL( clicked(int) ), this, SLOT( triaColor(int) ) );
    connect( colorsEixos, SIGNAL( clicked(int) ), this, SLOT( triaColorEix(int) ) );
}

/*********************************************************************************/
/*   ConfigVisorDialeg::~ConfigVisorDialeg()                                     */
/*Destructor de la classe que no necesita esborrar res ja que no hi ha cap punter*/
/*********************************************************************************/

ConfigVisorDialeg::~ConfigVisorDialeg() {}

/*****************************************************/
/*   void ConfigVisorDialeg::languageChange()        */
/*Metode que permet modificar el llenguatge utilitzat*/
/*****************************************************/

void ConfigVisorDialeg::languageChange()
{
    setCaption( trUtf8( "\x43\x6f\x6e\x66\x69\x67\x75\x72\x61\x63\x69\xc3\xb3\x20\x64\x65\x6c\x20\x76\x69\x73\x6f\x72" ) );
    grupColors->setTitle( tr( "Color dels elements visualitzats" ) );
    textLabel2->setText( tr( "Color de fons:" ) );
    textLabel3->setText( tr( "Color del model:" ) );
    textLabel4->setText( tr( "Color del quadre:" ) );
    botoFons->setText( QString::null );
    botoFons->setAccel( QKeySequence( QString::null ) );
    botoModel->setText( QString::null );
    botoModel->setAccel( QKeySequence( QString::null ) );
    botoQuadre->setText( QString::null );
    botoQuadre->setAccel( QKeySequence( QString::null ) );
    colorsEixos->setTitle( tr( "Color dels eixos de coordenades" ) );
    textLabel5->setText( tr( "Color Eix X:" ) );
    textLabel6->setText( tr( "Color Eix Y:" ) );
    textLabel7->setText( tr( "Color Eix Z:" ) );
    botoEixX->setText( QString::null );
    botoEixX->setAccel( QKeySequence( QString::null ) );
    botoEixY->setText( QString::null );
    botoEixY->setAccel( QKeySequence( QString::null ) );
    botoEixZ->setText( QString::null );
    botoEixZ->setAccel( QKeySequence( QString::null ) );
    tabWidget2->changeTab( tab, tr( "Colors" ) );
    groupBox8->setTitle( trUtf8( "\x52\x65\x73\x6f\x6c\x75\x63\x69\xc3\xb3\x20\x64\x65\x6c\x20\x6d\x6f\x64\x65\x6c\x20\x33\x44" ) );
    textLabel5_3->setText( trUtf8( "\x4d\xc3\xa0\x78\x69\x6d\x61" ) );
    textLabel4_2->setText( trUtf8( "\x4d\xc3\xad\x6e\x69\x6d\x61" ) );
    tabWidget2->changeTab( tab_2, trUtf8( "\x52\x65\x73\x6f\x6c\x75\x63\x69\x26\xc3\xb3" ) );
    buttonHelp->setText( tr( "A&juda" ) );
    buttonHelp->setAccel( QKeySequence( tr( "Alt+J" ) ) );
    buttonOk->setText( tr( "Accep&ta" ) );
    buttonOk->setAccel( QKeySequence( tr( "Alt+T" ) ) );
    buttonCancel->setText( trUtf8( "\x26\x43\x61\x6e\x63\x65\x6c\xc2\xb7\x6c\x61" ) );
    buttonCancel->setAccel( QKeySequence( tr( "Alt+C" ) ) );
}

/**********************************************************/
/*   void ConfigVisorDialeg::triaColor( int id )          */
/*Metode que permet escollir el color desitjat en cada cas*/
/**********************************************************/

void ConfigVisorDialeg::triaColor( int id )
{
    QButton* boto = grupColors->find( id );
    //qWarning("%d", id);
    QColor color = QColorDialog::getColor( boto->paletteBackgroundColor(), this, "Tria_Color" );
    if ( color.isValid() ) 
    {       
       boto->setPaletteBackgroundColor( color );
    }
/*
    else
    {
       QMessageBox::warning(this, tr("Modelatge de terrenys"),
                            tr("Color no valid. Trii un altre."),
			    tr("Accepta"), QString::null, QString::null, 0, -1);
    }  
*/
}

/***************************************************************/
/*   void ConfigVisorDialeg::triaColorEix( int id )            */
/*Metode que permet escollir el color dels eixos de coordenades*/
/***************************************************************/

void ConfigVisorDialeg::triaColorEix( int id )
{
    QButton* boto = colorsEixos->find( id );
    qWarning("%d", id);
    QColor color = QColorDialog::getColor( boto->paletteBackgroundColor(), this, "Tria_Color" );
    if ( color.isValid() ) 
    {       
       boto->setPaletteBackgroundColor( color );
    }
/*
    else
    {
       QMessageBox::warning(this, tr("Modelatge de terrenys"),
                            tr("Color no valid. Trii un altre."),
			    tr("Accepta"), QString::null, QString::null, 0, -1);
    }
*/    
}

/*******************************************************************************/
/*   ConfigVisorInfo ConfigVisorDialeg::dades()                                */
/*Metode que assigna sobre l'estructura conf el valor de les dades i la retorna*/
/*******************************************************************************/

ConfigVisorInfo ConfigVisorDialeg::dades()
{
    conf.cfons3d = botoFons->paletteBackgroundColor();
    conf.cmodel3d = botoModel->paletteBackgroundColor();
    conf.cquadre3d = botoQuadre->paletteBackgroundColor();
    conf.ceix_x = botoEixX->paletteBackgroundColor();
    conf.ceix_y = botoEixY->paletteBackgroundColor();
    conf.ceix_z = botoEixZ->paletteBackgroundColor();
    conf.resolucio = resolucioSlider->value();
    
    return conf;
}

/****************************************************************/
/*   void ConfigVisorDialeg::setDades( ConfigVisorInfo &cvi)    */
/*Metode que assigna el valor de les dades per poder mostrar-les*/
/****************************************************************/

void ConfigVisorDialeg::setDades( ConfigVisorInfo &cvi)
{
    botoFons->setPaletteBackgroundColor( cvi.cfons3d );
    botoModel->setPaletteBackgroundColor( cvi.cmodel3d );
    botoQuadre->setPaletteBackgroundColor( cvi.cquadre3d );
    botoEixX->setPaletteBackgroundColor( cvi.ceix_x );
    botoEixY->setPaletteBackgroundColor( cvi.ceix_y );
    botoEixZ->setPaletteBackgroundColor( cvi.ceix_z );

    resolucioSlider->setValue( cvi.resolucio );

    conf = cvi;
}

/************************************************************/
/*   void ConfigVisorDialeg::setResolucioMax( int nouvalor )*/
/*Metode que indica el valor de resolucio maxima possible   */
/************************************************************/

void ConfigVisorDialeg::setResolucioMax( int nouvalor )
{
   resolucioSlider->setMaxValue( nouvalor );
}

