#ifndef CONFIGDIALEGVISOR_H
#define CONFIGDIALEGVISOR_H

#include <qvariant.h>
#include <qdialog.h>

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QSpacerItem;
class QTabWidget;
class QWidget;
class QButtonGroup;
class QLabel;
class QPushButton;
class QGroupBox;
class QSlider;

struct ConfigVisorInfo {
    QColor cfons3d;
    QColor cmodel3d;
    QColor cquadre3d;
    QColor ceix_x;
    QColor ceix_y;
    QColor ceix_z;
    int resolucio;   

    ConfigVisorInfo()
    {
       cfons3d = Qt::white;
       cmodel3d.setRgb(170, 85, 0);
       cquadre3d = Qt::black;    
       ceix_x = Qt::red;
       ceix_y = Qt::green;
       ceix_z = Qt::blue;
       resolucio = 1;    
    }

    ConfigVisorInfo( const ConfigVisorInfo &p )
    {
       cfons3d = p.cfons3d;
       cmodel3d = p.cmodel3d;
       cquadre3d = p.cquadre3d;
       ceix_x = p.ceix_x;
       ceix_y = p.ceix_y;
       ceix_z = p.ceix_z;
       resolucio = p.resolucio;
    }

    ConfigVisorInfo &operator=( const ConfigVisorInfo &p )
    {
       cfons3d = p.cfons3d;
       cmodel3d = p.cmodel3d;
       cquadre3d = p.cquadre3d;
       ceix_x = p.ceix_x;
       ceix_y = p.ceix_y;
       ceix_z = p.ceix_z;
       resolucio = p.resolucio;
       
       return (*this);
    }
};

/************************************************************************************************************************/
/*                                  class ConfigVisorDialeg : public QDialog                                            */
/*Classe que descriu una finestra de dialeg que permet modificar la configuracio de la finestra 2.5D (color i resolucio)*/
/************************************************************************************************************************/

class ConfigVisorDialeg : public QDialog
{
    Q_OBJECT

public:
    ConfigVisorDialeg( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~ConfigVisorDialeg();

    QTabWidget* tabWidget2;
    QWidget* tab;
    QButtonGroup* grupColors;
    QLabel* textLabel2;
    QLabel* textLabel3;
    QLabel* textLabel4;
    QPushButton* botoFons;
    QPushButton* botoModel;
    QPushButton* botoQuadre;
    QButtonGroup* colorsEixos;
    QLabel* textLabel5;
    QLabel* textLabel6;
    QLabel* textLabel7;
    QPushButton* botoEixX;
    QPushButton* botoEixY;
    QPushButton* botoEixZ;
    QWidget* tab_2;
    QGroupBox* groupBox8;
    QLabel* textLabel5_3;
    QSlider* resolucioSlider;
    QLabel* textLabel4_2;
    QPushButton* buttonHelp;
    QPushButton* buttonOk;
    QPushButton* buttonCancel;

    ConfigVisorInfo dades();
    void setDades( ConfigVisorInfo & );
    void setResolucioMax( int );

protected:
    QVBoxLayout* ConfigVisorDialegLayout;
    QVBoxLayout* tabLayout;
    QSpacerItem* spacer7;
    QHBoxLayout* grupColorsLayout;
    QSpacerItem* spacer2;
    QVBoxLayout* layout6;
    QVBoxLayout* layout5;
    QHBoxLayout* colorsEixosLayout;
    QSpacerItem* spacer3;
    QVBoxLayout* layout8;
    QVBoxLayout* layout7;
    QVBoxLayout* tabLayout_2;
    QSpacerItem* spacer8;
    QGridLayout* groupBox8Layout;
    QSpacerItem* spacer16_2;
    QHBoxLayout* Layout1;
    QSpacerItem* Horizontal_Spacing2;

protected slots:
    virtual void languageChange();

private slots:
    void triaColor(int);
    void triaColorEix(int);

private:
    ConfigVisorInfo conf;
};

#endif // CONFIGDIALEGVISOR_H
