#include "event.h"

/********************************************************************************************/
/*   Event::Event()                                                                         */
/*Constructor que inicialitza cadascuna de les variables globals de l'objecte event creat   */
/********************************************************************************************/

Event::Event()
{ 
	tipus_event = INDEFINIT;
	pes=0.0;
}

/*********************************************************/
/*   Event::Event(int t)                                 */
/*Constructor que inicialitza el tipus de l'event creat  */
/*********************************************************/

Event::Event(int t)
{ 
	tipus_event = t;
	pes=0.0;
}


/***************************************************/
/*   Event::Event(const Event &ev)                 */
/*Constructor de copia                             */  
/***************************************************/

Event::Event(const Event &ev)
{
	*this=ev;
}

/*****************************************************************/
/*   Event::swap(Event &evx, Event &evy) */
/*Metode swap                                                   */  
/****************************************************************/

void Event::swap(Event &evx, Event &evy)
{
Event tmp;
tmp=evx;
evx=evy;
evy=tmp;
}

/*********************************/
/*   Event::~Event()         */
/*Destructor de la classe Event*/
/*********************************/

Event::~Event() {}



/*****************************************/
/*   int Event::tipusEvent() const       */
/*Mètode que retorna el tipus de l'event */
/*****************************************/

int Event::tipusEvent() const    
{ 
	return tipus_event;
}

/*****************************************/
/*   double Event::getpes() const        */
/*Mètode que retorna el pes de l'event   */
/*****************************************/

double Event::getpes() const    
{ 
	return pes;
}


/**************************************************/
/*   void Event::assignarTipusEvent(int t)        */
/*Mètode que permet modificar el tipus de l'event */
/**************************************************/

void Event::assignarTipusEvent(int t)
{ 
	tipus_event = t;
}

/**************************************************/
/*   void Event::setpes(double pes)               */
/*Mètode que permet modificar el pes de l'event   */
/**************************************************/

void Event::setpes(double pes)
{ 
	this->pes=pes;
}

//Redefinició d'operadors

/**************************************************************************************/
/*   bool Event::operator<(Event const &e)const                                      */
/*Mètode que ens ordena els events (Finestres i PseudoSources) segons l'atribut pes. */
/*************************************************************************************/

bool Event::operator<(Event const &e)const
{
	bool menor=false;
	if (this->getpes() < e.getpes())
	{
	menor=true;
	}
	return (menor);
}

/**************************************************************************************/
/*   bool Event::operator<(Event* const &e)const                                      */
/*Mètode que ens ordena els events (Finestres i PseudoSources) segons l'atribut pes. */
/*************************************************************************************/

bool Event::operator<(Event* const &e)const
{
	bool menor=false;
	if (this->getpes() < e->getpes())
	{
	menor=true;
	}
	return (menor);
}

/**************************************************************************************/
/*   bool Event::operator<(Event* const &e, Event* const &ev)const                   */
/*Mètode que ens ordena els events (Finestres i PseudoSources) segons l'atribut pes  */
/*************************************************************************************/

bool Event::ordena(Event* const &e, Event* const &ev)
{
bool menor=false;
	if (e->getpes()<ev->getpes())
	{
	menor=true;
	}
	else if (fabs(e->getpes()-ev->getpes())<TOLERANCE) 
	{
		if(e->tipusEvent()==0) //L'event és Finestra
		{
		menor=true;
		}
	}
	return (menor);
}

//Operador d'igualtat que miri el pes i el tipus
bool Event::operator==(Event e)
{
	bool iguals=false;
	if(this->tipusEvent()==e.tipusEvent() && this->pes==e.getpes())
	{
	iguals=true;
	}
	
	return (iguals);
}


