#ifndef _FITXER_RTERRENY_H_
#define _FITXER_RTERRENY_H_

#include "geometriabasica.h"
#include <qfile.h>
#include "terreny.h"

enum Missatges { ERROR_OBRIR  = -2,
                 ERROR_FORMAT = -1,
                 CORRECTE     =  0 
               };

typedef std::vector<Punt3d> VPunts;

struct InfoFitxer
{
  double xmin, ymin, zmin, xmax, ymax, zmax;
  VPunts punts;
};

/*********************************************************************************************************/
/*                                      class FitxerTerreny                                              */
/*Classe que gestiona el tractament amb els fitxers que contenen terrenys visualitzables en aquest editor*/
/*********************************************************************************************************/

class FitxerTerreny
{
public:
    FitxerTerreny();
    ~FitxerTerreny();

    int carrega( const QString&, Terreny* );
    int desa( const QString&, Terreny* );    

private:
     QFile f;
     InfoFitxer info;

     int carregaTin( const QString& );
     int desaTin( const QString&, Terreny* );
     int carregaT2d( const QString& );
     int desaT2d( const QString&, Terreny* );
     void inicialitza();
     int extreureCoordenades( QString, double &, double &, double & );
     void guardarDades( Terreny* );
     void treureFlag( QString& );
     int extreureNumero( const QString& );
};

#endif //_FITXER_RTERRENY_H_
