#include "infodialeg.h"

#include <qvariant.h>
#include <qlabel.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>

/****************************************************************************************/
/*   InfoDialeg::InfoDialeg( QWidget* parent, const char* name, bool modal, WFlags fl ) */
/*    : QDialog( parent, name, modal, fl )                                              */
/*Constructor de la classe, el qual crea la finestra amb les etiquetes que toca         */
/****************************************************************************************/

InfoDialeg::InfoDialeg( QWidget* parent, const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "InfoDialeg" );

    xLabel = new QLabel( this, "xLabel" );
    xLabel->setGeometry( QRect( 20, 20, 140, 16 ) );
    
    yLabel = new QLabel( this, "yLabel" );
    yLabel->setGeometry( QRect( 20, 50, 140, 16 ) );

    zLabel = new QLabel( this, "zLabel" );
    zLabel->setGeometry( QRect( 20, 80, 140, 20 ) );

    languageChange();
    resize( QSize(180, 120).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );
}

/*********************************************************************************/
/*   InfoDialeg::~InfoDialeg()                                                   */
/*Destructor de la classe que no necesita esborrar res ja que no hi ha cap punter*/
/*********************************************************************************/

InfoDialeg::~InfoDialeg() {}

/**********************************************************/
/*   void InfoDialeg::languageChange()                    */
/*Metode que descriu el text de cadascuna de les etiquetes*/
/**********************************************************/

void InfoDialeg::languageChange()
{
    setCaption( tr( "Dades Element" ) );
    xLabel->setText( tr( "Z:" ) );
    yLabel->setText( tr( "Y:" ) );
    zLabel->setText( tr( "X:" ) );
}

/******************************************************************/
/*   void InfoDialeg::modificaText( double a, double b, double c )*/
/*Metode que assigna el valor de cada coordenada per mostrar-les  */
/******************************************************************/

void InfoDialeg::modificaText( double a, double b, double c )
{
   xLabel->setText( QString("X: %1").arg(a) );
   yLabel->setText( QString("Y: %1").arg(b) );
   zLabel->setText( QString("Z: %1").arg(c) );
}
