#ifndef _POLIGON
#define _POLIGON

#include <iostream.h>
#include "punt.h"
#include <vector.h>
#include "vector3D.h"
#include "objecte.h"
#include "triangle.h"

#include "geometriabasica.h"

#define dot(u,v)   ((u).x() * (v).x() + (u).y() * (v).y())   // 2D dot product
#define perp(u,v)  ((u).x() * (v).y() - (u).y() * (v).x())   // 2D perp product

class Poligon_Convex;
class Triangle;

class Poligon : public Objecte
{
	protected:
		vector<Punt> punts; /*El vector de punts que defineixen la figura geomètrica*/
		int costats; /*El número de costats de l'objecte*/
		vector< Triangle > triangles_triangulacio;
		
		int tipus_poligon;
	public:
		Poligon(); /*Constructor per defecte que inicialitza tot a 0*/
		~Poligon();
		Poligon(vector<Punt> p, int cos); /*Constructor amb parametres que permet configurar cadascuna de les propietats del poligon irregular*/
		Poligon(pCara triangle);
		Poligon(Triangle3 triangle);

		Punt obtenirVertex(int posicio)const;
		vector<Punt> retorna_punts()const;
		int retorna_costats()const;
		
		bool interseccionaPoligonSegment2D(const Segment &s, bool extrems)const;
		
// 		bool entrada(Segment aresta, Punt punt, Poligon poligon, bool cas_infinit)const;

		/*Capçalera dels metodes necessaris per realitzar la triangulacio de poligons*/
		int orientacio()const;
		bool vertexConvex(Punt A, Punt B, Punt C, int orientacio);
		bool esquerra( const Punt &pA,const Punt &pB, const Punt & pC)const;
		bool interiorTriangle(const Punt &p, Punt triangle[3])const;
		bool pertany(const Punt &p, const vector<Punt> &llista) const;
		bool orella(const vector<Punt> &llistaConcaus, const vector<Punt> & llista, int posicio) const;
		
		void  triangulacio(); /*Metode de triangulacio que particiona el poligon en un conjunt de triangles.*/
		
		bool interseccioPoligonTriangle3D(const Triangle &cara)const;
		Segment seguent(const Segment &aresta, int &posicio)const;
		bool entrada(const Segment &aresta,const Punt &punt, const Poligon & poligon_visio, bool cas_infinit)const;
		bool intersecciona2D(const Segment &s, bool extrems) const;
		
		Triangle getTriangle()const;
		void escriure()const;
};

#endif
