#ifndef _POLIGON_CONVEX
#define _POLIGON_CONVEX

#include <iostream.h>
#include "punt.h"
#include <vector.h>
#include "vector3D.h"
#include "poligon.h"
#include "segment.h"

#include "geometriabasica.h"

inline float isLeft( Punt P0, Punt P1, Punt P2 )
{
    return (P1.x() - P0.x())*(P2.y() - P0.y()) - (P2.x() - P0.x())*(P1.y() - P0.y());
}

class Poligon_Convex : public Poligon
{
	private:
		Punt baricentre;
	public:
		Poligon_Convex(); /*Constructor per defecte que inicialitza tot a 0*/
		~Poligon_Convex();
		Poligon_Convex(vector<Punt> p, int cos); /*Constructor amb parametres que permet configurar cadascuna de les propietats del poligon irregular*/
		Poligon_Convex(vector<Punt> p);
		Poligon_Convex(pCara);
		Poligon_Convex(Triangle3 triangle);

		vector<Punt> getPunts()const;
		Punt calcula_baricentre()const; 
		bool punt_contingut2D(const Punt &,bool)const;
		
		vector<Punt> calcularConvexHull(vector<Punt> p);
		
		bool entrada(const Segment &aresta,const  Punt & punt,const  Poligon_Convex &quadrilater, bool cas_infinit)const;
		bool aresta_oposada_es_entrada(const pCara &tr, int vertex_oposat)const;
		bool intersecciona2D(const Segment &ss, bool extrems)const;
};

#endif
