#include "poligon_irregular.h"

/****************************************************/
/*   Poligon_Irregular::Poligon_Irregular()         */
/*Constructor per defecte que ho inicialitza tot a 0*/
/****************************************************/

Poligon_Irregular::Poligon_Irregular() 
{
	costats=0;
	tipus_poligon = POLIGON_IRREGULAR;
}

/*********************************************/
/*   Poligon_Irregular::~Poligon_Irregular() */
/*Destructor de la classe Poligon_Irregular  */
/*********************************************/

Poligon_Irregular::~Poligon_Irregular() {}

/******************************************************************************************/
/*   Poligon_Irregular::Poligon_Irregular(vector<Punt> p, int cos)                        */
/*Constructor amb parametres que permet configurar cadascuna de les propietats del poligon*/
/******************************************************************************************/

Poligon_Irregular::Poligon_Irregular(vector<Punt> p, int cos)  
{
	punts=p;
	costats=cos;
	tipus_poligon=POLIGON_IRREGULAR;
}

/*****************************************************************************/
/*   Punt Poligon_Irregular::puntMigInterior()                               */
/*El puntMigInterior el farem equivaldre amb el primer vertex que el defineix*/
/*****************************************************************************/

Punt Poligon_Irregular::puntMigInterior()
{
	return(punts[0]);
}

/**************************************************************************************************/
/*   double Poligon_Irregular::distancia(Punt p)                                                  */
/*Metode que retorna la distancia mes curta des del punt "p" passat per parametres fins al poligon*/
/**************************************************************************************************/

/*double Poligon_Irregular::distancia(Punt p) 
{
	Punt proper;
	Vector3D vector_proper;
	double modul_proper=0.0;

	proper=puntProper(p);
	

	vector_proper.modifica_coordenades(p.x()-proper.x(),p.y()-proper.y(),0.0);
	modul_proper=sqrt((vector_proper.x()*vector_proper.x())+(vector_proper.y()*vector_proper.y()));

	return(modul_proper);
}*/

/****************************************************************/
/*   Punt Poligon_Irregular::puntProper(Punt p)                 */
/*Metode que calcula el punt mes proper del poligon  al punt "p"*/
/****************************************************************/

/*Punt Poligon_Irregular::puntProper(Punt p) 
{
	Punt mes_proper,proper, seguent;
	Vector3D vector_proper;
	double modul_mes_proper=0.0, modul_proper=0.0;
	int primer=1;

	for(int i=0;i<costats;i++) 
	{
		if((i+1)==costats)
		{
			seguent=punts[0];
		}
		else
		{
			seguent=punts[i+1];
		}
		proper=p.calculaProperRecta(punts[i],seguent); 

		vector_proper.modifica_coordenades(p.x()-proper.x(),p.y()-proper.y(),0.0);
		modul_proper=sqrt((vector_proper.x()*vector_proper.x())+(vector_proper.y()*vector_proper.y()));

		if((modul_proper<modul_mes_proper)||(primer==1))
		{
			modul_mes_proper=modul_proper;
			mes_proper=proper;
			primer=0;
		}
	}

	return(mes_proper);
}*/

// /********************************************************************************************************/
// /*   int Poligon_Irregular::orientacio()                                                                */
// /*Metode que retorna la orientacio del poligon segons l'ordre en el qual l'usuari ha introduit els punts*/
// /********************************************************************************************************/
// 
// int Poligon_Irregular::orientacio() 
// {
// 	double coord1, coord2, coord3;
// 	double determinant=0;
// 	Punt p;
// 	int minim=0, anterior=0;
// 	Vector3D vector1, vector2;
// 	int orienta;
// 
// 	/*Primer cal trobar un vertex convex. Podrem agafar directament un vertex de coordenada minima o maxima, 
// 	tant de x com de y perque sempre sera convex*/
// 	for(int i=1;i<punts.size();i++)
// 	{
// 		if(punts[i].x()<punts[minim].x())
// 		{
// 			minim=i;
// 		}
// 	}
// 
// 	if(minim==0)
// 	{
// 		anterior=punts.size()-1;
// 	}
// 	else
// 	{
// 		anterior=minim-1;
// 	}
// 
// 	vector1.modifica_coordenades((punts[minim].x()-punts[anterior].x()), (punts[minim].y()-punts[anterior].y()), 0.0);
// 	vector2.modifica_coordenades((punts[(minim+1)%punts.size()].x()-punts[anterior].x()), (punts[(minim+1)%punts.size()].y()-punts[anterior].y()), 0.0);
// 
// 	determinant=(vector1.x()*vector2.y())-(vector1.y()*vector2.x());
// 	/*Segons el signe del determinant la orientacio sera positiva(1) o negativa(0)*/
// 	if(determinant>0)
// 	{
// 		orienta=1;
// 	}
// 	else
// 	{
// 		orienta=0;
// 	}
// 	return(orienta);
// }
// 
// /**********************************************************************************************/
// /*   bool Poligon_Irregular::vertexConvex(Punt A, Punt B, Punt C, int orientacio)             */
// /*A partir de tres punts i de la orientacio del poligon determinem si el punt B es o no convex*/
// /**********************************************************************************************/
// 
// bool Poligon_Irregular::vertexConvex(Punt A, Punt B, Punt C, int orientacio) 
// {
// 	Vector3D vector1, vector2;
// 	bool convex=false;
// 	double determinant=0;
// 
// 	vector1.modifica_coordenades((B.x()-A.x()), (B.y()-A.y()), 0.0);
// 	vector2.modifica_coordenades((C.x()-A.x()), (C.y()-A.y()), 0.0);
// 
// 	determinant=(vector1.x()*vector2.y())-(vector1.y()*vector2.x());
// 
// 	if(((determinant>0)&&(orientacio==1)) ||((determinant<0)&&(orientacio==0)))
// 	{
// 		convex=true;
// 	}
// 	return(convex);
// }
// 
// /****************************************************************************************/
// /*   bool Poligon_Irregular::esquerra(Punt pA, Punt pB, Punt pC)                        */
// /*Metode que informa si el punt pC es troba a l'esquerra del segment definit per pA i pB*/
// /****************************************************************************************/
// 
// bool Poligon_Irregular::esquerra(Punt pA, Punt pB, Punt pC) 
// {
// 	Vector3D vectAB, vectAC;
// 	bool esquerra=true;
// 
// 	vectAB.modifica_coordenades((pB.x()-pA.x()),(pB.y()-pA.y()),0.0);
// 	vectAC.modifica_coordenades((pC.x()-pA.x()),(pC.y()-pA.y()),0.0);
// 
// 	if(((vectAB.x()*vectAC.y())-(vectAC.x()*vectAB.y()))<=0)
// 	{
// 		esquerra=false;
// 	}
// 
// 	return(esquerra);
// }
// 
// /***********************************************************************************************************************/
// /*   bool Poligon_Irregular::interiorTriangle(Punt p, Punt triangle[3])                                                */
// /*A partir d'una terna de punts que defineixen un triangle determinem si el punt "p" es o no interior a aquest triangle*/
// /***********************************************************************************************************************/
// 
// bool Poligon_Irregular::interiorTriangle(Punt p, Punt triangle[3]) 
// {
// 	if(p==triangle[0] || p==triangle[1] || p==triangle[2]) /*En el cas que aquest punt "p" sigui algun dels extrems del 
// 	triangle no el considerarem com a interior*/
// 	{
// 		return(false);
// 	}
// 	else
// 	{
// 		return((esquerra(triangle[0], triangle[1], p) && esquerra(triangle[1], triangle[2], p) && esquerra(triangle[2], triangle[0], p))||
// 		(!esquerra(triangle[0], triangle[1], p) && !esquerra(triangle[1], triangle[2], p) && !esquerra(triangle[2], triangle[0], p)));
// 	}
// }
// 
// /**********************************************************************/
// /*   bool Poligon_Irregular::pertany(Punt p, vector<Punt> llista)     */
// /*Metode que indica si el punt "p" es troba dins de la llista indicada*/
// /**********************************************************************/
// 
// bool Poligon_Irregular::pertany(Punt p, vector<Punt> llista) 
// {
// 	bool trobat=false;
// 	int i=0;
// 
// 	while (i<llista.size() && !trobat)
// 	{
// 		if(llista[i]==p)
// 		{
// 			trobat=true;
// 		}
// 		i++;
// 	}
// 	return(trobat);
// }
// 
// /*****************************************************************************************************/
// /*   bool Poligon_Irregular::orella(vector<Punt> llistaConcaus, vector<Punt> llista, int posicio)    */
// /*Un triangle es orella quan no conte cap altre punt del poligon en el seu interiorEn aquest cas     */
// /*caldra comprovar si existeix un vertex concau a dins del triangle que te com a centre el vertex de */
// /*la posicio indicada. No sera orella en els casos seguents: 1.-Si el punt de la posicio de la llista*/
// /*es concau,2.- Si algun punt de la llista de concaus cau dins del triangle indicat                  */
// /*****************************************************************************************************/
// 
// bool Poligon_Irregular::orella(vector<Punt> llistaConcaus, vector<Punt> llista, int posicio) 
// {
// 	bool orella=true, trobat=false;
// 	Punt triangle[3];
// 	int i=0;
// 
// 	if(llistaConcaus.size()!=0)
// 	{
// 		if(pertany(llista[posicio], llistaConcaus))
// 		{
// 			orella=false;
// 		}
// 		else
// 		{
// 			while (i<llistaConcaus.size() && !trobat)
// 			{
// 				triangle[0]=llista[posicio-1];
// 				triangle[1]=llista[posicio];
// 				triangle[2]=llista[posicio+1];
// 				if(interiorTriangle(llistaConcaus[i], triangle))
// 				{
// 					trobat=true;
// 				}
// 				i++;
// 			}
// 			if(trobat)
// 			{
// 				orella=false;
// 			}
// 		}
// 	}
// 	return(orella);
// }
// 
// /*******************************************************************************/
// /*   vector< vector<Punt> >  Poligon_Irregular::triangulacio()                 */
// /*Aquest metode retorna per parametres els triangles en els quals s'ha dividit */
// /*el poligon despres de realitzar el proces de triangulacio                    */
// /*******************************************************************************/
// 
// vector< vector<Punt> >  Poligon_Irregular::triangulacio() 
// {
// 	int orienta; 
// 	vector<Punt> llistaConcaus, llista, aux_triangles;
// 	vector< vector<Punt> > triangles;
// 	int n=0, i=0, j=0, x=0;
// 	bool trobat=false;
// 	Punt actual, predecessor;
// 	
// 	/*Primerament cal calcular la orientacio del poligon*/
// 	orienta=orientacio();
// 
// 	for(i=0; i<punts.size(); i++)
// 	{
// 		if(!vertexConvex(punts[i], punts[(i+1)%punts.size()], punts[(i+2)%punts.size()], orienta)) /*En cada iteracio analitzarem al vertex i+1.
// 		Si aquest no es convex l'introduirem dins de la llista de concaus*/
// 		{
// 			llistaConcaus.push_back(punts[(i+1)%punts.size()]);
// 		}
// 	}
// 
// 	i=0;
// 	llista=punts;
// 	n=llista.size();
// 	x=i+2; /*Ens situem sobre el tercer element de la llista de punts que formen el triangle*/
// 
// 	while(n>3)
// 	{
// 		if(orella(llistaConcaus, llista, x-1))
// 		{
// 			/*S'afegeix a la llista el triangle format pels vertexs de les posicions x-2, x-1 i x*/
// 			aux_triangles.push_back(llista[x-2]);
// 			aux_triangles.push_back(llista[x-1]);
// 			aux_triangles.push_back(llista[x]);
// 			triangles.push_back(aux_triangles);
// 			aux_triangles.clear();
// 			
// 			n=n-1;
// 			/*Proces que ens permet eliminar de la llista de punts el que ja hem processat, es a dir, x-1*/
// 			actual=llista[x];
// 			predecessor=llista[x-2];
// 			for(j=x-1;j<llista.size();j++)
// 			{
// 				llista[j]=llista[j+1];
// 			}
// 			llista.pop_back();
// 			if(pertany(actual, llistaConcaus ) && vertexConvex(llista[x-2], llista[x-1], llista[x], orienta)) /*En el cas que abans, el punt 
// 			de la posicio x-1 fos concua cal controlar si actualment ho es o no*/
// 			{
// 				/*En el cas que ara no ho sigui cal que l'elimini de la llista de concaus*/
// 				j=0;
// 				while((j<llistaConcaus.size())&&(!trobat))
// 				{
// 					if(llistaConcaus[j]==actual)
// 					{
// 						trobat=true;
// 						for(int k=j;k<llistaConcaus.size();k++)
// 						{
// 							llistaConcaus[k]=llistaConcaus[k+1];
// 						}
// 						llistaConcaus.pop_back();
// 					}
// 					j++;
// 				}
// 				trobat=false;
// 			}
// 
// 			/*A continuacio s'inspecciona el seguent, es a dir, el predecessor, x*/
// 			if((x>2) && pertany(predecessor, llistaConcaus) && vertexConvex(llista[x-3], llista[x-2], llista[x-1], orienta))
// 			{
// 				j=0;
// 				while((j<llistaConcaus.size())&&(!trobat))
// 				{
// 					if(llistaConcaus[j]==predecessor)
// 					{
// 						trobat=true;
// 						for(int k=j;k<llistaConcaus.size();k++)
// 						{
// 							llistaConcaus[k]=llistaConcaus[k+1];
// 						}
// 						llistaConcaus.pop_back();
// 					}
// 					j++;
// 				}
// 				trobat=false;
// 			}
// 			if(x>2)
// 			{
// 				x--;
// 			}
// 		}
// 		else
// 		{
// 			x++;
// 		}
// 	}
// 	/*Afegeixo l'ultim triangle a la llista de triangles que retornarem*/
// 	aux_triangles.push_back(llista[x-2]);
// 	aux_triangles.push_back(llista[x-1]);
// 	aux_triangles.push_back(llista[x]);
// 	triangles.push_back(aux_triangles);
// 	
// 	return(triangles);
// }

/***********************************************************************************/
/*   bool Poligon_Irregular::poligonCorrecte(Punt, Pla)                            */
/*Mètode que indica si el segment indicat es troba en el pla passat per paràmetres */
/***********************************************************************************/

/*bool Poligon_Irregular::poligonCorrecte(Delaunay, Punt, Pla)
{
	bool correcte = false;
	
	return correcte;
}*/

/**********************************************************************************************************************/
/*   bool Poligon_Irregular::interseccio(Punt primer, Punt segon, double radi)                                        */
/*Metode que determina l'existencia d'interseccio entre un cercle i el poligon anant del punt "primer" al punt "segon"*/
/**********************************************************************************************************************/

/*bool Poligon_Irregular::interseccio(Punt primer, Punt segon, double radi) 
{
	bool interseccio=false;
	int orienta, i=0, anterior;
	vector<Punt> rectes;

	orienta=orientacio();

	rectes=primer.rectesParaleles(primer, segon, radi); 
	
	while(i<costats && !interseccio)
	{
		if(orienta) 
		{
			interseccio=primer.interseccioSegments(punts[i], punts[(i+1)%costats], rectes[0], rectes[2]);
			if(!interseccio)
			{
				interseccio=primer.interseccioSegments(punts[i], punts[(i+1)%costats], rectes[1], rectes[3]);
			}
		}
		else
		{
			if((costats-i-2)!=-1)
			{
				anterior=(costats-i-2)%costats;
			}
			else
			{
				anterior=costats-1;
			}
			interseccio=primer.interseccioSegments(punts[costats-i-1], punts[anterior], rectes[0], rectes[2]);
			if(!interseccio)
			{
				interseccio=primer.interseccioSegments(punts[costats-i-1], punts[anterior], rectes[1], rectes[3]);
			}
		}
		i++;
	}

	return(interseccio);
}*/
