#ifndef PSEUDOSOURCE_H
#define PSEUDOSOURCE_H

#include <iostream.h>
#include "punt.h"
#include "objecte.h"
#include "event.h"
#include "geometriabasica.h"
#include <qcolor.h>
#include <math.h>
#include <vector>
#include "linia.h"
#include <list.h>

class Finestra;

/*********************************************************************************************************/
/*                                        class Pseudo-Source                                            */
/*   Classe Pseudo-Source que conté tots els mètodes necessaris per poder treballar amb pseudo-sources   */
/*********************************************************************************************************/

class PseudoSource : public Event
{
	private:
				
		double sigma; //Distancia a la source de veritat
		int index; //Index de la posicio del vector on hi ha el punt (VectorVisio de la classe Visio)
		pVertex vertex;
		pCara cara;
			
		//double pes; //Pes = sigma
					
	public:
		
		PseudoSource(); //Constructor per defecte que inicialitza els atributs a 0
		~PseudoSource(); //Destructor
		PseudoSource(double sigma_, int index_, pVertex vertex_, pCara cara_); //Constructor amb parametres	
	
		/*Metodes que retornen els atributs de finestra*/
		double getsigma() const;
		int getindex() const;
		pVertex getvertex() const;
		pCara getcara() const;
		//double getpes() const;
				
		/*Metodes que permeten modificar el valor dels atributs de forma individual o bé tots de cop*/
		void setsigma(double sigma_);
		void setindex(int index_);
		void setvertex(pVertex vertex_);
		void setcara(pCara cara_);
		//void setpes(double pes);
		void modifica_pseudosource(double sigma_, int index_, pVertex vertex_, pCara cara_);
		
		void pintarFinestres(Delaunay *dt);
		void pintarEvent();
		
  		// Redefinició d'operadors
		bool operator==(PseudoSource ps)const;
 		bool operator!=(PseudoSource ps)const;
		
		void escriure()const;
		list<Event*> propagar(Delaunay *dt);
		
} ;

#endif

