#include "qimagedialog.h"
#include <qimage.h>
#include <qstringlist.h>

/*********************************************************************************************************************/
/*   QImageDialog::QImageDialog( QWidget *parent, const char *name, bool modal) : QFileDialog( parent, name, modal ) */
/*Constructor de la classe, el qual crea la finestra de dialeg de tipus fitxer per guardar la imatge capturada       */
/*********************************************************************************************************************/

QImageDialog::QImageDialog( QWidget *parent, const char *name, bool modal) : QFileDialog( parent, name, modal )
{
      setMode( QFileDialog::AnyFile );

      QStringList fmt = QImage::outputFormatList();

      setFilters( fmt );
      setSelectedFilter ( 1 );
}

/*********************************************************************************/
/*   QImageDialog::~QImageDialog()                                               */
/*Destructor de la classe que no necesita esborrar res ja que no hi ha cap punter*/
/*********************************************************************************/

QImageDialog::~QImageDialog() { }

/*******************************************************/
/*   QString QImageDialog::getNom()                    */
/*Metode que permet obtenir el nom del fitxer introduit*/
/*******************************************************/

QString QImageDialog::getNom()
{
      if ( selectedFile() != QString::null )
      {
          return ( selectedFile() + "." + selectedFilter().lower() );
      }
      else 
      {
          return QString::null;
      }
}

/**********************************************************/
/*   QString QImageDialog::QImageDialog::getFormat()      */
/*Metode que permet obtenir el format del fitxer introduit*/
/**********************************************************/

QString QImageDialog::QImageDialog::getFormat()
{
     return selectedFilter();
}

