#ifndef _TRIANGLE
#define _TRIANGLE

#include <iostream.h>
#include <vector.h>
#include "punt.h"
#include <vector>
#include "vector3D.h"
#include "pla.h"
#include "regio.h"
#include "geometriabasica.h"
#include "math.h"

typedef std::vector<Punt3d>  VectorPunt3d;
typedef std::vector<int>  VectorInt;
typedef std::vector<double>  VectorDoubles;
typedef std::vector<Regio>  VectorRegions;
typedef std::vector<Hiperbola>  VectorHiperboles;

class Segment;
class Poligon_Convex;

class Triangle
{
	private:
		Triangle3 triangle;
	public:
		Triangle();
		~Triangle();
		Triangle(pCara);
		Triangle(Triangle3);
		Triangle(Punt, Punt, Punt);

		double xmin()const;
		double xmax()const;
		double ymin()const;
		double ymax()const;
		double zmin()const;
		double zmax()const;
		
		double temps_t_s,temps_t_t,temps_t_T;
		
		vector<Punt> vertex_ordenats_x()const;
		vector<Punt> vertex_ordenats_y()const;
		vector<Punt> vertex_ordenats_z()const;
		
		Triangle2 on_xy()const;
		Punt3d circumcenter()const;
		const Triangle3 & getTriangle_cgal()const;
		
		bool p_on_triangle(const Punt3d &p)const;
		bool dinsTriangle(const Punt3d & p, bool &alCostat, bool VertexT=true,bool CostatsT=true)const;
		bool dinsTriangle(const Punt3d & p, bool VertexT=true,bool CostatsT=true)const;
		bool dinsTriangle(const Punt3d & p,const Vector & u,const Vector & v,const Punt3d & origen,bool &alCostat,bool VertexT=true,bool CostatsT=true)const;
		
		bool tr_e_intersection(const Segment3D &e,VectorPunt3d &p)const;
		bool tr_e_intersection(const Segment3D &e)const;
		bool triangle_intersection_e_obert(const Segment3D &e, VectorPunt3d &p)const;
		bool tr_l_intersection(const Line &l,VectorPunt3d &p)const;
		
		bool tri_tri_intersection(const Triangle3 &tr_b)const;
		bool tri_tri_intersection(const Triangle3 &tr_b, VectorPunt3d &pt_inter)const;
		
		bool tr_intersection_T_edges(const Tetrahedron &Tvs, VectorPunt3d &p_trT)const;
		
		bool tri_plane_intersection(const Plane &pla,VectorPunt3d &p)const;
		bool tri_plane_intersection(const Plane &pla,VectorPunt3d (&p)[3])const;
		bool tri_plane_intersection(const Triangle3 &tr_a,const Plane &pla,int &j,VectorPunt3d &p)const;
		bool tr_intersects_T(const Tetrahedron &Tvs,bool cV=false)const;
		bool tr_intersects_T(const Tetrahedron &Tvs, VectorPunt3d &p)const;
		bool interseccio_tetraedre(vector<Pla> pla,bool cV) const;
		
		bool TriangleTapaSegmentVisio(const Segment &sv,VectorDoubles &vis)const;
		bool TriangleTapaPuntVisio(const Punt &pv)const;
		
		VectorHiperboles skewProjection(const Segment  &ss, const Segment  &sv, const Pla& pla_v,const Pla &pla_s,double ds, Punt2d  &skp, bool trobarSigne=false)const;
		VectorHiperboles skewProjection(const Segment  &ss,const Segment &sv,const Pla&pla_v, const Pla &pla_s, const double &valor_s, bool trobarSigne=false)const;
		
// 		VectorHiperboles skewProjection(const Segment &ss,const Segment &sv, bool trobarSigne=false)const;
// 		VectorHiperboles skewProjection(const Segment &ss,const Segment & sv, Punt2d &skp, bool trobarSigne=false)const;
		VectorHiperboles skewCasCoplanar(int i, const Segment  &ss, const Segment  &sv, const Pla &pla_v,  bool trobarSigne)const; //1 sola recta, 1! segment
// 		void obtenirRegions(const Segment &ss, const Segment &sv, VectorRegions &regions, bool trobarSigne) const;
		void obtenirRegions(const Segment & ss,const Segment &sv, const Pla &pla_v, const Pla &pla_s, const double &ds,VectorRegions &regions, bool trobarSigne,const bool &per_discretitzar) const;
		 void obtenirRegionsDiscretitzar(const Segment & ss,const Segment &sv, const Pla &pla_v, const Pla &pla_s, const double &valor_s,VectorRegions &regions)const;
		Punt puntEntrePlans(const Segment &ss, const Segment&sv)const;
		
		bool interseccio(const Triangle &tr,  Segment &s, int &tri_i, bool extrems1=true, bool extrems2=true) const;
		bool interseccio(const Triangle &tr,  Segment &s, bool extrems1=true, bool extrems2=true) const;
		bool interseccio(const Triangle &tr,  bool extrems1=true, bool extrems2=true) const;
		
		bool interseccio(const Segment &s, bool extremsS=true, bool VertexT=true,bool CostatsT=true) const; 
		bool interseccio(const Segment &s, bool &alCostat, bool extremsS=true, bool VertexT=true,bool CostatsT=true) const; 
		bool interseccio(const Segment &s, Punt3d &p, bool &seg, bool extremsS=true, bool VertexT=true,bool CostatsT=true) const;
		bool interseccio(const Segment &s, Punt3d &p, bool &seg, bool &alCostat, bool extremsS=true, bool VertexT=true,bool CostatsT=true) const; 
		
		bool intersecciolinia(const Segment &s, double &r, bool VertexT=true,bool CostatsT=true) const; 
		bool intersecciolinia(const Segment &s, Punt3d &p, double &r, bool &seg, bool &alCostat, bool VertexT=true,bool CostatsT=true) const; 
		
		vector<Triangle> retallar(const Tetrahedron &Tvs,const Segment &ss,const Segment &sv,const Pla &pla_v, const Pla &pla_s, const double &valor_s,bool cV)const;
		void arreglar(Triangle &t,const Pla &plav, const Punt &Bari, int &iv,const Segment & segmentplav, Segment *snouv,bool &costatBariv,const  Tetrahedron &Tvs,bool cV)const;
		
		void escriure()const;
		bool conteVertex(const Segment &s)const;		
		void modificacio_segment(Segment &s)const;
		
		bool interseccioParalelapipede(const vector<Pla>&plans)const;
		bool interseccioParalelapipede(double,double,double,double,double,double);
		bool interseccioPiramide(vector<Pla> pla) const ;
		
		vector<Pla> plansDelimitadors(const Segment &sv)const;
		vector<Pla> plansDelimitadors(const Punt &pv)const;
		vector<Pla> plansDelimitadors(vector<Punt3d> p,bool)const;
		
		void temps()const;
		void tempsG(double)const;
};

double min( double a, double b);
double max( double a, double b);
#endif
