/************
 * Fitxer: valordialeg.cpp
 * PTFC: Disseny d'una eina de modelat de terrenys i c�cul de corbes de nivell
 * Autor: Sergio Jaraiz Ojea
 * @ Gener 2006 
 * 
 */  

#include "valordialeg.h"

#include <qvariant.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qvalidator.h>

/*
 *  Constructs a ValorDialeg as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
ValorDialeg::ValorDialeg( QWidget* parent, const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "ValorDialeg" );
    ValorDialegLayout = new QVBoxLayout( this, 11, 6, "ValorDialegLayout"); 

    layout8 = new QHBoxLayout( 0, 0, 6, "layout8"); 

    textLabel1 = new QLabel( this, "textLabel1" );
    layout8->addWidget( textLabel1 );

    lineEdit1 = new QLineEdit( this, "lineEdit1" );
    lineEdit1->setAlignment( int( QLineEdit::AlignRight ) );
    lineEdit1->setValidator( new QDoubleValidator( 0.0, 10000.0, 6, lineEdit1 ) );
    layout8->addWidget( lineEdit1 );
    ValorDialegLayout->addLayout( layout8 );

    layout9 = new QHBoxLayout( 0, 0, 6, "layout9"); 

    pushButton8 = new QPushButton( this, "pushButton8" );
    layout9->addWidget( pushButton8 );

    pushButton9 = new QPushButton( this, "pushButton9" );
    layout9->addWidget( pushButton9 );
    ValorDialegLayout->addLayout( layout9 );
    languageChange();
    resize( QSize(246, 78).expandedTo(minimumSizeHint()) );
    clearWState( WState_Polished );

    // signals and slots connections
    connect( pushButton8, SIGNAL( clicked() ), this, SLOT( accept() ) );
    connect( pushButton9, SIGNAL( clicked() ), this, SLOT( reject() ) );
    connect( lineEdit1, SIGNAL( textChanged( const QString & ) ), SLOT( canviaValor( const QString & ) ) );

    // buddies
    textLabel1->setBuddy( lineEdit1 );
}

/*
 *  Destroys the object and frees any allocated resources
 */
ValorDialeg::~ValorDialeg()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void ValorDialeg::languageChange()
{
    setCaption( tr( "Tria valor de Nivell" ) );
    textLabel1->setText( tr( "Valor &del Nivell:" ) );
    lineEdit1->setText( tr( "0" ) );
    pushButton8->setText( tr( "Accepta" ) );
    pushButton8->setAccel( QKeySequence( QString::null ) );
    pushButton9->setText( trUtf8( "\x26\x43\x61\x6e\x63\x65\x6c\xc2\xb7\x6c\x61" ) );
    pushButton9->setAccel( QKeySequence( tr( "Alt+C" ) ) );
}

void ValorDialeg::canviaValor( const QString & str )
{
   int p = 0;
   QString s = str;
   if ( lineEdit1->validator()->validate( s, p ) == QValidator::Acceptable ) _valor = str;
}

QString ValorDialeg::valor()
{
   return _valor;
}
