#include "visio.h"

/***************************************************************************************************************/
/*   Visio::Visio()                                                                                              */
/*Constructor que segueix el patró que proporciona el Singleton fent que tan sols es crei un objecte tipus Visio*/
/***************************************************************************************************************/

Visio * Visio::instancia=0;

Visio::Visio() 
{
	objectes.clear();
	objectes_distancies.clear();
	objectes_cami_minim.clear();
	
	calculat = false;
	recalculat = false;
}

/******************************************************************************************************/
/*   Visio::Visio(VectorVisio d)                                                                      */
/*Constructor que inicialitza cadascuna de les variables, a més d'assignar el vector d'objectes passat*/
/******************************************************************************************************/

Visio::Visio( VectorVisio v ) 
{
	calculat = false;
	recalculat = false;
	objectes=v;
	objectes_distancies=v;
	objectes_cami_minim=v;
}


/*********************************************************/
/*   Visio * Visio:: instance()                            */
/*Mètode que permet seguir la implementacio del Singleton*/
/*********************************************************/

Visio * Visio::instance()
{
	if(instancia==0)
	{
		instancia = new Visio;
	}
	return instancia;
}

/*******************************/
/*   Visio::~Visio()           */
/*Destructor de la classe Visio*/
/*******************************/

Visio::~Visio() 
{
	cout<<"D visio"<<endl;
/*	if(textura)
		delete textura;*/
// 		delete [] textura;
	if(instancia)
	{
		cout<<"D visioddddd"<<endl;
		instancia=NULL;
		if(objectes.size()>0)
		{
			cout<<"objectes.size()="<<objectes.size()<<endl;
			for(unsigned int i=objectes.size()-1;i>0;i--)
				delete objectes[i-1];
			objectes.clear();
		}
		if(objectes_distancies.size()>0)
		{
			cout<<"objectes_distancies.size()="<<objectes_distancies.size()<<endl;
			for(unsigned int i=objectes_distancies.size()-1;i>0;i--)
				delete objectes_distancies[i-1];
			objectes_distancies.clear();
		}
		if(objectes_cami_minim.size()>0)
		{
			cout<<"objectes_cami_minim.size()="<<objectes_cami_minim.size()<<endl;
			for(unsigned int i=objectes_cami_minim.size()-1;i>0;i--)
				delete objectes_cami_minim[i-1];
			objectes_cami_minim.clear();
		}
		
	}
	else
		cout<<"NO "<<endl;
	
	cout<<"Df visio"<<endl;
}

/*************************************************/
/*   VectorVisio Visio::getObjecteVisio()        */
/*Mètode que retorna el vector d'objecte de visio*/
/*************************************************/

VectorVisio Visio::getObjecteVisio()
{
	return objectes;
}


/*************************************************/
/*   VectorVisio Visio::getObjecteDistancies()   */
/*Mètode que retorna el vector d'objectes de distàncies*/
/*************************************************/

VectorVisio Visio::getObjecteDistancies()
{
	return objectes_distancies;
}


/*************************************************/
/*   VectorVisio Visio::getObjecteCamiMinim()   */
/*Mètode que retorna el vector d'objectes de cami minim*/
/*************************************************/

VectorVisio Visio::getObjecteCamiMinim()
{
	return objectes_cami_minim;
}

/************************************************************/
/*   void Visio::setObjecteVisio( VectorVisio )             */
/*Mètode que permet modificar el vector d'objectes de visio */
/************************************************************/

void Visio::setDelaunay( VectorVisio v)
{
	objectes = v;
}


/************************************************************/
/*   void Visio::setObjecteDistancies(VectorDistancies)     */
/*Mètode que permet modificar el vector d'objectes de visio */
/************************************************************/

void Visio::setDelaunayDistancies(VectorDistancies v)
{
	objectes_distancies = v;
}


/************************************************************/
/*   void Visio::setObjecteDistancies(VectorDistancies)     */
/*Mètode que permet modificar el vector d'objectes de visio */
/************************************************************/

void Visio::setDelaunayPuntsCamiMinim(VectorPuntsCamiMinim v)
{
	objectes_cami_minim = v;
}


/************************************************************/
/*   void Visio::setMidesGraella(int amplada_ ,int alcada_)           */
/*Mètode que permet modificar els mides de la textura/graella inicial */
/************************************************************/
void Visio::setMidesGraella(int amplada_ ,int alcada_)
{
	amplada=amplada_;
	alcada=alcada_;
}

/***********************************************************/
/*   void Visio::clear()                                   */
/*Mètode que permet esborrar el vector d'objectes de visio */
/***********************************************************/

void Visio::clear()
{
	cout<<"CLEAR visio"<<endl;
	if(objectes.size()>0)
	{
		for(unsigned int i=objectes.size();i>0;i--)
			delete objectes[i-1];
		objectes.clear();
	}
	segments_visibles.clear( );
	segments_analitzats.clear( );
	calculat = false;
	textura.clear();
	cout<<"CLEARf visio"<<endl;
}

/******************************************************************************/
/*   void Visio::inserirObjecte(Objecte obj)                                  */
/*Mètode que permet inserir un nou objecte dins del vector d'objectes de visio*/
/******************************************************************************/

void Visio::inserirObjecte(Objecte * obj)
{
	objectes.push_back(obj);
}

/******************************************************************************/
/*   void Visio::inserirObjecteDistancies(Objecte obj)                             */
/*Mètode que permet inserir un nou objecte dins del vector d'objectes de distàncies*/
/******************************************************************************/

void Visio::inserirObjecteDistancies(Objecte * obj)
{
	objectes_distancies.push_back(obj);
}


/******************************************************************************/
/*   void Visio::inserirObjecteCamiMinim(Objecte obj)                             */
/*Mètode que permet inserir un nou objecte dins del vector d'objectes de camí mínim *a/
/******************************************************************************/

void Visio::inserirObjecteCamiMinim(Objecte * obj)
{
	objectes_cami_minim.push_back(obj);
}

/*************************************************************************/
/*   void Visio::eliminarObjecte(int posicio)                            */
/*Mètode que permet eliminar un objecte del vector donada la seva posicio*/
/*************************************************************************/

void Visio::eliminarObjecte(int posicio)
{
	VectorVisio::iterator it;
	
	for(it = objectes.begin(); it != objectes.end(); ++it)
	{
		if ((*it) == objectes[posicio - 1]) 
		{
			objectes.erase( it ); /*Instrucció que permet eliminar l'objecte escollit*/
			break;
		}
	}
}


/*************************************************************************/
/*   void Visio::eliminarObjecteDistancies(int posicio)                  */
/*Mètode que permet eliminar un objecte del vector donada la seva posicio*/
/*************************************************************************/

void Visio::eliminarObjecteDistancies(int posicio)
{
	VectorDistancies::iterator it;
	
	for(it = objectes_distancies.begin(); it != objectes_distancies.end(); ++it)
	{
		if ((*it) == objectes_distancies[posicio - 1]) 
		{
			objectes_distancies.erase( it ); /*Instrucció que permet eliminar l'objecte escollit*/
			break;
		}
	}
}


/*************************************************************************/
/*   void Visio::eliminarObjecteDistancies(int posicio)                  */
/*Mètode que permet eliminar un objecte del vector donada la seva posicio*/
/*************************************************************************/

void Visio::eliminarObjecteCamiMinim(int posicio)
{
	VectorPuntsCamiMinim::iterator it;
	
	for(it = objectes_cami_minim.begin(); it != objectes_cami_minim.end(); ++it)
	{
		if ((*it) == objectes_cami_minim[posicio - 1]) 
		{
			objectes_cami_minim.erase( it ); /*Instrucció que permet eliminar l'objecte escollit*/
			break;
		}
	}
}


/*************************************************************************/
/*   Objecte Visio::obtenirObjecte(int posicio)                          */
/*Mètode que permet obtenir un dels objectes del vector donada la posicio*/
/*************************************************************************/

Objecte * Visio::obtenirObjecte(int posicio)
{
	return objectes[posicio-1];
} 


/*************************************************************************/
/*   Objecte Visio::obtenirObjecteDistancies(int posicio)                */
/*Mètode que permet obtenir un dels objectes del vector donada la posicio*/
/*************************************************************************/

Objecte * Visio::obtenirObjecteDistancies(int posicio)
{
	return objectes_distancies[posicio-1];
} 


/*************************************************************************/
/*   Objecte Visio::obtenirObjecteCamiMinim(int posicio)                */
/*Mètode que permet obtenir un dels objectes del vector donada la posicio*/
/*************************************************************************/

Objecte * Visio::obtenirObjecteCamiMinim(int posicio)
{
	return objectes_cami_minim[posicio-1];
} 

/************************************************************/
/*   int Visio::numeroObjectes()                            */
/*Mètode que retorna el numero d'objectes de visio existents*/
/************************************************************/

int Visio::numeroObjectes()
{
	return objectes.size();
}

/************************************************************/
/*   int Visio::numeroObjectesDistancies()                  */
/*Mètode que retorna el numero d'objectes de distàncies existents*/
/************************************************************/

int Visio::numeroObjectesDistancies()
{
	return objectes_distancies.size();
}


/************************************************************/
/*   int Visio::numeroObjectesCamiMinim()                  */
/*Mètode que retorna el numero d'objectes de distàncies existents*/
/************************************************************/

int Visio::numeroObjectesCamiMinim()
{
	return objectes_cami_minim.size();
}



/************************************************************************/
/*   vector< pair<double,double> > Visio::getSegmentsVisibles()         */
/*Mètode que retorna els segments visibles d'un segment des del de visio*/
/************************************************************************/

vector< vector< pair<Punt, Punt> > > Visio::getSegmentsVisibles()
{
	return segments_visibles;
}

/********************************************************************************/
/*   void Visio::setSegmentsVisibles(vector< pair<double,double> >)             */
/*Mètode que permet assignar els segments visibles d'un segment des del de visio*/
/********************************************************************************/

void Visio::setSegmentsVisibles( vector< pair<Punt, Punt> >  seg)
{
	segments_visibles.push_back( seg );
}

/***************************************************/
/*   int Visio::numeroSegmentsVisibles()           */
/*Mètode que retorna el numero de segments visibles*/
/***************************************************/

int Visio::numeroSegmentsVisibles()
{
	return segments_visibles.size();
}

/************************************************************************/
/*   vector< pair<double,double> > Visio::getSegmentsVisibles()         */
/*Mètode que retorna els segments visibles d'un segment des del de visio*/
/************************************************************************/

vector< Segment > Visio::getSegmentsAnalitzats()
{
	return segments_analitzats;
}

/********************************************************************************/
/*   void Visio::setSegmentsVisibles(vector< pair<double,double> >)             */
/*Mètode que permet assignar els segments visibles d'un segment des del de visio*/
/********************************************************************************/

void Visio::setSegmentsAnalitzats(vector< Segment > seg)
{
	segments_analitzats = seg;
}

/***************************************************/
/*   int Visio::numeroSegmentsVisibles()           */
/*Mètode que retorna el numero de segments visibles*/
/***************************************************/

int Visio::numeroSegmentsAnalitzats()
{
	return segments_analitzats.size();
}

/***********************************************************************************/
/*   void Visio::resetSegmentsVisibles()                                           */
/*Mètode que permet eliminar els segments de visibilitat i tornar a començar de nou*/
/***********************************************************************************/

void Visio::resetSegmentsVisibles()
{
	segments_visibles.clear( );
	segments_analitzats.clear( );
}

void Visio::inicialitza_mides(int amplada_, int alcada_, double x_min, double x_max, double y_min, double y_max)
{
	amplada=amplada_;
	alcada=alcada_;
	xmin = x_min;
	xmax = x_max;
	ymin = y_min;
	ymax = y_max;
}

void Visio::get_mides(int &amplada_, int &alcada_, double &x_min, double &x_max, double &y_min, double &y_max)
{
	amplada_=amplada;
	alcada_= alcada;
	x_min= xmin;
	x_max=xmax;
	y_min=ymin;
	y_max=ymax ;
}

void Visio::inicialitza_buffer_textura()
{
	textura=vector<GLubyte>(amplada*alcada*4,0);
	
// 	for(int j=0;j<(amplada*alcada*4);j++)
// 	{
// 		textura[j]=0;
// 	}
	calculat = true;
	recalculat=true;
	cout<<"Mida textura: "<<(amplada*alcada*4)<<endl;
}

void Visio::emplena_textura_segment_terreny(vector<pair<Punt, Punt> > parts_visibles, const int &segment_visio)
{
	int j, i0, i1, aux;
	int float_corresponent;
	int n=textura.size();
	
	if(parts_visibles.size()>0)
	{
		float_corresponent =  (segment_visio/8);
		j = round(((parts_visibles[0].first.x()-(double)xmin)*(double)amplada)/((double)xmax-(double)xmin));
// 		if(j==0) j=1;
		for(int i=0;i<parts_visibles.size();i++)
		{
			if(parts_visibles[i].first.y()<parts_visibles[i].second.y())
			{
				i0 = floor(((parts_visibles[i].first.y()-ymin)/(ymax-ymin))*alcada);
				i1 = ceil(((parts_visibles[i].second.y()-ymin)/(ymax-ymin))*alcada);
			}
			else
			{
				i0 = floor(((parts_visibles[i].second.y()-ymin)/(ymax-ymin))*alcada);
				i1 = ceil(((parts_visibles[i].first.y()-ymin)/(ymax-ymin))*alcada);
			}
			if(i0>i1)
			{
				aux = i0;
				i0 = i1;
				i1 = aux;
			}
// 			i0=max(i0-1,0);
// 			i1++;
// 			for(int k=(((((j-1)*alcada)+i0)*4)+float_corresponent);k<(((((j-1)*alcada)+i1)*4)+float_corresponent);k=k+4)
			for(int k=((((j*alcada)+i0)*4)+float_corresponent);k<((((j*alcada)+i1+1)*4)+float_corresponent)&&k<n;k=k+4)
				textura[k]=textura[k]|(1<<(segment_visio%8));
		}
	}
}

GLubyte * Visio::obtenir_Textura()
{
	if(!calculat)
	{
		return NULL;
	} 
	else
	{
		recalculat=false;
		return &textura[0];
	}
}

bool Visio::calculada_textura()
{
	return calculat;
}

bool Visio::textura_Modificada()
{
	return recalculat;
}

void Visio::emplena_textura_segments_terreny(const Triangle &cara,const vector<int> &conta,float parts_primer_previes,const vector<vector< pair<double, double> > > &segments_visibles,const int &r)
{
cout<<"UTILITZANT FUNCIO ANULADA"<<endl;
	/*k=0;
	int csv=0;
	double cs=(double) parts_primer_previes;
	while(k<(conta.size()-1)/2.&&csv<segments_vis.size())
	{
		while(cs<conta[2*k+1])
		 {
			for(t=0;t<segments_vis[csv].size();t++)
			{
				if(!variant)
				{
					parell_punts.first = Punt(trian[conta[2*k]].e_t((cs+segments_vis[csv][t].first)/(double)conta[(2*k)+1]));
					parell_punts.second = Punt(trian[conta[2*k]].e_t((cs+segments_vis[csv][t].second)/(double)conta[(2*k)+1]));
					segments_visibles.push_back(parell_punts);
				}
				else
				{
					parell_punts.first = Punt(trian[conta[2*k]].e_t(1-(cs+1.-segments_vis[csv][t].first)/(double)conta[(2*k)+1]));
					parell_punts.second=Punt(trian[conta[2*k]].e_t(1-(cs+1.-segments_vis[csv][t].second)/(double)conta[(2*k)+1]));
					segments_visibles.push_back(parell_punts);
				}
			}
// 			Per cada segment del terreny guardem en el vector 
			visio->emplena_textura_segment_terreny(segments_visibles, r); // tenim coordenades món.
			segments_visibles.clear();
			cs++;
			csv++;
		}
		k++;
		cs=0.;
	}*/
}

void Visio::emplena_textura(const Triangle &tr, const int &n_sv, double *limits)
{
	int float_corresponent =  (n_sv/8);
	int bit=(n_sv%8);
	int i0,i1;
	vector<Punt> p=tr.vertex_ordenats_x();
	Segment s(p[0],p[2]);
	double x=p[0].x();
	for(int l=0;l<2;l++)
	{
		Segment s1(p[l],p[l+1]);
		
		int j0=floor(((min(max(p[l].x(),limits[0]),limits[3])-xmin)/(xmax-xmin))*(double)amplada);
		int j1=ceil(((min(max(p[l+1].x(),limits[0]),limits[3])-xmin)/(xmax-xmin))*(double)amplada)+1;
		double inc_x=(p[l+1].x()-p[l].x())/(double)(j1-j0);
		for(int j=j0;j<j1;j++)
		{
			x+=inc_x;
			double y0=min(max(s.coordenada_y(x),limits[1]),limits[4]);
			double y1=min(max(s1.coordenada_y(x),limits[1]),limits[4]);
			if(y0<y1)
			{
				i0 =floor(((y0-ymin)/(ymax-ymin))*(double)alcada);
				i1=ceil(((y1-ymin)/(ymax-ymin))*(double)alcada)+1;
			}
			else
			{
				i1 =ceil(((y0-ymin)/(ymax-ymin))*(double)alcada)+1;
				i0=floor(((y1-ymin)/(ymax-ymin))*(double)alcada);
			}
			if(j==0) j=1;
			for(int k=((((j-1)*alcada)+i0)*4+float_corresponent);k<(((j-1)*alcada+i1)*4+float_corresponent);k=k+4)
				textura[k]=textura[k]|(1<<bit);
		}
	}
}

