#include "visorterreny.h"
#include "corbesnivell.h"

/*******************************************************************************************************/
/*   VisorTerreny::VisorTerreny( QWidget *parent, const char *name )  : QGLWidget( parent, name )      */
/*Constructor que inicialitza cadascuna de les variables globals de l'objecte VisorTerreny creat       */
/*******************************************************************************************************/
	

VisorTerreny::VisorTerreny( QWidget *parent, const char *name )
     : QGLWidget( parent, name ) 
{ 
	pressed = FALSE;

	/*Les mides per defecte inicials són de 0 les mínimes i 20 les màximes*/
        info_mon.xmin = info_mon.ymin = info_mon.zmin =  0.0;
        info_mon.xmax = info_mon.ymax =info_mon. zmax = 20.0;

	oldpos = QPoint( 0, 0 );

	/*A partir dels vectors que formen les coordenades màximes i mínimes calculem el centre*/
        info_GL.centre = 0.5 * ( Vector( info_mon.xmin, info_mon.ymin, info_mon.zmin ) +
                         Vector( info_mon.xmax, info_mon.ymax, info_mon.zmax ) );
	info_GL.elevacio = 30.0;
	info_GL.rotacio = 260.0;
        info_GL.zoom = 2.0;    
        info_GL.distancia = sqrt(info_mon.xmax*info_mon.xmax + 
                        info_mon. ymax*info_mon.ymax + 
                         info_mon.zmax*info_mon.zmax);  
        info_GL.posicioCam = Vector( 0.0, 0.0, 0.0 );
	info_GL._moviment = M_ORBITAL;
	
        mesh = Terreny::getInstancia();

        _mode = M_TERRENY;
        _estat = CALCULA_TOT;
	info_bezier.resolucio = 1;
	
// 	regions_hiperboliques = RegionsHiperboliques::instance();
	visio=Visio::instance();
	info_mostrar.veure_elements_visio = FALSE;
	
	/*Assignem els colors de fons, el del quadre i el dels triangles que representaran les cares*/
        info_GL.color_fons = Qt::white;
        info_GL.color_per_defecte.setRgb(170, 85, 0);
        info_GL.color_quadre = Qt::black;
        info_GL.color_eix_x = Qt::red;
        info_GL.color_eix_y = Qt::green;
        info_GL.color_eix_z = Qt::blue;
	info_mostrar.finestres=FALSE;
        info_mostrar.filferros = FALSE;
        info_mostrar.quadre = TRUE;
        info_mostrar.eixos = TRUE;	
        info_mostrar.veure_control = FALSE;
        info_mostrar.veure_normals = FALSE;	
	info_bezier.nvs.clear();
	comptador=0;
	
	// ex-visualitzador_regions_hiperboliques.
	info_vis.lmx=15;
	info_vis.lmy=10;
	info_vis.x_negatiu=0,info_vis.x_positiu=info_vis.lmx,info_vis.y_negatiu=0,info_vis.y_positiu=info_vis.lmy;
	info_h.context = cgCreateContext();
	info_h.haveLoadedPrograms=false;
	info_vis.bits=8;
	info_vis.veurePintarHiperboles=false;
	info_vis.fitarRegionsAcuradament=false; // si true la part de les regions que s'envia a pintar es el Triangle+Quadrat intersecat amb [0,1].
	info_vis.fitarQuadratUnitat=true;
	info_vis.segments_estudiats.clear();
	info_vis.conta.clear();
	info_vis.parts_primer_previes=0;
	info_vis.area_llegida=0;
	
	info_temps.total=0;
	info_temps.intersec_triangle=0;
	info_temps.intersec_segment=0;
	info_temps.regions=0;
	info_temps.retallar=0;
	info_temps.projeccio=0;
	info_temps.guardar=0;
	info_temps.pintar=0;
	
}

/**************************************/
/*   VisorTerreny::~VisorTerreny()    */
/*Destructor de la classe VisorTerreny*/
/**************************************/

VisorTerreny::~VisorTerreny() {}

/*******************************************************************/
/*   void VisorTerreny::initVista()                                */
/*Metode que inicialitza els valors coresponents a la vista inicial*/
/*******************************************************************/

void VisorTerreny::initVista()
{
     info_GL.centre = 0.5 * ( Vector( info_mon.xmin, info_mon.ymin, info_mon.zmin ) +
                      Vector(info_mon. xmax, info_mon.ymax, info_mon.zmax ) );

     info_GL.elevacio = 30.0;
     info_GL.rotacio = 260.0;
     info_GL.zoom = 2.0;
     info_GL.distancia = sqrt(info_mon.xmax*info_mon.xmax + info_mon.ymax*info_mon.ymax + info_mon.zmax*info_mon.zmax);  
     info_GL.posicioCam = Vector( 0.0, 0.0, 0.0 );	

     updateGL();
}

/*****************************************/
/*   void VisorTerreny::initializeGL()   */
/*Mètode que permet inicialitzar l'OpenGL*/
/*****************************************/

void VisorTerreny::initializeGL()
{
// cout<<"hola<"<<endl;
    static GLfloat ll_ambient[] = { 0.3, 0.3, 0.3, 1.0 };
    static GLfloat ll_diffuse[] = { 0.6, 0.6, 0.6, 1.0 };
    //static GLfloat ll_specular[] = { 1.0, 1.0, 1.0, 1.0 };
    Vector llum( info_mon.xmax, 0.0, info_mon.zmax );
    normalitza(llum);
    static GLfloat posicio0[] = { llum.x(), llum.y(), llum.z(), 0.0 };    
    //static GLfloat mat_shiny[] = { 10.0 };
    //qDebug( "%f-%f-%f", llum.x(), llum.y(), llum.z() );
    //static GLfloat ambientLight[] = { 1.0, 1.0, 1.0, 1.0 };    
    // Set light model to use ambient light specif ied by ambientLight[]
    //glLightModelfv(GL_LIGHT_MODEL_AMBIENT,ambientLight);

    glLightfv( GL_LIGHT0, GL_AMBIENT, ll_ambient );
    glLightfv( GL_LIGHT0, GL_DIFFUSE, ll_diffuse );
    //glLightfv( GL_LIGHT0, GL_SPECULAR, ll_specular );
    glLightfv( GL_LIGHT0, GL_POSITION, posicio0 );

    glEnable( GL_LIGHTING );
    glEnable( GL_LIGHT0 );

    glEnable( GL_COLOR_MATERIAL );
    glColorMaterial( GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE );

    glShadeModel( GL_SMOOTH );
    glDepthFunc(GL_LEQUAL);
    glEnable( GL_DEPTH_TEST );
    glDisable(GL_COLOR_LOGIC_OP);
	glDisable(GL_LOGIC_OP);
    //glCullFace( GL_FRONT );
    //glEnable( GL_CULL_FACE );
    //glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);    
    //glEnable( GL_NORMALIZE );
    
//     glEnable(GL_STENCIL_TEST);
    glDisable(GL_STENCIL_TEST);
	setMouseTracking(true);
	
	glGenFramebuffersEXT(1,&info_h.fb);
	info_h.error=glGetError();
	if(info_h.error!=GL_NO_ERROR) cout<<"Error en el glGenFramebuffersEXT: "<<gluErrorString(info_h.error)<<endl;
	
	glGenRenderbuffersEXT(1,&info_h.color_rb);
	info_h.error=glGetError();
	if(info_h.error!=GL_NO_ERROR) cout<<"Error en el glGenRenderbuffersEXT: "<<gluErrorString(info_h.error)<<endl;
	
	glBindFramebufferEXT(GL_FRAMEBUFFER_EXT,info_h.fb);
	info_h.error=glGetError();
	if(info_h.error!=GL_NO_ERROR) cout<<"Error en el glBindFramebufferEXT: "<<gluErrorString(info_h.error)<<endl;
	
	glBindRenderbufferEXT(GL_RENDERBUFFER_EXT,info_h.color_rb);
	info_h.error=glGetError();
	if(info_h.error!=GL_NO_ERROR) cout<<"Error en el glBindFramebufferEXT: "<<gluErrorString(info_h.error)<<endl;
	
// 	glRenderbufferStorageEXT(GL_RENDERBUFFER_EXT, GL_RGBA16,512, 512);
	glRenderbufferStorageEXT(GL_RENDERBUFFER_EXT, GL_RGBA,width(), height());
	info_h.error=glGetError();
	if(info_h.error!=GL_NO_ERROR) cout<<"Error en el glRenderbufferStorageEXT: "<<gluErrorString(info_h.error)<<endl;
	
	glFramebufferRenderbufferEXT(GL_FRAMEBUFFER_EXT,GL_COLOR_ATTACHMENT0_EXT,GL_RENDERBUFFER_EXT,info_h.color_rb);
	info_h.error=glGetError();
	if(info_h.error!=GL_NO_ERROR) cout<<"Error en el glFramebufferRenderbufferEXT: "<<gluErrorString(info_h.error)<<endl;
	
	info_h.CHECK_FRAMEBUFFER_STATUS();
	
	glBindFramebufferEXT(GL_FRAMEBUFFER_EXT,0);
	
	info_vis.bits=8;
	info_vis.maxim_bits=3*info_vis.bits;
    
}

/*************************************************************************************/
/*   void VisorTerreny::resizeGL( int ample, int alcada )                            */
/*Mètode que permet redimensionar la superfície GL canviant els paràmetres necessaris*/
/*************************************************************************************/

void VisorTerreny::resizeGL( int ample, int alcada )
{
    //qDebug( "[DEBUG]: Entro en resize de VisorTerreny." );

    glViewport( 0, 0, (GLint)ample, (GLint)alcada );
    glMatrixMode( GL_PROJECTION );
    glLoadIdentity();

    if ( alcada == 0 )
        gluPerspective( 60.0, (GLdouble)ample, 0.1, 10000.0 );
    else
        gluPerspective( 60.0, (GLdouble)ample / (GLdouble)alcada, 0.1, 10000.0 );
       
    glMatrixMode( GL_MODELVIEW );
    glLoadIdentity();
}

/*****************************************************/
/*   void VisorTerreny::paintGL()                    */
/*Mètode que pinta el contingut de la finestra OpenGL*/
/*****************************************************/

void VisorTerreny::paintGL()
{
	//qDebug( "[DEBUG]: Entro en paint de VisorTerreny." );
// 		 glLightfv( GL_LIGHT0, GL_AMBIENT, ll_ambient );
// 		glLightfv( GL_LIGHT0, GL_DIFFUSE, ll_diffuse );
		//glLightfv( GL_LIGHT0, GL_SPECULAR, ll_specular );
// 		glLightfv( GL_LIGHT0, GL_POSITION, posicio0 );

		
	if(info_vis.veurePintarHiperboles&&_estat==CALCULA_VISIO) //veure Pintar Hiperboles
		obtenir_segments_visibles();  //veure Pintar Hiperboles
	else
	{
		generaCalculs();
		
		glEnable( GL_LIGHTING );
		glEnable( GL_LIGHT0 );

		glEnable( GL_COLOR_MATERIAL );
		glColorMaterial( GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE );

		glShadeModel( GL_SMOOTH );
		glDepthFunc(GL_LEQUAL);
		glEnable( GL_DEPTH_TEST );
		glDisable(GL_STENCIL_TEST);
		setMouseTracking(true); 
		
		glMatrixMode( GL_PROJECTION );
		glLoadIdentity();
		if ( height() == 0 )
			gluPerspective( 60.0, (GLdouble)width(), 0.1, 10000.0 );
		else
			gluPerspective( 60.0, (GLdouble)width() / (GLdouble)height(), 0.1, 10000.0 );
		glMatrixMode( GL_MODELVIEW );
		glLoadIdentity();
		
		cgGLDisableProfile(info_h.fragmentProfile);	
		if( info_mostrar.filferros ) glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
		else glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
		
		//     cout<<"Numero de punts 3D: "<<mesh->numero_de_vertexs()<<endl;
		/*Es realitza la corresponent assignació de color de fons*/
		qglClearColor( info_GL.color_fons ); 
		glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
		glLoadIdentity();
		glPushMatrix();
		
		info_GL.posicioCam = Vector( ( info_GL.zoom * (info_GL.distancia / 2.0) * cos( gr2rd( info_GL.elevacio ) ) * cos( gr2rd( info_GL.rotacio ) ) ) + info_GL.centre.x(),
			( info_GL.zoom * (info_GL.distancia / 2.0) * cos( gr2rd( info_GL.elevacio ) ) * sin( gr2rd( info_GL.rotacio ) ) ) + info_GL.centre.y(),
			( info_GL.zoom * (info_GL.distancia / 2.0) * sin( gr2rd( info_GL.elevacio ) ) ) + info_GL.centre.z() );
		
		/*Es posiciona la càmara per tal que aquesta apunti cap allà on es desitja*/   
		gluLookAt( info_GL.posicioCam.x(), info_GL.posicioCam.y(), info_GL.posicioCam.z(),
			info_GL.centre.x(), info_GL.centre.y(), info_GL.centre.z(), 
			0.0, 0.0, 1.0 );

		Vector llum(info_mon. xmax, 0.0, info_mon.zmax );
		normalitza(llum);
		static GLfloat posicio0[] = { llum.x(), llum.y(), llum.z(), 0.0 };
		
		glDisable(GL_LIGHT0);
		glLightfv( GL_LIGHT0, GL_POSITION, posicio0 ); 
		glEnable( GL_LIGHT0 );   
		glDisable(GL_COLOR_LOGIC_OP);
		glDisable(GL_LOGIC_OP);	
		//qDebug("ROTACIO = %f - ELEVACIO = %f- info_GL.zoom = %f", info_GL.rotacio, info_GL.elevacio, info_GL.zoom); 
	//	generaCalculs();
		//     qDebug("Despres de generaCalculs");
		/*
		static GLfloat posicio0[] = { xmax, 0.0, zmax, 0.0 };
		glDisable( GL_LIGHTING );
		glDisable( GL_LIGHT0 );
		glLightfv( GL_LIGHT0, GL_POSITION, posicio0 );
		glEnable( GL_LIGHTING );
		glEnable( GL_LIGHT0 );
		*/
		if(info_mostrar.veure_elements_visio ) dibuixarObjectesVisio();
		/*Segons el tipus de visualització escollida cridarem a un o altre mètode de dibuix*/
		if( _mode == M_TERRENY ) dibuixaSuperficie();    
		if ( _mode == M_ISOLINIES ) dibuixaCorbes3D();       
		if(info_mostrar.finestres)
		{ pintarFinestres(); }
		// dibuixem els triangles que es consideren a cada pas, (els guardats a triangle_bons_visio.)
// 		    dibuixaVisibilitat();
		
		/*Desprès d'haver representat el model 2.5D representem el cub que l'engloba i els eixos x, y i z que ens permetran tenir coneixement d'allà on ens trobem*/
		glDisable( GL_LIGHTING );
		if( info_mostrar.quadre ) dibuixaQuadre();
		if( info_mostrar.eixos ) dibuixaEixos(); 
		glEnable( GL_LIGHTING );
		
		//dibuixa situacio focus de llum
		/*
		glPointSize(5.0);
		glBegin( GL_POINTS );
		glColor3f( 1.0, 0.0, 0.0 );
		glVertex3d( xmax, 0.0, zmax );
		glEnd();    
		*/
		
		if(mesh->comprovarInterseccio())
		{
			Segment seg;
			Triangle tria;
			vector<pCara> cares = mesh->getCaresIntersecciona();
			for(int i=0;i<cares.size();i++)
			{
				glColor3f( 0.1, 0.1, 0.8 );
				glBegin( GL_TRIANGLES );
					glVertex3f(cares[i]->vertex(0)->point().x(), cares[i]->vertex(0)->point().y(), cares[i]->vertex(0)->point().z() );
					glVertex3f(cares[i]->vertex(1)->point().x(), cares[i]->vertex(1)->point().y(), cares[i]->vertex(1)->point().z() );
					glVertex3f(cares[i]->vertex(2)->point().x(), cares[i]->vertex(2)->point().y(), cares[i]->vertex(2)->point().z() );
				glEnd();
			}
			switch(mesh->tipusInterseccio())
			{
				case PUNT_VISIO:
					glLineWidth(3.0);
					seg = mesh->getSegmentIntersecciona();
					glLineWidth(1.0);
					glBegin(GL_LINES);
						glColor3f( 0.1, 0.8, 0.1 );
						glVertex3f( seg.getOrigen().x(),seg.getOrigen().y(), seg.getOrigen().z() );
						glVertex3f( seg.getDesti().x(),seg.getDesti().y(), seg.getDesti().z() );
					glEnd();
					
					break;
				case SEGMENT_VISIO:
					tria = mesh->getTriangleIntersecciona();
					glColor3f( 0.1, 0.8, 0.1 );
					glBegin( GL_TRIANGLES );
						glVertex3f(tria.getTriangle_cgal().vertex(0).x(), tria.getTriangle_cgal().vertex(0).y(), tria.getTriangle_cgal().vertex(0).z());
						glVertex3f( tria.getTriangle_cgal().vertex(1).x(), tria.getTriangle_cgal().vertex(1).y(), tria.getTriangle_cgal().vertex(1).z());
						glVertex3f( tria.getTriangle_cgal().vertex(2).x(), tria.getTriangle_cgal().vertex(2).y(), tria.getTriangle_cgal().vertex(2).z());
					glEnd();
					break;
			}
			
		}
		
		glPopMatrix();    
	}

}

/********************************************************************/
/*    void VisorTerreny::dibuixaVisibilitat()                       */
/*Mètode que va dibuixant el tetraedre, triangles bons de visio, ...*/
/********************************************************************/

void VisorTerreny::dibuixaVisibilitat()
{
// 	cout<<"dVis"<<endl;
	glDisable(GL_COLOR_LOGIC_OP);
	glDisable(GL_LOGIC_OP);	
	if(mesh->numero_de_vertexs()>2)
	{
		for(int i=0;i<4;i++)
		{
			//normal = normal.vector_normal(info_vis.tetraedre.vertex((i+2)%4), info_vis.tetraedre.vertex((i+1)%4), info_vis.tetraedre.vertex(i));
			glBegin(GL_LINE_LOOP);
				glColor3f( 0.1, 0.8, 0.1 );
				//glNormal3f(normal.x(), normal.y(), normal.z());
				glVertex3f( info_vis.tetraedre.vertex((i+2)%4).x(), info_vis.tetraedre.vertex((i+2)%4).y(), info_vis.tetraedre.vertex((i+2)%4).z() );
				//glNormal3f(normal.x(), normal.y(), normal.z());
				glVertex3f( info_vis.tetraedre.vertex((i+1)%4).x(), info_vis.tetraedre.vertex((i+1)%4).y(), info_vis.tetraedre.vertex((i+1)%4).z() );
				//glNormal3f(normal.x(), normal.y(), normal.z());
				glVertex3f( info_vis.tetraedre.vertex(i).x(),info_vis.tetraedre.vertex(i).y(), info_vis.tetraedre.vertex(i).z());
			glEnd();
			glBegin( GL_TRIANGLES );
				glVertex3f(info_vis.tetraedre.vertex((i+2)%4).x(), info_vis.tetraedre.vertex((i+2)%4).y(), info_vis.tetraedre.vertex((i+2)%4).z() );
				glVertex3f( info_vis.tetraedre.vertex((i+1)%4).x(), info_vis.tetraedre.vertex((i+1)%4).y(), info_vis.tetraedre.vertex((i+1)%4).z() );
				glVertex3f( info_vis.tetraedre.vertex(i).x(),info_vis.tetraedre.vertex(i).y(), info_vis.tetraedre.vertex(i).z());
			glEnd();
		}
		//Pinta els triangles desglossats que interseccionen
		for(unsigned int i=0;i<info_vis.triangle_bons_visio.size();i++)
		{
			glBegin( GL_TRIANGLES );
				glColor3f( 0.4, 0.8, 0.6 );
				glVertex3f(info_vis.triangle_bons_visio[i].getTriangle_cgal().vertex(0).x(),info_vis.triangle_bons_visio[i].getTriangle_cgal().vertex(0).y(), info_vis.triangle_bons_visio[i].getTriangle_cgal().vertex(0).z());
				glVertex3f(info_vis.triangle_bons_visio[i].getTriangle_cgal().vertex(1).x(), info_vis.triangle_bons_visio[i].getTriangle_cgal().vertex(1).y(), info_vis.triangle_bons_visio[i].getTriangle_cgal().vertex(1).z() );
				glVertex3f(info_vis.triangle_bons_visio[i].getTriangle_cgal().vertex(2).x(),info_vis.triangle_bons_visio[i].getTriangle_cgal().vertex(2).y(), info_vis.triangle_bons_visio[i].getTriangle_cgal().vertex(2).z() );
			glEnd();
		}
		glBegin( GL_LINES );
			/*Indiquem el color que volem que tinguin les linies que anem a dibuixar tot seguit*/
			glColor3f( 1.0, 1.0, 0.0 );
			/*Generem les tres arestes que crearan el triangle a través dels punts guaradats anteriorment.*/
			glVertex3f( info_vis.ss.getOrigen().x(), info_vis.ss.getOrigen().y(), info_vis.ss.getOrigen().z());
			glVertex3f( info_vis.ss.getDesti().x(), info_vis.ss.getDesti().y(), info_vis.ss.getDesti().z() );
		glEnd();
	}
}

/********************************************************************/
/*    void VisorTerreny::dibuixaTriangulacio3D()                    */
/*Mètode que dibuixa el model utilitzant la triangulació de Delaunay*/
/********************************************************************/

void VisorTerreny::dibuixaTriangulacio3D()
{
	glDisable(GL_COLOR_LOGIC_OP);
	glDisable(GL_LOGIC_OP);	
	glLineWidth(0.5);
	IteradorCares fit = (mesh->triangulacio())->finite_faces_begin();
	for( ; fit != (mesh->triangulacio())->finite_faces_end(); ++fit)
	{
		Punt3d p0 = (*fit).vertex(0)->point();
		Punt3d p1 = (*fit).vertex(1)->point();
		Punt3d p2 = (*fit).vertex(2)->point();

		glBegin( GL_TRIANGLES );            
			qglColor( info_GL.color_per_defecte );
			glVertex3d( p0.x(), p0.y(), p0.z() );
			glVertex3d( p1.x(), p1.y(), p1.z() );
			glVertex3d( p2.x(), p2.y(), p2.z() );
		glEnd();
	}
}


void VisorTerreny::prepararFinestresPintar()
{
info_mostrar.finestres=TRUE;
repaint();
info_mostrar.finestres=FALSE;
}


void VisorTerreny::pintarFinestres()
{
list<Finestra>::iterator fj0,fvj0,fj1,fvj1,fj2,fvj2;
Finestra f;
pCara cara_veina;

//triemMon( info_mon.xmin, info_mon.xmax, info_mon.ymin, info_mon.ymax, -10, 10 ); 

for (IteradorCares fit=(mesh->triangulacio())->finite_faces_begin(); fit!=(mesh->triangulacio())->finite_faces_end();fit++)
{
	if(!mesh->es_cara_infinita(fit))
	{
		fj0=fit->info().LlistaFinestres[0].begin();
		fvj0=fit->info().LlistaFinestres[0].end();
		fj1=fit->info().LlistaFinestres[1].begin();
		fvj1=fit->info().LlistaFinestres[1].end();
		fj2=fit->info().LlistaFinestres[2].begin();
		fvj2=fit->info().LlistaFinestres[2].end();
	
		while (fj0!=fvj0)
		{
			f=*fj0;
			//f.escriure();
			f.setPinta(true);
			f.pintarEvent3d();
			fj0++;
		}
		
		while (fj1!=fvj1)
		{
			f=*fj1;
			//f.escriure();
			f.setPinta(true);
			f.pintarEvent3d();
			fj1++;
		}
		
		while (fj2!=fvj2)
		{
			f=*fj2;
			//f.escriure();
			f.setPinta(true);
			f.pintarEvent3d();
			fj2++;
		}
	
		for (int i=0;i<3;i++)
		{
			pCara cara_veina=fit->neighbor(i);
            		
			if (!mesh->es_cara_infinita(cara_veina))
			{
				fj0=cara_veina->info().LlistaFinestres[i].begin();
				fvj0=cara_veina->info().LlistaFinestres[i].end();
										
				while (fj0!=fvj0)
				{
					f=*fj0;
					//f.escriure();
					f.setPinta(true);
					f.pintarEvent3d();
					fj0++;
				}
			}
		}
	}
}

}


void VisorTerreny::triemMon(double xmin, double xmax, double ymin, double ymax, double zmin, double zmax)
{
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(xmin, xmax, ymin, ymax, zmin,zmax );   
	glMatrixMode(GL_MODELVIEW);
    	glLoadIdentity();
}

/**********************************************************************************/
/*   void VisorTerreny::dibuixarObjectesVisio(  )                                 */
/*Mètode que permet pintar els diferents objectes de visio introduits per l'usuari*/
/**********************************************************************************/

void VisorTerreny::dibuixarObjectesVisio( )
{
	int i,j,k,l;
	Objecte * obj;
	Objecte * objdist;
	Objecte * objcamiminim;
	Objecte * objcamiminim2;
	Punt p;
	glDisable(GL_COLOR_LOGIC_OP);
	glDisable(GL_LOGIC_OP);
	//glColor3f( 0.8, 0.0, 0.5 ); //Visibilitat
	glColor3f( 0.0, 1.0, 1.0 ); //Distàncies
	
	for(i=0; i<visio->numeroObjectes(); i++)
	{
		obj = visio->obtenirObjecte(i+1);
		switch(obj->tipusObjecte())
		{
			case PUNT_VISIO: 
				glPointSize(5);
				glBegin( GL_POINTS );
					glVertex3f( ((Punt *)obj)->x(), ((Punt *)obj)->y(), ((Punt *)obj)->z() );       
				glEnd();
				break;
			case SEGMENT_VISIO: 
				glBegin( GL_LINES );
					glVertex3f( ((Segment *)obj)->getOrigen().x(), ((Segment *)obj)->getOrigen().y(), ((Segment *)obj)->getOrigen().z() );      
					glVertex3f( ((Segment *)obj)->getDesti().x(), ((Segment *)obj)->getDesti().y(), ((Segment *)obj)->getDesti().z() );       
				glEnd();
				break;
			case POLIGON_VISIO: 
				glBegin( GL_LINE_LOOP );
					for(int j=0;j<((Poligon *)obj)->retorna_costats();j++)
					{
						p = ((Poligon *)obj)->obtenirVertex(j+1);
						glVertex3f( p.x(), p.y(), p.z() );      
					}
				glEnd();
				break;
			case POLIGONAL_VISIO: 
// 				cout<<"3D POLIGONAL"<<endl;
				for(int j=0;j<((Poligonal *)obj)->numero_de_punts()-1;j++)
				{
					glBegin( GL_LINES );
						p = ((Poligonal *)obj)->getPunt(j+1);
						glVertex3f( p.x(), p.y(), p.z() );  
						p = ((Poligonal *)obj)->getPunt(j+2);
						glVertex3f( p.x(), p.y(), p.z() );    
					glEnd();
				}
				break;
		}
	}
	
	for(k=0; k<visio->numeroObjectesDistancies(); k++)
	{
		objdist = visio->obtenirObjecteDistancies(k+1);
		switch(objdist->tipusObjecte())
		{
			case PUNT_VISIO: 
				glColor3f(1.0,1.0,0.33);
				glPointSize(5);
				glBegin( GL_POINTS );
					glVertex3f( ((Punt *)objdist)->x(), ((Punt *)objdist)->y(), ((Punt *)objdist)->z() );       
				glEnd();
				break;
		}		
	}
	
	int mida=visio->numeroObjectesCamiMinim();
	//cout << "VISOR TERRENY: objectesCamiMinim = " << mida << endl;
	l=0;
	
	/*cout << "Punts de Objectes Cami Minim" << endl;
	Objecte * o;
	for (int zz=0;zz<mida;zz++)
	{
	o=visio->obtenirObjecteCamiMinim(zz+1);
	cout << ((Punt *)o)->x() << " , " << ((Punt *)o)->y() << " , " << ((Punt *)o)->z() << endl;	
	}*/
	
	while (l<mida)
	{
		objcamiminim = visio->obtenirObjecteCamiMinim(l+1);
		objcamiminim2 = visio->obtenirObjecteCamiMinim(l+2);
		glColor3f(1.0,1.0,1.0);
		glLineWidth(3);
		glBegin(GL_LINES);
			glVertex3f(((Punt *)objcamiminim)->x(),((Punt *)objcamiminim)->y(),((Punt *)objcamiminim)->z());
			glVertex3f(((Punt *)objcamiminim2)->x(),((Punt *)objcamiminim2)->y(),((Punt *)objcamiminim2)->z());
		glEnd();
		l=l+2;
		while(l<mida)
		{
			objcamiminim=objcamiminim2;
			objcamiminim2=visio->obtenirObjecteCamiMinim(l+1);
			glColor3f(1.0,1.0,1.0);
			glLineWidth(3);
			glBegin(GL_LINES);
				glVertex3f(((Punt *)objcamiminim)->x(),((Punt *)objcamiminim)->y(),((Punt *)objcamiminim)->z());
				glVertex3f(((Punt *)objcamiminim2)->x(),((Punt *)objcamiminim2)->y(),((Punt *)objcamiminim2)->z());
			glEnd();
			l++;	
		}
	}
	
	//cout << "Punts dibuixats en el Visor = " << mida << endl;
		
}

/********************************************************/
/*   void VisorTerreny::dibuixaSuperficie()             */
/*Mètode que dibuixa el terreny en solid, amb superficie*/
/********************************************************/

void VisorTerreny::dibuixaSuperficie()
{
	Punt3d p0,p1,p2;
	IteradorCares fit;
	LlistaCares::iterator cit;
	Vector v_normal;
	LlistaCares c;
	glDisable(GL_COLOR_LOGIC_OP);
	glDisable(GL_LOGIC_OP);	
	
	for( fit = (mesh->triangulacio())->finite_faces_begin(); fit != (mesh->triangulacio())->finite_faces_end(); ++fit )
	{
		c = fit->info().cares;
//       cout<<"Cares: "<<c.size()<<endl;
for( cit = c.begin(); cit != c.end(); ++cit )
{ 
         p0 = cit->t[0];	            
	 p1 = cit->t[1];	
	 p2 = cit->t[2];	         
         v_normal = cit->normal;        
         glBegin( GL_TRIANGLES );       
         	qglColor( info_GL.color_per_defecte );
              
	      glNormal3d(v_normal.x(), v_normal.y(), v_normal.z());
              
	      glVertex3d( p0.x(), p0.y(), p0.z() );
              //glNormal3d(v_normal.x(), v_normal.y(), v_normal.z());
              glVertex3d( p1.x(), p1.y(), p1.z() );
              //glNormal3d(v_normal.x(), v_normal.y(), v_normal.z());
              glVertex3d( p2.x(), p2.y(), p2.z() );                      
	 glEnd();
// 	 cout<<"Punt: "<<p0.x()<<" - "<< p0.y()<<endl;
      }
      if( info_mostrar.veure_control ) 
      {
         dibuixaPuntsControl( fit->info().control );
         glBegin( GL_LINE_LOOP ); //POINTS );
              qglColor( Qt::blue );
              glVertex3d( fit->vertex(0)->point().x(), fit->vertex(0)->point().y(), fit->vertex(0)->point().z() );
              glVertex3d( fit->vertex(1)->point().x(), fit->vertex(1)->point().y(), fit->vertex(1)->point().z() );
              glVertex3d( fit->vertex(2)->point().x(), fit->vertex(2)->point().y(), fit->vertex(2)->point().z() );                      
	 glEnd();
      }
      if( info_mostrar.veure_normals ) 
      {
         glBegin( GL_LINES ); //POINTS );
              qglColor( Qt::darkRed );
              glVertex3d( fit->vertex(0)->point().x(), fit->vertex(0)->point().y(), fit->vertex(0)->point().z() );
              glVertex3d( fit->vertex(0)->point().x() + fit->info().v_normals[0].x() * 5, 
                          fit->vertex(0)->point().y() + fit->info().v_normals[0].y() * 5, 
                          fit->vertex(0)->point().z() + fit->info().v_normals[0].z() * 5 );
              glVertex3d( fit->vertex(1)->point().x(), fit->vertex(1)->point().y(), fit->vertex(1)->point().z() );
              glVertex3d( fit->vertex(1)->point().x() + fit->info().v_normals[1].x() * 5, 
                          fit->vertex(1)->point().y() + fit->info().v_normals[1].y() * 5, 
                          fit->vertex(1)->point().z() + fit->info().v_normals[1].z() * 5 );
              glVertex3d( fit->vertex(2)->point().x(), fit->vertex(2)->point().y(), fit->vertex(2)->point().z() );                      
              glVertex3d( fit->vertex(2)->point().x() + fit->info().v_normals[2].x() * 5, 
                          fit->vertex(2)->point().y() + fit->info().v_normals[2].y() * 5, 
                          fit->vertex(2)->point().z() + fit->info().v_normals[2].z() * 5 );
	 glEnd();         
         fit->info().v_normals;      
      }
   }	
}

/***************************************************************/
/*   void VisorTerreny::dibuixaCorbes3D()                      */
/*Mètode que dibuixa les corbes de nivell calculades previament*/
/***************************************************************/

void VisorTerreny::dibuixaCorbes3D()
{
   LlistaCares lc;   
   mesh->corbes3D(lc);

   LlistaCares::iterator cit;
   LlistaCares::iterator inici = lc.begin();
   LlistaCares::iterator fi = lc.end();
   Punt3d p0, p1, p2;
   Vector v_normal;
   QColor color;
   glDisable(GL_COLOR_LOGIC_OP);
	glDisable(GL_LOGIC_OP);	
	
   for( cit = inici; cit != fi; ++cit )
   {
        p0 = cit->t[0];	            
	p1 = cit->t[1];	
	p2 = cit->t[2];	         
	
        v_normal = cit->normal;                
	color = cit->color;
       
        glBegin( GL_TRIANGLES );       
           qglColor( color );
	   //qDebug("COLOR=(%d,%d,%d)", color.red(), color.green(), color.blue());
           glNormal3d(v_normal.x(), v_normal.y(), v_normal.z());
           glVertex3d( p0.x(), p0.y(), p0.z() );
           //glNormal3d(v_normal.x(), v_normal.y(), v_normal.z());
           glVertex3d( p1.x(), p1.y(), p1.z() );       
           //glNormal3d(v_normal.x(), v_normal.y(), v_normal.z());
           glVertex3d( p2.x(), p2.y(), p2.z() );                      
       glEnd();      
   }
}

/*********************************************************************/
/*   void VisorTerreny::mousePressEvent( QMouseEvent *e)             */
/*Mètode que s'executa en el moment en que es prem un botó del ratolí*/
/*********************************************************************/

void VisorTerreny::mousePressEvent( QMouseEvent *e)
{
          if (e->button() == QMouseEvent::LeftButton )
	{
		/*Simplement indiquem que existeix un botó apretat amb l'atribut pressed a cert i a continuació */
		pressed = true;
		
		/*L'atribut pos retorna la posició del mouse (QPoint), relativa a la finestra que rep l'event*/
		oldpos = e->pos();
	}
	else if(e->button() == QMouseEvent::RightButton)
	{
		comptador--;
		calcula_visio(info_vis.amb_triangles);
	}
	else if(e->button() == QMouseEvent::MidButton)
	{
		comptador++;
		calcula_visio(info_vis.amb_triangles);
	}
}

/***************************************************************************/
/*   void VisorTerreny::mouseReleaseEvent( QMouseEvent *e)                 */
/*Mètode que s'executa en el moment en que es deixa anar el botó del ratolí*/
/***************************************************************************/

void VisorTerreny::mouseReleaseEvent( QMouseEvent *e)
{
        pressed = false;
	
	/*Indiquem que no existeix cap botó apretat i que la posició és la (0,0)*/
	oldpos = e->pos() - e->pos();   //QPoint( 0, 0 );
}

/********************************************************************************/
/*   void VisorTerreny::mouseMoveEvent( QMouseEvent *e)                         */
/*Mètode que s'executa en el moment en que el ratolí es mou, estigui o no premut*/
/********************************************************************************/

void VisorTerreny::mouseMoveEvent( QMouseEvent *e) 
{
    /*En el cas que el botó estigui pres i ens estiguem movent realitzem el corresponent moviment de la càmara tenint en compte la posició anterior del ratolí. És a dir, es modifiquen els paràmetres de rotació i elevació i tot seguit es repinta l'OpenGL*/
    if ( pressed )
    {
       //qDebug( "MSG: En movimiento, (%d, %d)", e->x(), e->y() );
       QPoint vector = e->pos() - oldpos;

       if( info_GL._moviment == M_ORBITAL )
       {       
       
       if ( abs( vector.x() ) > abs( vector.y() ) )
       {
          if ( vector.x() > 0 )
	  {
	     info_GL.rotacio -= 1.0;
	     if ( info_GL.rotacio < 0.0 ) info_GL.rotacio += 360.0;	                  
	  }
          else
	  {
	     info_GL.rotacio += 1.0;
	     if ( info_GL.rotacio > 360.0 ) info_GL.rotacio -= 360.0;	     	  
	  }
       }
       else
       {
          if ( vector.y() > 0 ) 
	  {
	      if ( info_GL.elevacio < 89.0 ) info_GL.elevacio += 1.0;	  	     	     	  
	     
	  }
          else
	  {
	     if ( info_GL.elevacio > -89.0 ) info_GL.elevacio -= 1.0;
	  }
       }
      }
      else if( info_GL._moviment == M_DESP )
      {
       
      //qDebug("AX = %f, AY = %f", vector.x()/ 250.0, vector.y() / 250.0);
        info_GL.centre = info_GL.centre + 
                 (info_GL.zoom * (vector.x() / 200.0) * Vector(sin(gr2rd(info_GL.rotacio)), -cos(gr2rd(info_GL.rotacio)), 0) ) +
                 (info_GL.zoom * (-vector.y() / 200.0) * Vector(sin(gr2rd(info_GL.elevacio)) * cos(gr2rd(info_GL.rotacio)),
	                                                  sin(gr2rd(info_GL.elevacio)) * sin(gr2rd(info_GL.rotacio)),
                 				         -cos(gr2rd(info_GL.elevacio))));
      }
       
       updateGL();	
    }	
}

/************************************************/
/*   void VisorTerreny::actualitza()            */
/*Mètode que permet actualitzar la visualització*/
/************************************************/

void VisorTerreny::actualitza()
{
    _estat = CALCULA_TOT;
    //generaCalculs();
    updateGL();
}

/************************************************/
/*   void VisorTerreny::setZoom ( int accio )   */
/*Mètode que actualitza el zoom de la imatge    */
/************************************************/

void VisorTerreny::setZoom ( int accio )
{
    /*A partir de l'enter pasat per paràmetres podem determinar si el que es desitja fer és un zoom + o - i d'aquesta manera modificar les mides de la plantilla OpenGL del món*/
    if ( accio == APROPAR )
    {
      if ( info_GL.zoom > 0.01 ) info_GL.zoom = info_GL.zoom - 0.01;
    }
    else if ( accio == ALLUNYAR )
    {
      if ( info_GL.zoom < 2.0 ) info_GL.zoom = info_GL.zoom + 0.01;      
    }

    //resizeGL(width(), height());
    updateGL();
}

void VisorTerreny::setLmx(float l)
{
	info_vis.lmx=l;
}
void VisorTerreny::setLmy(float l)
{	
	info_vis.lmy=l;
}
float VisorTerreny::getLmx()
{
	return info_vis.lmx;
}
float VisorTerreny::getLmy()
{
	return info_vis.lmy;
}


/****************************************************************************************/
/*   void VisorTerreny::wheelEvent( QWheelEvent* we)                                    */
/*Mètode que és executat quan succeeix algun event que no està contemplat especificament*/
/****************************************************************************************/

void VisorTerreny::wheelEvent( QWheelEvent* we)
{
    if ( we->delta() > 0 )
    {
       if ( info_GL.zoom > 0.01 ) info_GL.zoom = info_GL.zoom - 0.01;
    }
    else
    {
       if ( info_GL.zoom < 2.0 ) info_GL.zoom = info_GL.zoom + 0.01;      
    }

    //resizeGL(width(), height());
    updateGL();
}

/******************************************/
/*   void VisorTerreny::dibuixaQuadre()*/
/*Mètode que dibuixa el recuadre englobant*/
/******************************************/

void VisorTerreny::dibuixaQuadre()
{
    glBegin( GL_LINE_LOOP );
        qglColor( info_GL.color_quadre );
        glVertex3d(info_mon. xmin, info_mon.ymin,info_mon. zmin );                              
        glVertex3d( info_mon.xmax,info_mon. ymin, info_mon.zmin );                      
        glVertex3d( info_mon.xmax, info_mon.ymin, info_mon.zmax );
        glVertex3d( info_mon.xmin, info_mon.ymin, info_mon.zmax );
    glEnd();	

    glBegin( GL_LINE_LOOP );
        qglColor( info_GL.color_quadre );
        glVertex3d(info_mon. xmin, info_mon.ymax, info_mon.zmax );        
        glVertex3d( info_mon.xmax, info_mon.ymax, info_mon.zmax );        
        glVertex3d( info_mon.xmax, info_mon.ymax, info_mon.zmin );                              
        glVertex3d( info_mon.xmin, info_mon.ymax, info_mon.zmin );                              
    glEnd();

    glBegin( GL_LINES );
        qglColor( info_GL.color_quadre );

        glVertex3d( info_mon.xmin, info_mon.ymin, info_mon.zmax );
        glVertex3d( info_mon.xmin, info_mon.ymax, info_mon.zmax );

        glVertex3d( info_mon.xmax, info_mon.ymin, info_mon.zmax );
        glVertex3d( info_mon.xmax, info_mon.ymax, info_mon.zmax );

        glVertex3d( info_mon.xmax, info_mon.ymin, info_mon.zmin );
        glVertex3d( info_mon.xmax, info_mon.ymax, info_mon.zmin );

        glVertex3d( info_mon.xmin, info_mon.ymin, info_mon.zmin );
        glVertex3d( info_mon.xmin,info_mon.ymax, info_mon.zmin );

    glEnd();
}

/************************************************************/
/*   void VisorTerreny::dibuixaEixos()                      */
/*Mètode que dibuixa els eixos per tal de poder-nos orientar*/
/************************************************************/

void VisorTerreny::dibuixaEixos()
{
   glBegin( GL_LINES );
       qglColor( info_GL.color_eix_x );
       glVertex3d( info_mon.xmin - 1.0, info_mon.ymin - 1.0, info_mon.zmin );
       glVertex3d( info_mon.xmin + 5.0, info_mon.ymin - 1.0, info_mon.zmin );

       qglColor( info_GL.color_eix_y );
       glVertex3d(info_mon.xmin - 1.0, info_mon.ymin - 1.0, info_mon.zmin );
       glVertex3d( info_mon.xmin - 1.0, info_mon.ymin + 5.0, info_mon.zmin );

       qglColor( info_GL.color_eix_z );
       glVertex3d( info_mon.xmin - 1.0, info_mon.ymin - 1.0, info_mon.zmin );
       glVertex3d( info_mon.xmin - 1.0, info_mon.ymin - 1.0, info_mon.zmin + 5.0 );
   glEnd();
}

/**************************************************************************************************/
/*   void VisorTerreny::dibuixaPla( double nivell, QColor color )                                 */
/*Mètode que dibuixa un quadrat a l'alçada indicada amb les coordenades mínimes i màximes de x i y*/
/**************************************************************************************************/

void VisorTerreny::dibuixaPla( double nivell, QColor color )
{
   glBegin( GL_QUADS );              
       qglColor( color );
       glVertex3d( info_mon.xmin, info_mon.ymin, nivell );
       glVertex3d( info_mon.xmin, info_mon.ymax, nivell );
       glVertex3d( info_mon.xmax, info_mon.ymax, nivell );
       glVertex3d( info_mon.xmax, info_mon.ymin, nivell );
   glEnd(); 
}

/*****************************************************/
/*   void VisorTerreny::setMode( const int mode )    */
/*Mètode que permet assignar un mode de visualització*/
/*****************************************************/

void VisorTerreny::setMode( int mode )
{
    //qDebug("setMode");
    _mode = mode;
    updateGL();
}

/**************************************************************************************/
/*   void Visualitzador3D::modificaMida( double _xmin, double _ymin, double _zmin,    */
/*                                double _xmax, double _ymax, double _zmax)           */
/*Mètode que permet modificar els atributs del visualitzador 2.5D, les coordenades    */
/**************************************************************************************/

void VisorTerreny::modificaMida( double _xmin, double _ymin, double _zmin, 
                                 double _xmax, double _ymax, double _zmax )
{
   info_mon.xmin = _xmin;
   info_mon.ymin = _ymin;
   info_mon.zmin = _zmin;
   info_mon.xmax = _xmax;
   info_mon.ymax = _ymax;
   info_mon.zmax = _zmax;
   
   info_GL.centre = 0.5 * ( Vector( info_mon.xmin, info_mon.ymin, info_mon.zmin ) + Vector( info_mon.xmax, info_mon.ymax, info_mon.zmax ) );
   info_GL.distancia = sqrt(info_mon.xmax*info_mon.xmax + info_mon.ymax*info_mon.ymax + info_mon.zmax*info_mon.zmax);  
  
   updateGL();
   repaint();
}

/***************************************************************************/
/*   void VisorTerreny::modificaColors( QColor cf, QColor cm, QColor cq,   */
/*                                   QColor cex, QColor cey, QColor cez )  */
/*Mètode que permet modificar el valor dels colors dels diferents objectes */
/***************************************************************************/

void VisorTerreny::modificaColors( QColor cf, QColor cm, QColor cq,
                                   QColor cex, QColor cey, QColor cez )
{
   info_GL.color_fons = cf;
   info_GL.color_per_defecte = cm;
   info_GL.color_quadre = cq;
   info_GL.color_eix_x = cex;
   info_GL.color_eix_y = cey;
   info_GL.color_eix_z = cez;
   
   updateGL();
}

/******************************************************************************/
/*   void VisorTerreny::modificaResolucio( int _resolucio )                   */
/*Mètode que permet modificar el valor de resolucio en la superficie de Bezier*/
/******************************************************************************/

void VisorTerreny::modificaResolucio( int _resolucio )
{
   info_bezier.resolucio = _resolucio;
   _estat = CALCULA_TOT;
   
   updateGL();
}

/************************************************************************/
/*   void VisorTerreny::modificaNivells( const Nivells & nivells )      */
/*Mètode que permet modificar el nombre de nivels que es volem calcular */
/************************************************************************/

void VisorTerreny::modificaNivells( const Nivells & nivells )
{
//    qDebug("modificaNivells");
   info_bezier.nvs = nivells;
   if( _estat != CALCULA_TOT ) _estat = CALCULA_CORBES;
   //calcul_corbes_fet = FALSE;
}

/*****************************************************************************/
/*   void VisorTerreny::veureFils( bool b )                                  */
/*Mètode que permet indicar si volem o no visualitzar el terreny en filferros*/
/*****************************************************************************/

void VisorTerreny::veureFils( bool b )
{
    info_mostrar.filferros = b;
    updateGL();
}

/******************************************************************************/
/*   void VisorTerreny::veureLimits( bool b )                                 */
/*Mètode que permet indicar si volem o no visualitzar el terreny amb el quadre*/
/******************************************************************************/

void VisorTerreny::veureLimits( bool b )
{
    info_mostrar.quadre = b;
    updateGL();
}

/******************************************************************************/
/*   void VisorTerreny::veureEixos( bool b )                                  */
/*Mètode que permet indicar si volem o no visualitzar el terreny amb els eixos*/
/******************************************************************************/

void VisorTerreny::veureEixos( bool b )
{
    info_mostrar.eixos = b;
    updateGL();
}

/************************************************************************************/
/*   void VisorTerreny::veurePuntsControl( bool b )                                 */
/*Mètode que permet indicar si volem o no visualitzar els punts de control de bezier*/
/************************************************************************************/

void VisorTerreny::veurePuntsControl( bool b )
{
    info_mostrar.veure_control = b;
    updateGL();
}

/********************************************************************************/
/*   void VisorTerreny::veureNormals( bool b )                                  */
/*Mètode que permet indicar si volem o no visualitzar les normals de cada vertex*/
/********************************************************************************/

void VisorTerreny::veureNormals( bool b )
{
    info_mostrar.veure_normals = b;
    updateGL();
}

/******************************************************/
/*   void VisorTerreny::mostraElementsVisio()         */
/*Mètode que permet fer visibles els elements de visio*/
/******************************************************/

void VisorTerreny::mostraElementsVisio( bool b)
{
  /*EditorTerreny *editor;
  if (editor->getModeVisibilitat()==TRUE)
  {
  info_mostrar.veure_elements_visio = b;
  updateGL(); //Repintem la plantilla d'OpenGL
  }
  else
  {
  cout << "\nError, no es poden veure punts de visio amb mode distancies";
  }*/	
  info_mostrar.veure_elements_visio = b;
  updateGL(); //Repintem la plantilla d'OpenGL
}

/************************************************************************/
/*   void VisorTerreny::generaCalculs()                                 */
/*Mètode que realitza el calcul de bezier segons la resolucio escollida */
/************************************************************************/

void VisorTerreny::generaCalculs()
{   
//     cout<<"generaCalculs "<<_estat<<" mode "<<_mode<<endl;
    if( _estat == CALCULA_TOT )
    {
       if( _mode == M_TERRENY )
       {
          mesh->generaBezier( info_bezier.resolucio );
          //terra->normalsBezier();
//          _estat = CALCULA_CORBES;
       }
       else if( _mode == M_ISOLINIES )
       {
          mesh->generaBezier( info_bezier.resolucio );
          mesh->generaCorbes( info_bezier.nvs );
          //terra->normalsCorbes();
          _estat = CALCULA_RES;
       }
    }
    else if( _estat == CALCULA_CORBES )
    {
       if( _mode == M_ISOLINIES )
       {
          //qDebug("Corbes2");          
          mesh->generaCorbes( info_bezier.nvs );
          _estat = CALCULA_RES;	 
       }        
    }
    else if(_estat == CALCULA_VISIO)
    	calcula_visio(info_vis.amb_triangles);
}

/*************************************************************/
/*   void VisorTerreny::setModeDesp ( int mode )             */
/*Mètode que permet indicar el tipus de moviment que cal fer */
/*************************************************************/

void VisorTerreny::setModeDesp ( int mode )
{
     info_GL._moviment = mode;
}

void VisorTerreny::setCalculaVisio (bool discretitzant)
{
	_estat = CALCULA_VISIO;
	info_vis.amb_triangles=discretitzant;
	if(info_vis.veurePintarHiperboles) calcula_visio(info_vis.amb_triangles);
	else updateGL();
}
/**************************************************************************************/
/*   int VisorTerreny::getResolucioMax()                                              */
/*Mètode que retorna el valor maxim de resolucio possible segons les mides del terreny*/
/**************************************************************************************/

int VisorTerreny::getResolucioMax()
{
  return( mesh->obtenirResolucioMax( info_mon.xmax * info_mon.ymax ) );
}

/*************************************************************************************/
/*   void VisorTerreny::dibuixaPuntsControl( Vector *ct )                          */
/*Mètode que serveix per representar els punts de control per la superficie de bezier*/
/*************************************************************************************/

void VisorTerreny::dibuixaPuntsControl( Vector *ct )
{
   glPointSize(5.0);
   glBegin( GL_POINTS );
      glColor3f(0.0, 1.0, 0.0);
      glVertex3d( ct[0].x(), ct[0].y(), ct[0].z() );
      glVertex3d( ct[1].x(), ct[1].y(), ct[1].z() );
      glVertex3d( ct[2].x(), ct[2].y(), ct[2].z() );
      glVertex3d( ct[3].x(), ct[3].y(), ct[3].z() );
      glVertex3d( ct[4].x(), ct[4].y(), ct[4].z() );
      glVertex3d( ct[5].x(), ct[5].y(), ct[5].z() );
      glVertex3d( ct[6].x(), ct[6].y(), ct[6].z() );
   glEnd();
}

// void VisorTerreny::dibuixaNormals( Vector *nm )
// {
// }

/***********************************************************************************************/
/*   void VisorTerreny::calcula_visio()                                                        */
/*Mètode que permet calcular les parts visibles del terreny utilitzant el mètode de inequacions*/
/***********************************************************************************************/

void VisorTerreny::calcula_visio( bool variant )
{

// 	info_vis.amb_triangles=false;//variant;
	timeval i,f;
	_estat=CALCULA_VISIO;
	pCara cara;
// 	vector<pCara> cares;
	int j,k;
	Segment sv;
	Punt pv;
	Poligon poligon_visio;
	Poligonal poligonal;
	int columnes,files;
	double x_minV2d, x_maxV2d, y_minV2d, y_maxV2d;
 	visio->get_mides(columnes,files,x_minV2d, x_maxV2d, y_minV2d, y_maxV2d);
	
	vector<vector<Segment> > segments_estudiar;
	segments_estudiar = mesh->obtenir_segments();
	
// 	float lmx=regions_hiperboliques->getVisualitzadorRegionsHiperboliques()->getLmx();
	int talls;
	Segment sv_aux;
	
	vector<double> part_visible;
	vector<Punt> vertexs;
// 	comptador=0;
	visio->inicialitza_buffer_textura();
	if(visio->numeroObjectes()==0)
	{
	
// 	visio->inserirObjecte( new Segment(Punt(), Punt(),true) );
		if(mesh->numero_de_cares()>3000) visio->inserirObjecte( new Segment(Punt(33.2,8.65,5), Punt(37.44,3.482,0.5),true) );
		else visio->inserirObjecte( new Segment(Punt(3.12, 16.1194, 0.5), Punt(8.48, 13.9303, 1.2),true) );
// 		visio->inserirObjecte( new Punt(18.3, 15.6,3.0));
// 		visio->inserirObjecte( new Punt(1.3, 5.6,4.5)); 
// 		visio->inserirObjecte( new Punt(1.2, 1.49254, 1));
// 		visio->inserirObjecte( new Segment(Punt(1.6, 2.48756, 0.5), Punt(4.36, 2.28856, 0.5),true));
// 		cout<<"visio.size() "<<visio->numeroObjectes()<<endl;

// visio->inserirObjecte( new Segment(Punt(19.24, 1.39303, 0.2), Punt(17.56, 0.696517, 0.2),true) );
// 		visio->inserirObjecte( new Segment(Punt(1.44, 5.87065, 0.5), Punt(2.76, 8.50746, 0.6),true) );
		
// 		visio->inserirObjecte( new Segment(Punt(14.12, 16.650718,8.0),Punt(16.96,9.617225,4.0),true) );
// 		visio->inserirObjecte( new Segment(Punt(7.0, 18.0, 7.0),Punt(2.5, 16.5, 8.0),true) );
// 		visio->inserirObjecte( new Segment(Punt(1.28, 14.9761, 2.), Punt(2.76, 18.0861, 4.),true) );
// 		visio->inserirObjecte( new Segment(Punt(1.4, 5.17413, 6), Punt (6.48, 1.89055, 6),true) );
// 		visio->inserirObjecte( new Segment(Punt(5.64, 3.28358, 8), Punt(18, 10.2488, 5),true) );
// 		visio->inserirObjecte( new Segment(Punt(1., 12., 3.), Punt(1.5, 7., 3.),true) );
// 		visio->inserirObjecte( new Segment(Punt(4.12, 2.48804, 2), Punt(5.96, 8.4689, 5),true) );
// 		visio->inserirObjecte( new Segment(Punt(9.12, 12.8708, 2), Punt(8.72, 6.74641, 1),true) );
// 		visio->inserirObjecte( new Segment(Punt(9.92, 17.177, 3), Punt(13.8, 15.2632, 2),true) );
// 		visio->inserirObjecte( new Segment(Punt(18.44, 3.92344, 3), Punt(12.88, 3.8756, 2),true) );
// 		visio->inserirObjecte( new Segment(Punt(17, 17.3206, 2), Punt(18.64, 11.8182, 3),true) );
// 		visio->inserirObjecte( new Segment(Punt(1.16, 4.35407, 2), Punt(2.4, 1.86603, 4),true) );
		// s'elimininen a l'eliminar visio.
	}
// 	info_temps.totali=
	if(mesh->numero_de_vertexs()>2) /*En el cas que tinguem algun triangle calculem els segments per cadascun d'ells */
	{
		
		gettimeofday(&i,NULL);
		
		gettimeofday(&info_temps.total_i,NULL);
// 		info_temps.total_i=clock();
		if(visio->numeroObjectes()>0) /*Si hi ha algun objecte de visio*/
		{
// 			cares = mesh->getCares();
			for(int r=0;r<visio->numeroObjectes();r++) /*Per cadascun dels elements de visio*/
			{
				info_vis._element=SEGMENT_V;
				switch( (visio->obtenirObjecte(r+1))->tipusObjecte() )
				{
					case PUNT_VISIO:
						pv = *((Punt *)visio->obtenirObjecte(r+1));
						info_vis._element=PUNT_V;
						pv.escriure();
						tractamentCares(pv,  x_minV2d, x_maxV2d, y_minV2d, y_maxV2d, variant, r,segments_estudiar);
							cout<<"visio.size() "<<visio->numeroObjectes()<<endl;
						pv.escriure();
						break;
					case SEGMENT_VISIO:
						sv = *((Segment *)visio->obtenirObjecte(r+1));
						talls = ceil(sv.midaSegment()/info_vis.lmx);
						for(int cv=0;cv<talls;cv++)
						{
							sv_aux= Segment(Punt(sv.e_t((double)cv/(double)talls)), Punt(sv.e_t(((double)(cv+1)/(double)talls))),true);
							tractamentCares(sv_aux,  /*cares,*/x_minV2d, x_maxV2d, y_minV2d, y_maxV2d, variant, r,segments_estudiar);
						}
						cout<<"\n FINAL DEL SEGMENT DE VISIO"<<endl;
						cout<<"SEGMENT_VISIO"<<endl;
						sv.escriure();
						break;
					case POLIGON_VISIO:
						poligon_visio = *((Poligon *)visio->obtenirObjecte(r+1));
						vertexs= poligon_visio.retorna_punts();
						/*Per cadascun de les arestes del poligon es realitzarà el mateix proces que en el cas de segments tenint en compte que tots ells escriuran sobre le mateix bit de textura*/
						cout<<"POLIGON_VISIO"<<endl;
						for( j=0; j<poligon_visio.retorna_costats(); j++)
						{
							/*Construir el segment de l'aresta*/
							sv = Segment(vertexs[j], vertexs[(j+1)%poligon_visio.retorna_costats()], true);
							talls = ceil(sv.midaSegment()/info_vis.lmx);
							for(int cv=0;cv<talls;cv++)
							{
								sv_aux= Segment(Punt(sv.e_t((double)cv/(double)talls)), Punt(sv.e_t(((double)(cv+1)/(double)talls))),true);
								tractamentCares(sv_aux,  /*cares,*/x_minV2d, x_maxV2d, y_minV2d, y_maxV2d, variant, r,segments_estudiar);
							}
							sv.escriure();
						}
						break;
					case POLIGONAL_VISIO:
						poligonal = *((Poligonal *)visio->obtenirObjecte(r+1));
						for ( k=0;k<poligonal.numero_de_punts()-1;k++ )
						{
							sv = Segment(poligonal.getPunt(k+1), poligonal.getPunt(k+2), true);
							talls = ceil(sv.midaSegment()/info_vis.lmx);
							for(int cv=0;cv<talls;cv++)
							{
								sv_aux= Segment(Punt(sv.e_t((double)cv/(double)talls)), Punt(sv.e_t(((double)(cv+1)/(double)talls))),true);
								tractamentCares(sv_aux,  /*cares,*/x_minV2d, x_maxV2d, y_minV2d, y_maxV2d, variant, r,segments_estudiar);
							}
// 							cout<<"ORIGEN "<<sv.getOrigen().x()<<" - "<<sv.getOrigen().y()<<" - "<<sv.getOrigen().z()<<endl;
							sv.escriure();
						}
				}
			}
		}
		gettimeofday(&info_temps.total_f,NULL);// 		info_temps.total_f=clock();
		gettimeofday(&f,NULL);
		info_temps.suma_total();
		
	}
	_estat=CALCULA_TOT;
	cout<<"TEMPS total: "<<info_temps.total<<" "<<(double)((&f)->tv_usec-(&i)->tv_usec)/1000000.0<<endl;
	cout<<"      interseccio Paral  "<<info_temps.intersec_triangle<<" "<<info_temps.intersec_triangle*100./info_temps.total<<" % "<<endl;
	cout<<"      interseccio Tvs     "<<info_temps.intersec_segment<<" "<<info_temps.intersec_segment*100./info_temps.total<<" % "<<endl;
	cout<<"      regions                "<<info_temps.regions<<" "<<info_temps.regions*100./info_temps.total<<" % "<<endl;
	cout<<"      retallar                "<<info_temps.retallar<<" "<<info_temps.retallar*100./info_temps.total<<" % "<<endl;
	cout<<"      pintar                  "<<info_temps.pintar<<" "<<info_temps.pintar*100./info_temps.total<<" % "<<endl;
	cout<<"      projectar eix y     "<<info_temps.projeccio<<" "<<info_temps.projeccio*100./info_temps.total<<" % "<<endl;
	cout<<"      area projectada   "<<info_vis.area_llegida<<endl;
	cout<<"      guardar inform   "<<info_temps.guardar<<" "<<info_temps.guardar*100./info_temps.total<<" % "<<endl;
	cout<<"  Total fraccionat      "<<( info_temps.intersec_triangle+info_temps.intersec_segment+info_temps.regions+info_temps.retallar+info_temps.pintar+info_temps.projeccio+info_temps.guardar)*100./info_temps.total<< "%"<<endl;
	
	
	updateGL();
}


// ------------------------------------------------------ SEGMENT VISIO --------------------------------------------

void VisorTerreny::tractamentCares(const Segment &sv, /*vector<pCara> cares,*/ double x_minV2d, double x_maxV2d, double y_minV2d, double y_maxV2d, bool variant,const int &r,const vector<vector<Segment> > &segments_estudiar )
{

	
	pCara triangle_sv;
	
	gettimeofday(&info_temps.intersec_triangle_i,NULL);// 	info_temps.intersec_triangle_i=clock();
	mesh->calculaEntrades(sv,triangle_sv);
	gettimeofday(&info_temps.intersec_triangle_f,NULL);// 	info_temps.intersec_triangle_f=clock();
	info_temps.suma_intersec_triangle();
	
	vector<double> part_visible;
	pCara cara;
	vector<pCara> cares;
	cares = mesh->getCares();
	
//  	for(unsigned int i=204+comptador; i<205+comptador;i++) //140, 569
	for ( unsigned int i=0;i<cares.size();i++)  //Per cada una de les cares
	{
		//Comprovem si el triangle actual no es veu dd el segment de visio
		cara = cares[i];
		Triangle tria(cara);
		bool continuar = false;
		if(x_maxV2d>tria.xmin()&&x_minV2d<tria.xmax()&& y_maxV2d>tria.ymin()&&y_minV2d<tria.ymax())
		{
			gettimeofday(&info_temps.intersec_triangle_i,NULL);// 			info_temps.intersec_triangle_i=clock();
			continuar=tria.TriangleTapaSegmentVisio(sv,part_visible);
			gettimeofday(&info_temps.intersec_triangle_f,NULL);// 			info_temps.intersec_triangle_f=clock();
			info_temps.suma_intersec_triangle();
		}
		if(continuar)
		{
			cout<<"\n Numero de cara: "<<i;
			vector<Segment> aux;
				analitzarTriangle( cara, triangle_sv, sv, variant, part_visible, r,segments_estudiar[i] /*aux*/);
		}
	}
	// ultima cara fer estudi dels que han quedat penjats.
	if(info_vis.conta.size()>0)
	{
		info_vis.segments_vis.clear();	
		if(info_vis.veurePintarHiperboles) updateGL();
		else obtenir_segments_visibles();
		
		info_vis.vector_regions.clear();
		gettimeofday(&info_temps.guardar_i,NULL);// 	info_temps.guardar_i=clock();
		emplena_textura(info_vis.segments_estudiats,info_vis.conta, info_vis.parts_primer_previes,r);
		gettimeofday(&info_temps.guardar_f,NULL);// 		info_temps.guardar_f=clock();
		info_temps.suma_guardar();
		info_vis.segments_estudiats.clear();
		info_vis.conta.clear();
// 		char kk;
// 		cin>>kk;
	}
}

/*******************************************************************************************************************************/
/*void VisorTerreny::analitzarTriangle( const pCara &cara , Segment sv, bool variant, const vector<double> &part_visible,int r)*/
/*Mètode que tracta els segments que formen un triangle i en calcula la visibilitat amb el sv                                  */
/*******************************************************************************************************************************/

void VisorTerreny::analitzarTriangle( const pCara &cara ,  const pCara &triangle_sv , const Segment &sv, bool variant, const vector<double> &part_visible,const  int & r,const vector<Segment> &trian_)
{
	
	Punt aux1, aux2;
	vector<Segment> trian;
	bool continuar=true;
	unsigned int j;
	int conta_seg=info_vis.conta.size()/2.;
	int reals=0,c=0;
	bool penjat = false;
	int maxim=info_vis.maxim_bits;
	vector<Regio> regio;
	pCara triangle_pv;
	gettimeofday(&info_temps.intersec_triangle_i,NULL);// 	info_temps.intersec_triangle_i=clock();
	vector<pCara> triangles_intersequen = mesh->triangles_intersequen_paralelapipede(cara, triangle_sv,sv); 
	gettimeofday(&info_temps.intersec_triangle_f,NULL);// 	info_temps.intersec_triangle_f=clock();
	info_temps.suma_intersec_triangle();

// 	for(unsigned int l=0;l<triangles_intersequen.size();l++)
// 		info_vis.triangle_bons_visio.push_back(Triangle(triangles_intersequen[l]));
	
	Triangle tr_cara(cara);
	Pla pla = Pla(Punt(cara->vertex(0)->point()), Punt(cara->vertex(1)->point()), Punt(cara->vertex(2)->point()));
	cout<<" Numero de triangles intersequen: "<<triangles_intersequen.size();
	if(triangles_intersequen.size()!=0)
	{
		Pla plav,plas;  
// 		trian = mesh->segments_triangle(cara); /*Obtenim els segments que formen el triangle actual*/
trian=trian_;
		cout<<" Numero de segments: "<<trian.size();
		if(trian.size()>0)
		{
			int i=0;
			while(trian[i].es_degenerat()&&i<trian.size()) i++;
			if(i<trian.size())
			{
				Vector vn=CGAL::cross_product( sv.getSegment_cgal().to_vector(),trian[i].getSegment_cgal().to_vector());
				plav=Pla(Plane(sv.source(),vn));
				plas=Pla(Plane(trian[i].source(),vn));  
			}
			else continuar=false;
		}
		if(continuar) 
			for (j=0;j<trian.size();j=j+reals) /*Per cadascun dels segments que formen el triangle*/
// 			for (j=0;j<min(1,trian.size());j=j+reals) /*Per cadascun dels segments que formen el triangle*/
			{
				reals=0;
				
				while(conta_seg<maxim && (j+reals)<trian.size())
				{
					regio.clear();
					/*Creem un pla a partir dels vertexs del triangle per poder calcular la z dels extrems del segment*/
					info_vis.ss=Segment(Punt(pla.on_plane_3d(trian[j+reals].source())),Punt(pla.on_plane_3d(trian[j+reals].target())),sv); //ss
					info_vis.segments_estudiats.push_back(trian[j+reals]);
					if(!info_vis.ss.es_degenerat()) /*Comprovem que els extrems del segment no siguin iguals ja que sino es tractaria d'un punt*/ 
						if(!penjat && info_vis.ss.midaSegmentVertical2d() <= info_vis.lmy)
						{
							tractamentSegments(sv,plav,plas, variant, triangles_intersequen,cara, part_visible,conta_seg);
							conta_seg++;info_vis.conta.push_back(info_vis.segments_estudiats.size()-1);info_vis.conta.push_back(1);reals++;
						}
						else
						{
							if(!penjat) c = 0;
							Segment frag = info_vis.ss;
							int talls = ceil(frag.midaSegmentVertical2d()/info_vis.lmy);
							while(conta_seg<maxim && c <talls)
							{
								info_vis.ss = Segment(Punt(frag.e_t((double)c/(double)talls-1e-4)), Punt(frag.e_t((double)(c+1)/(double)talls)),sv);
								tractamentSegments(sv, plav,plas,variant, triangles_intersequen,cara, part_visible,conta_seg);
								c++; conta_seg++; 
							}
							if(conta_seg<maxim||talls==c)
							{
								info_vis.conta.push_back(info_vis.segments_estudiats.size()-1); info_vis.conta.push_back(c); reals++; 
								penjat = false;
							}
							else
							{
								info_vis.conta.push_back(info_vis.segments_estudiats.size()-1); info_vis.conta.push_back(c); 
								penjat = true;
							}
						}
					else
						reals++;
				}
				
				if(conta_seg==maxim)
				{
					info_vis.segments_vis.clear();
					
					if(info_vis.veurePintarHiperboles) updateGL();
					else obtenir_segments_visibles();
					
					info_vis.vector_regions.clear();
					gettimeofday(&info_temps.guardar_i,NULL); // 			info_temps.guardar_i=clock();
					emplena_textura(info_vis.segments_estudiats,info_vis.conta, info_vis.parts_primer_previes,r);
					gettimeofday(&info_temps.guardar_f,NULL);// 			info_temps.guardar_f=clock();
					info_temps.suma_guardar();
					info_vis.segments_estudiats.clear();
					info_vis.conta.clear();
					conta_seg=0;
					
					if(penjat) info_vis.parts_primer_previes=c;
					else info_vis.parts_primer_previes=0;
// 					char kk;
// 					cin>>kk;
				}
				
			}
	}
	else
	{
		gettimeofday(&info_temps.guardar_i,NULL);// 		info_temps.guardar_i=clock();
		visio->emplena_textura(tr_cara,r,mesh->maximsIMinims());
		gettimeofday(&info_temps.guardar_f,NULL);// 		info_temps.guardar_f=clock();
		info_temps.suma_guardar();
	}
}


void VisorTerreny::emplena_textura(const vector<Segment> &trian,const vector<int> &conta, int parts_primer_previes,const int& r)
{
	int csv=0;
	double cs=(double)parts_primer_previes;
	unsigned int k=0;
	pair<Punt, Punt> parell_punts;
	vector< pair<Punt, Punt> > segments_visibles;
	while( k<(conta.size()-1)/2.&&csv<info_vis.segments_vis.size())
	{
		while(cs<conta[2*k+1])
		{
			for(unsigned int t=0;t<info_vis.segments_vis[csv].size();t++)
			{
				parell_punts.first = Punt(trian[conta[2*k]].e_t((cs+min(1,info_vis.segments_vis[csv][t].first))/(double)conta[(2*k)+1]));
				parell_punts.second=Punt(trian[conta[2*k]].e_t((cs+max(0,info_vis.segments_vis[csv][t].second))/(double)conta[(2*k)+1]));
				segments_visibles.push_back(parell_punts);
			}
			visio->emplena_textura_segment_terreny(segments_visibles, r); // tenim coordenades món.
			segments_visibles.clear();
			cs++;
			csv++;
		}
		k++;
		cs=0.;
	}
}

void VisorTerreny::tractamentSegments(const Segment &sv, const Pla &pla_v, const Pla &pla_s, bool variant,const vector<pCara> &triangles_intersequen, const pCara &cara, const vector<double> &part_visible,int cs)
{
	vector<Regio> regions;
	vector<pCara> cares_interseccio;
	Vector3D v1,pv;
	v1.converteix(sv.getOrigen(),info_vis.ss.getOrigen());
	pv=v1.producte_vectorial(info_vis.ss.getVector());
	double cop;
	
// 	cout<<"FRAGMENT TERRENY: "; info_vis.ss.escriure();
	Pla plasv(info_vis.ss.getOrigen(),info_vis.ss.getDesti(),sv.getOrigen());
	if(plasv.getPla().is_degenerate()) 
	{
		plasv= Pla(info_vis.ss.getOrigen(),info_vis.ss.getDesti(),sv.getDesti());
		if(plasv.getPla().is_degenerate()) cop =0;
		else cop =plasv.distancia(sv.getDesti().getPunt());
	}
	else
		cop =plasv.distancia(sv.getDesti().getPunt());
		
	bool coplanars=!(fabs(pv.producteEscalar(sv.getVector()))>1e-3||fabs(cop)>1e-3);
	if(!coplanars) /*En el cas que no siguin coplanars*/
	{
		bool cV=Triangle(cara).conteVertex(info_vis.ss);
		vector<Punt> punts;
		
		gettimeofday(&info_temps.intersec_segment_i,NULL);// 		info_temps.intersec_segment_i=clock();
		
		//Creem el tetraedre
		punts.push_back(info_vis.ss.getOrigen());
		punts.push_back(info_vis.ss.getDesti());
		Segment s1(info_vis.ss.getOrigen(),sv.getOrigen());
		Segment s2(info_vis.ss.getDesti(), sv.getDesti());
		if(s1.interseccioProjeccio(s2)){ punts.push_back(sv.getOrigen()); punts.push_back(sv.getDesti());}
		else{ punts.push_back(sv.getDesti()); punts.push_back(sv.getOrigen());}
		info_vis.tetraedre = Tetrahedron(punts[0].getPunt(), punts[1].getPunt(), punts[2].getPunt(), punts[3].getPunt());
		Punt bariT=((punts[0]+punts[1])+(punts[2]+punts[3]))/4.;
		info_vis.plans_tetraedre.clear();
		
		Pla pla_;
		for(int k=0;k<4;k++)
		{
			pla_=Pla(punts[k],punts[(k+1)%4],punts[(k+2)%4]);
			if(pla_.avaluarPunt(bariT)>TOLERANCE) pla_.canviarSigne();
			info_vis.plans_tetraedre.push_back(pla_);
		}

		// Determinem quines cares intersequen amb el tetraedre
		for(unsigned int l=0;l<triangles_intersequen.size();l++)
			if( Triangle(triangles_intersequen[l]).interseccio_tetraedre(info_vis.plans_tetraedre,cV)) cares_interseccio.push_back(triangles_intersequen[l]);
// 			if( Triangle(triangles_intersequen[l]).tr_intersects_T(info_vis.tetraedre,cV)) cares_interseccio.push_back(triangles_intersequen[l]);
		
		gettimeofday(&info_temps.intersec_segment_f,NULL);// 		info_temps.intersec_segment_f=clock();
		info_temps.suma_intersec_segment();
		
		//Obtenim les regions a partir dels triangles anteriors definides a través de hiperboles
		bool conte_vertex=Triangle(cara).conteVertex(info_vis.ss);
		
// 		info_temps.regions_i=clock();// 		gettimeofday(&info_temps.regions_i,NULL);

		double valor_s=pla_s.avaluarPunt(info_vis.ss.source());
		
		info_vis.ss.obtencio_Regions_variant( info_vis.tetraedre,info_vis.plans_tetraedre,sv,pla_v, pla_s, valor_s, cares_interseccio, regions, conte_vertex,info_temps.retallar,info_temps.regions,info_temps.intersec_segment,info_vis.amb_triangles);

// 		gettimeofday(&info_temps.regions_f,NULL);// 		info_temps.regions_f=clock();// 		info_temps.suma_regions();
		
// 		for(unsigned int l=0;l<cares_interseccio.size();l++)
// 			info_vis.triangle_bons_visio.push_back(Triangle(cares_interseccio[l]));
		
		cares_interseccio.clear();
	}
	else
	{
		//En el cas que siguin coplanars ss i sv
		bool colineals;
		Vector3D u=info_vis.ss.getVector();
		Vector3D v=sv.getVector();
		double lambda;
		
		if(u.x()!= 0) lambda=v.x()/u.x();
		else if(u.y()!= 0) lambda=v.y()/u.y();
		else if(u.z()!=0)  lambda=v.z()/u.z();
		else lambda=0.;
		colineals=fabs(v.x()-lambda*u.x())<1e-3&&fabs(v.y()-lambda*u.y())<1e-3&&fabs(v.z()-lambda*u.z())<1e-3; 
		if(!colineals)//coplanars
		{
			vector<Segment> segments_coplanars;
			cout<<"COPLANARS"<<endl;	
// 			Apliquem el calcul en el cas que siguin coplanars
			Segment ss_trans(info_vis.ss), sv_trans(sv);
			segments_coplanars=mesh->segments_intersequen(ss_trans, sv_trans,cara); // obtenim segment dins trapezi i nou sistema coordenades 
			regions=ss_trans.buscarImatgesHiperboles(sv_trans, segments_coplanars);
		}
		else //colineals
		{
			cout<<"COLINEALS"<<endl;
			double to=sv.coord_p_on_e(info_vis.ss.getOrigen().getPunt()),td=sv.coord_p_on_e(info_vis.ss.getDesti().getPunt());
			
			Segment s; //uneix extrems ss i sv.
			if(min(to,td)<0) s=Segment(Punt(sv.e_t(min(to,td))), Punt(sv.e_t(0.)));
			else  s=Segment(Punt(sv.e_t(1.)),Punt(sv.e_t(min(to,td))));
			if(mesh->linia_interseca(s))
				regions.push_back(Regio(Hiperbola(0.,0.,-1.,0.,Punt2d(0.,0.), Punt2d(1.,0.)),Hiperbola(0.,0.,1.,-1.,Punt2d(0.,1.), Punt2d(1.,1.))));
		}
	}
	info_vis.setRegions(part_visible,info_vis.ss.midaSegmentVertical2d(),sv.midaSegment(),coplanars);
	info_vis.vector_regions.push_back(regions);
	
}


// vector<vector<pair<double,double> > > VisorTerreny::obtenir_segments_visibles(/*const vector<vector<Regio> > & vr*/)
 void  VisorTerreny::obtenir_segments_visibles()
{
	cout<<" vr: "<<info_vis.vector_regions.size()<<", vs "<<info_vis.vector_segments.size();
	
	gettimeofday(&info_temps.pintar_i,NULL);// 	info_temps.pintar_i=clock();
	if(info_vis._element==SEGMENT_V) pintarRegionsHiperboliques();
	else if (info_vis._element== PUNT_V) pintarSegments();		
	gettimeofday(&info_temps.pintar_f,NULL);// 	info_temps.pintar_f=clock();
	info_temps.suma_pintar();
	
	
// 	vector<float> uc_buff(width()*height()*3,0);;
// 	if(info_vis.veurePintarHiperboles) glBindFramebufferEXT(GL_FRAMEBUFFER_EXT,0);
// 	else
// 	{
// 		glBindFramebufferEXT(GL_FRAMEBUFFER_EXT,info_h.fb);
// 		glReadBuffer(GL_COLOR_ATTACHMENT0_EXT);
// 	}
// 	glReadPixels(0,0,width(),height(), GL_RGB, GL_FLOAT, &uc_buff[0]);
// 	gettimeofday(&info_temps.pintar_f,NULL);// 	info_temps.pintar_f=clock();
// 	info_temps.suma_pintar();
	
	gettimeofday(&info_temps.projeccio_i,NULL);// 	info_temps.projeccio_i=clock();
	projeccioEixY((int)info_vis.vector_lx.size());
	gettimeofday(&info_temps.projeccio_f,NULL);// 	info_temps.projeccio_f=clock();
	info_temps.suma_projeccio();
	
	
	info_vis.vector_lx.clear();
	info_vis.vector_ly.clear();
	info_vis.vector_minim.clear();
	info_vis.vector_maxim.clear();
	info_vis.vector_coplanars.clear();
	info_vis.vector_regions.clear();
	info_vis.vector_segments.clear();
	glBindFramebufferEXT(GL_FRAMEBUFFER_EXT,0);
	cgGLDisableProfile(info_h.fragmentProfile);
}
void VisorTerreny::pintarRegionsHiperboliques()
{
	cout<<" p3DSH";
	glDisable(GL_DEPTH_TEST);
	
	modePintarFrameBuffer();
	
	if(info_vis.amb_triangles)
	{
		for(unsigned k=0;k<info_vis.vector_regions.size();k++)
		if(info_vis.vector_minim[k]>0. || info_vis.vector_maxim[k]<1.)
		{
			assignarColor(k);
			pintarQuadratsInicials(info_vis.vector_minim[k],info_vis.vector_maxim[k],info_vis.vector_lx[k],info_vis.vector_ly[k]);
		}
		PintarRegionsAproximadesPerTriangles();
	}
	else
	{
		cgGLDisableProfile(info_h.fragmentProfile);
		for(unsigned k=0;k<info_vis.vector_regions.size();k++)
			if(info_vis.vector_minim[k]>0. || info_vis.vector_maxim[k]<1.)
			{
				assignarColor(k);
				pintarQuadratsInicials(info_vis.vector_minim[k],info_vis.vector_maxim[k],info_vis.vector_lx[k],info_vis.vector_ly[k]);
			}
		
		cgGLEnableProfile(info_h.fragmentProfile);
		for(unsigned int j=0;j<info_vis.vector_regions.size();j++)
		{
			assignarColor(j);
			float lx=info_vis.vector_lx[j];
			float ly=info_vis.vector_ly[j];
			double minim=info_vis.vector_minim[j];
			double maxim=info_vis.vector_maxim[j];
			int alcada=(int)(ly/info_vis.lmy)*height();
			if(info_vis.vector_coplanars[j])
				pintarSharderHiperbolesCoplanars(info_vis.vector_regions[j],lx,ly,minim,maxim);
			else
				pintar3DShaderHiperboles(info_vis.vector_regions[j],lx,ly,minim,maxim);
		}
	}
 }
 
 void VisorTerreny::PintarRegionsAproximadesPerTriangles()
 {
	glEnable(GL_SCISSOR_TEST );
 	cout<<"PRApT: "/*<<info_vis.vector_regions.size()<<" seg: "<<info_vis.vector_lx.size()<<" "<<info_vis.vector_ly.size()<<endl*/;
//  	for(unsigned int l=0; l<min(1,info_vis.vector_regions.size());l++)
	for(unsigned int l=0; l<info_vis.vector_regions.size();l++)
	{
		assignarColor(l);
		unsigned int k,kf;
		double lx=info_vis.vector_lx[l];
		double ly=info_vis.vector_ly[l];
		double lmy=info_vis.lmy;
	
		int alcada=ly/info_vis.lmy*height();
		glScissor( 0, height()-alcada,  lx/info_vis.lmx*width(),alcada );
// 		for(unsigned int j=0+comptador;j<1+comptador;j++)
		for(unsigned int j=0;j<info_vis.vector_regions[l].size();j++)
		{
		
			vector<Hiperbola> hiperboles=info_vis.vector_regions[l][j].getRegio();
			vector<vector<Punt2d> > p_hip=info_vis.vector_regions[l][j].mostrejar(0.0001);
// 			glColor3f(1,0,0);
// 			for(unsigned int kd=0;kd<min(1,p_hip.size());kd++)
// 			{
// 				glBegin(GL_LINE_STRIP);
// 				for(k=0;k<p_hip[kd].size();k++)
// 					glVertex3f(p_hip[kd][k].x()*lx,lmy-ly*p_hip[kd][k].y(),0);
// 				glEnd();	
// 			}
			int gran=1;
			if(p_hip.size()==4) gran=2;
			
			for(int i=0;i<gran;i++)
			{
				glBegin(GL_TRIANGLE_STRIP);
				for(k=0;k<p_hip[i].size()&&k<p_hip[gran+i].size();k++)
				{
					glVertex3f(p_hip[i][k].x()*lx,lmy-p_hip[i][k].y()*ly,0);
					glVertex3f(p_hip[gran+i][k].x()*lx,lmy-p_hip[gran+i][k].y()*ly,0);
				}
				glEnd();
				if(k<p_hip[gran+i].size())
				{
					glBegin(GL_TRIANGLE_FAN);
					glVertex3f(p_hip[gran+i][k-1].x()*lx,lmy-p_hip[gran+i][k-1].y()*ly,0);
					for(;k<p_hip[i].size()&&k<p_hip[i].size();k++)
						glVertex3f(p_hip[i][k].x()*lx,lmy-p_hip[i][k].y()*ly,0);
					glEnd();	
				}
				else if(k<p_hip[i].size())
				{
					glBegin(GL_TRIANGLE_FAN);
					glVertex3f(p_hip[i][k-1].x()*lx,lmy-p_hip[i][k-1].y()*ly,0);
					for(;k<p_hip[gran+i].size()&&k<p_hip[gran+i].size();k++)
						glVertex3f(p_hip[gran+i][k].x()*lx,lmy-p_hip[gran+i][k].y()*ly,0);
					glEnd();	
				}
			}
		}
	}
	glDisable(GL_SCISSOR_TEST );
 }

void VisorTerreny::modePintarFrameBuffer()
{
	glBindFramebufferEXT(GL_FRAMEBUFFER_EXT,info_h.fb);
	
	GLenum drawbufs[] = {GL_COLOR_ATTACHMENT0_EXT};
	glDrawBuffersARB(1, drawbufs);
	glDrawBuffer(GL_COLOR_ATTACHMENT0_EXT);
	info_h.CHECK_FRAMEBUFFER_STATUS();
	
	if(info_vis.veurePintarHiperboles) glBindFramebufferEXT(GL_FRAMEBUFFER_EXT,0);
	
	glDisable(GL_DITHER);
	glDisable(GL_BLEND);
	glDisable(GL_DEPTH_TEST);
	glDisable( GL_LIGHTING );
	glDisable( GL_COLOR_MATERIAL );
	glEnable(GL_COLOR_LOGIC_OP);
	glEnable(GL_LOGIC_OP);
	glLogicOp(GL_OR);
	
	qglClearColor( Qt::black ); 
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT | GL_STENCIL_BUFFER_BIT);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(0,info_vis.lmx,0,info_vis.lmy,-10,10);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	
	if( info_vis.amb_triangles&&info_h.haveLoadedPrograms)
	{
		cgGLDisableProfile(info_h.fragmentProfile);
		info_h.haveLoadedPrograms=FALSE;
	}
	else if (!info_vis.amb_triangles&&!info_h.haveLoadedPrograms) 
		info_h.carregarFragment();
	
}

void VisorTerreny::pintarQuadratsInicials(double minim,double maxim,float lx,float ly)
{
	
	if(minim>0.)
	{
		glBegin(GL_QUADS);
			glVertex3f(0.,info_vis.lmy,0.);
			glVertex3f(0.,info_vis.lmy-ly,0.);
			glVertex3f(minim*lx,info_vis.lmy-ly,0.);
			glVertex3f(minim*lx,info_vis.lmy,0.);
		glEnd();
	}
	else
	{
		glBegin(GL_QUADS);
			glVertex3f(maxim*lx,info_vis.lmy-ly,0.);
			glVertex3f(maxim*lx,info_vis.lmy,0.);
			glVertex3f(lx,info_vis.lmy,0.);
			glVertex3f(lx,info_vis.lmy-ly,0.);
		glEnd();
	}
}


void VisorTerreny::pintar3DShaderHiperboles(const vector<Regio> &regions_g,float lx,float ly,float minim,float maxim)
{
	for(int i=0;i<(int)regions_g.size();i++)
	{
		double a3=0,b3=0,c3=0,d3=0;
		Hiperbola h3;
		Hiperbola h1=regions_g[i].getHiperbola(1);
		double a1=h1.ctu()/(lx*ly),b1=h1.ct()/lx,c1=h1.cu()/ly,d1=h1.cc();
		Hiperbola h2=regions_g[i].getHiperbola(2);
		double a2=h2.ctu()/(lx*ly),b2=h2.ct()/lx,c2=h2.cu()/ly,d2=h2.cc();
		if(regions_g[i].numero_hiperboles()==3)
		{
			h3=regions_g[i].getHiperbola(3);
			a3=h3.ctu()/(lx*ly);b3=h3.ct()/lx;c3=h3.cu()/ly;d3=h3.cc();
		}
			
		Hiperbola h_aux=h1;
		Hiperbola h_aux2;
		double x_mig=(h_aux.source().x()+h_aux.target().x())/2;
		if( (x_mig>=h2.source().x() && x_mig<=h2.target().x()) || (x_mig<=h2.source().x() && x_mig>=h2.target().x()) ) h_aux2=h2;
		else h_aux2=h3;
		
		

		//Fem el canvi d'escala x tenir els coeficients de le hiperboles correctes.
		double e=(double)(info_vis.x_positiu-info_vis.x_negatiu)/(double)width();
		double f=(double)(info_vis.y_positiu-info_vis.y_negatiu)/(double)height();

		cgGLSetParameter3f(info_h.xM_yM,lx*(float)width()/info_vis.x_positiu,height()-ly*(float)height()/info_vis.y_positiu,0);
		
		cgGLSetParameter3f(info_h.a_x2_y2_xy, 0,0,-a1*e*f);
		cgGLSetParameter3f(info_h.a_x_y_c,(a1*info_vis.y_positiu+b1)*e,(-a1*info_vis.x_negatiu-c1)*f,a1*info_vis.x_negatiu*info_vis.y_positiu+b1*info_vis.x_negatiu+c1*info_vis.y_positiu+d1);

		cgGLSetParameter3f(info_h.b_x2_y2_xy, 0,0,-a2*e*f);
		cgGLSetParameter3f(info_h.b_x_y_c,(a2*info_vis.y_positiu+b2)*e,(-a2*info_vis.x_negatiu-c2)*f,a2*info_vis.x_negatiu*info_vis.y_positiu+b2*info_vis.x_negatiu+c2*info_vis.y_positiu+d2);
	
		if(regions_g[i].numero_hiperboles()==3)
		{
			cgGLSetParameter3f(info_h.c_x2_y2_xy, 0,0,-a3*e*f);
			cgGLSetParameter3f(info_h.c_x_y_c,(a3*info_vis.y_positiu+b3)*e,(-a3*info_vis.x_negatiu-c3)*f,a3*info_vis.x_negatiu*info_vis.y_positiu+b3*info_vis.x_negatiu+c3*info_vis.y_positiu+d3);
		}
		else if(regions_g[i].numero_hiperboles()==2)
		{
			cgGLSetParameter3f(info_h.c_x2_y2_xy, 0,0,0);
			cgGLSetParameter3f(info_h.c_x_y_c,0,1,-height()-1);
		}
		
		bool aconseguit=false;
		vector<bool> rectangle;	vector<vector<Punt2d> > punts_rectangle;
		if(info_vis.fitarRegionsAcuradament)
			regions_g[i].afitarRegio(rectangle,punts_rectangle,aconseguit);
		
		if(aconseguit)
				pintarRegioBenAfitada(regions_g[i ],rectangle,punts_rectangle,lx,ly);
		else
		{
			// Trobem el rang q cal pintar
			double x_min=minim,x_max=maxim;
			Hiperbola h_max_rang=regions_g[i].getHiperbola(regions_g[i].hiperbolaMaximRangX()+1);
			x_min=h_max_rang.source().x();
			x_max=h_max_rang.target().x();
			if(x_min>x_max)
			{
				double aux=x_max;
				x_max=x_min;
				x_min=aux;
			}
			if(x_min<minim) x_min=minim;
			if(x_max>maxim) x_max=maxim;
			x_min=lx*x_min;
			x_max=lx*x_max;
			double y_min=0,y_max=1;
			Hiperbola h_max_rang_y=regions_g[i].getHiperbola(regions_g[i].hiperbolaMaximRangY()+1);
			y_min=h_max_rang_y.source().y();
			y_max=h_max_rang_y.target().y();
			if(y_min>y_max)
			{
				double aux=y_max;
				y_max=y_min;
				y_min=aux;
			}
			if(y_min<0) y_min=0;
			if(y_max>1) y_max=1;
			if(info_vis.fitarQuadratUnitat)
			{
				x_min=max(lx*minim,min(x_min,lx*maxim));
				x_max=min(lx*maxim,max(x_max,lx*minim));
				y_min=max(0,min(y_min,1));
				y_max=min(1,max(y_max,0));
			}
	// 		cout<<" ["<<x_min<<", "<<x_max<<"] x ["<<y_min<<", "<<y_max<<"]";
			y_min=info_vis.y_positiu-y_min*ly;
			y_max=info_vis.y_positiu-y_max*ly;
			if(x_min>info_vis.x_positiu || x_max<info_vis.x_negatiu || y_min>info_vis.y_positiu || y_max<info_vis.y_negatiu)
			{}
			else
			{
				glBegin(GL_QUADS);
					glVertex3f(x_min,y_min,0.);
					glVertex3f(x_max,y_min,0.);
					glVertex3f(x_max,y_max,0.);
					glVertex3f(x_min,y_max,0.);
				glEnd();
			}
		}
	}

}

void VisorTerreny::pintarSharderHiperbolesCoplanars( vector<Regio> regions_g,float lx,float ly,float minim,float maxim)
{ 
 	glDisable(GL_DEPTH_TEST);
	double e=(double)(info_vis.x_positiu-info_vis.x_negatiu)/(double)width();
	double f=(double)(info_vis.y_positiu-info_vis.y_negatiu)/(double)height();
	
	for(unsigned int i=0;i<regions_g.size();i++)
		pintarRegioHiperbolica(regions_g[i],info_vis.x_positiu,info_vis.y_positiu,e,f,lx,ly);

}


void VisorTerreny::pintarRegioHiperbolica(Regio r,double x_max, double y_max, double e, double f,float lx, float ly)
{
	bool dues_parts;
	
	dues_parts = r.prepararRegio();
	vector<Punt> p;
	int vegades=1;
	if(dues_parts) vegades=2;
	
	for(int i=0;i<vegades;i++)
	{
		double a1=r.getHiperbola(1).ctu(),b1=r.getHiperbola(1).ct(),c1=r.getHiperbola(1).cu(),d1=r.getHiperbola(1).cc();
		double a2=r.getHiperbola(2).ctu(),b2=r.getHiperbola(2).ct(),c2=r.getHiperbola(2).cu(),d2=r.getHiperbola(2).cc();
		
		cgGLSetParameter3f(info_h.xM_yM,x_max*width()/info_vis.x_positiu,y_max*height()/info_vis.y_positiu,0);
		
		cgGLSetParameter3f(info_h.a_x2_y2_xy, 0,0,-a1*e*f);
		cgGLSetParameter3f(info_h.a_x_y_c,(a1*info_vis.y_positiu+b1)*e,(-a1*info_vis.x_negatiu-b2)*f,a1*info_vis.x_negatiu*info_vis.y_positiu+b1*info_vis.x_negatiu+c1*info_vis.y_positiu+d1);
    
		cgGLSetParameter3f(info_h.b_x2_y2_xy, 0,0,-a2*e*f);
		cgGLSetParameter3f(info_h.b_x_y_c,(a2*info_vis.y_positiu+b2)*e,(-a2*info_vis.x_negatiu-c2)*f,a2*info_vis.x_negatiu*info_vis.y_positiu+b2*info_vis.x_negatiu+c2*info_vis.y_positiu+d2);
			
		// pintem la part de dins de les dues hiperboles (r.getHiperbola())[0], (r.getHiperbola())[1]
		// S'hauria de buscar un BOUNDING més ACURAT
		
		glBegin(GL_QUADS);
			glVertex3f(0,info_vis.y_positiu,0);
			glVertex3f(lx,info_vis.y_positiu,0);
			glVertex3f(lx,info_vis.y_positiu-ly,0);
			glVertex3f(0,info_vis.y_positiu-ly,0);
		glEnd();
		
		if(dues_parts)
		{
			vector<Hiperbola> hiperboles = r.getRegio();
			hiperboles[0].canviarSigne();
			hiperboles[1].canviarSigne();
			r.setRegio(hiperboles);
		}
	}
}
 

void VisorTerreny::projeccioEixY(int conta_segments)
{
	int r;
	if(info_vis.vector_segments.size()==0) r=1;
	else r=0;
	vector< vector< pair<double,double> > > resultat_projeccio;
	
	if(conta_segments>0)
	{
		vector< pair<double, double> > resultat;
		float maximlx=info_vis.vector_lx[0], maximly=info_vis.vector_ly[0];
		for(unsigned int i=1;i<info_vis.vector_lx.size();i++)
		{
			if(maximlx<info_vis.vector_lx[i]) maximlx = info_vis.vector_lx[i];
			if(maximly<info_vis.vector_ly[i]) maximly = info_vis.vector_ly[i];
		}
		
		int alcada=floor((maximly/info_vis.lmy)*height());
// 		int amplada=max((int)((maximlx/info_vis.lmx)*width()),1);
		int amplada=max(floor((maximlx/info_vis.lmx)*width()),1);
		
		vector<float> uc_buff(amplada*alcada*3,0);
// 		glHistogram(GL_HISTOGRAM,256,GL_RGB,true);
// 		info_h.error=glGetError();
// 		if(info_h.error!=GL_NO_ERROR) cout<<"Error en el gHistogram: "<<gluErrorString(info_h.error)<<endl;

		if(info_h.haveLoadedPrograms) glDisable(info_h.fragmentProfile);
		
		if(info_vis.veurePintarHiperboles) glBindFramebufferEXT(GL_FRAMEBUFFER_EXT,0);
		else
		{
			glBindFramebufferEXT(GL_FRAMEBUFFER_EXT,info_h.fb);
			glReadBuffer(GL_COLOR_ATTACHMENT0_EXT);
		}
		glReadPixels(0,height()-alcada,amplada,alcada, GL_RGB, GL_FLOAT, &uc_buff[0]);
		
		info_vis.area_llegida=info_vis.area_llegida+amplada*alcada;
		
// 		vector<int> histograma(256*3);
// 		glGetHistogram(GL_HISTOGRAM,true,GL_RGB,GL_UNSIGNED_BYTE,&histograma[0]);
// 		info_h.error=glGetError();
// 		if(info_h.error!=GL_NO_info_h.error) cout<<"info_h.error en el glGetHistogram: "<<gluinfo_h.errorString(info_h.error)<<endl;
// 	
 		glBindFramebufferEXT(GL_FRAMEBUFFER_EXT,0);

		double nombre_maxim=pow(2,info_vis.bits)-1;
		for(int t=0;t<conta_segments;t++)
		{
			resultat.clear();
			int aux=-1;
			int alcada_t=max(0,floor((info_vis.vector_ly[t]/info_vis.lmy)*height())-r);
			int amplada_t=max(1-r,floor((info_vis.vector_lx[t]/info_vis.lmx)*width())-r);
// 				int amplada_t=max((int)((info_vis.vector_lx[t]/info_vis.lmx)*width()),1);
			int byte=t/info_vis.bits;
			int bit=t%info_vis.bits;
			int i0=alcada-alcada_t;
			for(int i=i0;i<alcada-1;i++)
			{
				int blancs=0;
				for(int j=0;j<amplada_t-r;j++)
					if(((int)round(uc_buff[i*amplada*3+(j*3)+byte]*nombre_maxim) &(int) (1<<bit))>0 ) blancs++;
				
				if(blancs==amplada_t-r&&alcada_t!=0)//blancs son els no negres.
				{
					if(aux!=-1)
					{
						pair<double,double> p;
						if(aux==i0) p.first=1;
						else p.first=info_vis.canviCoordenadesFila(aux-i0,info_vis.vector_ly[t],(double)height())/(double)info_vis.vector_ly[t];
						p.second=info_vis.canviCoordenadesFila(i-i0,info_vis.vector_ly[t],(double)height())/(double)info_vis.vector_ly[t];
						resultat.push_back(p);
						aux=-1;
					}
				}
				else
					if(aux==-1) aux=i;
			}
			
			if(aux!=-1)	//comprovem l'ultima fila
			{
				pair<double,double> p;
				if(aux==i0) p.first=1;
				else p.first=info_vis.canviCoordenadesFila(aux-i0,info_vis.vector_ly[t],(double)height())/(double)info_vis.vector_ly[t];
				p.second=0;//p.second=info_vis.canviCoordenadesFila(alcada-i0+r,info_vis.vector_ly[t],(double)height())/(double)info_vis.vector_ly[t]; //=0;
				resultat.push_back(p);
			}
			info_vis.segments_vis.push_back(resultat);
		}
	}
}

void VisorTerreny::assignarColor(int conta_segments)
{
	double nombre_maxim=pow(2,info_vis.bits)-1;
	if(conta_segments<info_vis.bits)
		glColor3f(((double)(1<<(conta_segments%info_vis.bits)))/nombre_maxim,0.,0.);
	else if(conta_segments<2*info_vis.bits)
		glColor3f(0.,((double)(1<<(conta_segments%info_vis.bits)))/nombre_maxim,0.);
	else 
		glColor3f(0.,0.,((double)(1<<(conta_segments%info_vis.bits)))/nombre_maxim);
}


//         ----------------------------------      PUNT VISIO    ---------------------------------     

void VisorTerreny::tractamentCares(const Punt &pv, double x_minV2d, double x_maxV2d, double y_minV2d, double y_maxV2d, bool variant,const  int &r,const vector<vector<Segment> > &segments_estudiar )
{
	pCara cara,triangle_pv;
	mesh->calculaEntrades(pv,triangle_pv);
	vector<pCara> cares= mesh->getCares();
	for (unsigned int i=0;i<cares.size();i++)  //Per cada una de les cares
// 	for (unsigned int i=2;i<2;i++)  //Per cada una de les cares
	{
		//Comprovem si el triangle actual no es veu dd el segment de visio
		cout<<"\n cara "<< i;
		cara = cares[i];
		Triangle tria(cara);
		bool continuar = false;
		if(x_maxV2d>tria.xmin()&&x_minV2d<tria.xmax()&& y_maxV2d>tria.ymin()&&y_minV2d<tria.ymax())
			continuar = tria.TriangleTapaPuntVisio(pv);
// 		vector<Segment> aux;
		if(continuar)
			analitzarTriangle( cara,triangle_pv, pv, variant, r,/*aux*/segments_estudiar[i] );
	}
}


void VisorTerreny::analitzarTriangle( const pCara &cara , const pCara &triangle_pv ,const Punt &pv, bool variant, const int &r,const vector<Segment> &trian)
{
	Punt aux1, aux2;
	int conta_seg=0,reals=0,c=0,parts_primer_previes;
	bool penjat = false;
		int maxim=info_vis.maxim_bits;
	vector<int> conta;
	
	vector<pCara> triangles_intersequen = mesh->triangles_intersequen_piramide(cara, triangle_pv, pv);
	Triangle tr_cara(cara);
	Pla pla = Pla(Punt(cara->vertex(0)->point()), Punt(cara->vertex(1)->point()), Punt(cara->vertex(2)->point()));
	if(triangles_intersequen.size()!=0)
	{
// 		vector<Segment> trian = mesh->segments_triangle(cara); /*Obtenim els segments que formen el triangle actual*/ 
		cout<<" Numero de segments: "<<trian.size();
		for (unsigned int j=0;j<trian.size();j=j+reals) /*Per cadascun dels segments que formen el triangle*/
		{
			if(penjat) parts_primer_previes=c;
			else parts_primer_previes=0;
			conta.clear();
			conta_seg=0,reals=0;
			while(conta_seg<maxim && (j+reals)<trian.size())
			{
				/*Creem un pla a partir dels vertexs del triangle per poder calcular la z dels extrems del segment*/
				aux1=Punt(pla.on_plane_3d(trian[j+reals].getOrigen().getPunt()));
				aux2=Punt(pla.on_plane_3d(trian[j+reals].getDesti().getPunt()));
				if(aux1 != aux2) /*Comprovem que els extrems del segment no siguin iguals ja que sino es tractaria d'un punt*/
				{
					info_vis.ss = Segment(aux1, aux2); // segment ss
					if(!penjat && info_vis.ss.midaSegmentVertical2d() <= info_vis.lmy)
					{
						PuntSegment(pv, triangles_intersequen);
						conta_seg++;conta.push_back(j+reals);conta.push_back(1);reals++;
					}
					else
					{
						if(!penjat) c = 0;
						Segment frag = info_vis.ss;
						int talls = ceil(frag.midaSegmentVertical2d()/info_vis.lmy);
						while(conta_seg<maxim && c <talls)
						{
							info_vis.ss = Segment(Punt(frag.e_t((double)c/(double)talls-1e-4)), Punt(frag.e_t((double)(c+1)/(double)talls)));
							PuntSegment(pv,triangles_intersequen);
							c++; conta_seg++; 
						}
						if(conta_seg<maxim||talls==c)
						{
							conta.push_back(j+reals); conta.push_back(c); reals++; 
							penjat = false;
						}
						else
						{
							conta.push_back(j+reals); conta.push_back(c);
							penjat = true;
						}
					}
				}
				else
					reals++;
				
			}
			info_vis.segments_vis.clear();
			
			if(info_vis.veurePintarHiperboles) updateGL();
			else obtenir_segments_visibles();
			
			emplena_textura(trian,conta, parts_primer_previes,r);
			info_vis.vector_segments.clear(); 
 		}
		
	}
	else
		visio->emplena_textura(tr_cara,r,mesh->maximsIMinims());

}

void VisorTerreny::PuntSegment(const Punt &pv, const vector<pCara> &triangles_intersequen)
{
	vector<Segment> vector_s;
	Segment s;
	Triangle tr(info_vis.ss.getOrigen(), info_vis.ss.getDesti(), pv);
	
	Transformation3 trans = info_vis.ss.calcularTransformacioPuntVisio(pv);
	
	for(unsigned int i=0;i<triangles_intersequen.size();i++)
		if(!Triangle(triangles_intersequen[i]).p_on_triangle(info_vis.ss.punt_mig_3d()))
			if(tr.interseccio(triangles_intersequen[i], s, false, false))
			{
				Segment seg(trans(s.getOrigen().getPunt()), trans(s.getDesti().getPunt()));
				vector_s.push_back(seg.projeccio(Punt(trans(pv.getPunt()))));
//  				seg.projeccio(pv).escriure();
			}
			
	info_vis.vector_segments.push_back(vector_s);
// 	cout<<" vs "<<vector_s.size();
	info_vis.setSegments(info_vis.ss.midaSegmentVertical2d(),(double)width());
}

void VisorTerreny::pintarSegments()
{
	cout<<" pSegments ";
	modePintarFrameBuffer();
	
// 	glLineWidth(5.0);
	for(unsigned int k=0;k<info_vis.vector_segments.size();k++)
	{
		assignarColor(k);
		for(unsigned int i=0;i<info_vis.vector_segments[k].size();i++)
		{
			glBegin(GL_LINES);
				glVertex3f(info_vis.vector_segments[k][i].getOrigen().z(),info_vis.lmy-info_vis.vector_segments[k][i].getOrigen().x(),info_vis.vector_segments[k][i].getOrigen().y());
				glVertex3f(info_vis.vector_segments[k][i].getDesti().z(),info_vis.lmy-info_vis.vector_segments[k][i].getDesti().x(),info_vis.vector_segments[k][i].getDesti().y());
			glEnd();
		}
	}
// 	cout<<"fipSegments"<<endl;
 }

void VisorTerreny::pintarRegioBenAfitada(const Regio &r,const vector<bool> &rectangle,const vector<vector<Punt2d> > &punts_rectangle,double lx, double ly) const
 {
	if(r.numero_hiperboles()==3)
	{
		vector<Punt2d> p_h;
		p_h.push_back(r.getHiperbola(1).source()); p_h.push_back(r.getHiperbola(1).target());
		if(r.getHiperbola(3).source()!=p_h[0] &&r.getHiperbola(3).source()!=p_h[1]) 	
			p_h.push_back(r.getHiperbola(3).source());
		else p_h.push_back(r.getHiperbola(3).target());
		
		if(!info_vis.fitarQuadratUnitat)
		{
			glBegin(GL_TRIANGLES);
				glVertex3f(p_h[0].x()*lx,info_vis.y_positiu-ly*p_h[0].y(),0);
				glVertex3f(p_h[1].x()*lx,info_vis.y_positiu-ly*p_h[1].y(),0);
				glVertex3f(p_h[2].x()*lx,info_vis.y_positiu-ly*p_h[2].y(),0);
			glEnd();
		}
		else
		{
			vector<Punt> pts;
			pts.clear();
			vector<bool> extrem(4,true);  // al considerar l'extrem de vertex 00,10,11,01 respectivament
			
		// 	cout<<"triangle: ";
		// 	for(unsigned int j=0;j<3;j++)
		// 		cout<<"("<<p_h[j].x()<<", "<<p_h[j].y()<<") ";
						
			for(unsigned int j=2;j<3+1;j++)
			{
				// recta definida per punts (j,j+1).
				if( p_h[j%3].x()>=0&&p_h[j%3].x()<=1&&p_h[j%3].y()>=0&&p_h[j%3].y()<=1) pts.push_back(Punt(p_h[j%3]));
				else
				{
					double a=p_h[j%3].y()-p_h[(j+1)%3].y();
					double b=p_h[(j+1)%3].x()-p_h[j%3].x();
					double c=-1*(p_h[j%3].x()*a+p_h[j%3].y()*b);
					if(c*(b+c)<0) pts.push_back(Punt(0,-c/b,0)); // interseccio seg x=0 (0,0)-(0,1) <=> (0a+0b+c)*(0a+b+c)<0
					if((b+c)*(a+b+c)<0) pts.push_back(Punt(-(b+c)/a,1,0)); // interseccio seg y=1 (0,1)-(1,1) <=> (0a+1b+c)*(1a+b+c)<0
					if((a+b+c)*(a+c)<0) pts.push_back(Punt(1,-(a+c)/b,0)); // interseccio seg x=1 (1,1)-(1,0) <=> (1a+1b+c)*(1a+0b+c)<0
					if((a+c)*(c)<0) pts.push_back(Punt(-c/a,0,0)); // interseccio seg y=0 (1,0)-(0,0) <=> (1a+0b+c)*(0a+0b+c)<0
					double altre=a*p_h[(j+2)%3].x()+b*p_h[(j+2)%3].y()+c;
					extrem[0]=extrem[0]&&(c*altre>0);  // 00
					extrem[1]=extrem[1]&&((b+c)*altre>0);  //01
					extrem[2]=extrem[2]&&((a+b+c)*altre>0); //11
					extrem[3]=extrem[3]&&((a+c)*altre>0); //10
				}
			}
			if(extrem[0]){ pts.push_back(Punt(0,0,0));}// cout<<" (0, 0) "<<endl;}
			if(extrem[1]) {pts.push_back(Punt(0,1,0));}//cout<<" (0, 1) "<<endl;}
			if(extrem[2]) {pts.push_back(Punt(1,1,0));}//cout<<" (1, 1) "<<endl;}
			if(extrem[3]) {pts.push_back(Punt(1,0,0));}//cout<<" (1, 0) "<<endl;}
		// 	for(unsigned int j=0;j<pts.size();j++)
		// 		cout<<"("<<pts[j].x()<<", "<<pts[j].y()<<") ";
		// 	cout<<endl;
		
			vector<Punt> pts_;
			for(unsigned int j=0;j<pts.size();j++)
			{ 
				int k=0;
				while(k<j&&pts_[k]!=pts[j])k++;
				if(j==k) pts_.push_back(pts[j]);
			}
			if(pts_.size()>2)
			{
				Poligon_Convex pol(pts_); // calcula la convex Hull del cjt de punts que li passem.
				vector<Punt> p_dibuix;
				p_dibuix=pol.getPunts();
				glBegin(GL_POLYGON);
					for(unsigned int j=0;j<p_dibuix.size();j++)
						glVertex3f(p_dibuix[j].x()*lx,info_vis.y_positiu-ly*p_dibuix[j].y(),0);
				glEnd();
			}
		// 	else if(pts.size()>0) cout<<"NO PINTAR NI UN TRINAGLE!!!"<<endl;
		// 	else cout<<"RE"<<endl;
		}

	 }
			
			
	for(unsigned int k=0;k<rectangle.size();k++)
	{
		if(rectangle[k])
		{
			if(!info_vis.fitarQuadratUnitat)
			{
				glBegin(GL_QUADS);
					glVertex3f(punts_rectangle[k][0].x()*lx,info_vis.y_positiu-ly*punts_rectangle[k][0].y(),0);
					glVertex3f(punts_rectangle[k][1].x()*lx,info_vis.y_positiu-ly*punts_rectangle[k][1].y(),0);
					glVertex3f(punts_rectangle[k][2].x()*lx,info_vis.y_positiu-ly*punts_rectangle[k][2].y(),0);
					glVertex3f(punts_rectangle[k][3].x()*lx,info_vis.y_positiu-ly*punts_rectangle[k][3].y(),0);
				glEnd();
			}
			else
			{
				for(int kl=0;kl<2;kl++)
				{
					vector<Punt2d> p_h;
					p_h.push_back(punts_rectangle[k][0+kl]);
					p_h.push_back(punts_rectangle[k][1+kl]);
					p_h.push_back(punts_rectangle[k][2+kl]);
					
					vector<Punt> pts;
					pts.clear();
					vector<bool> extrem(4,true);  // al considerar l'extrem de vertex 00,10,11,01 respectivament
					
		// 			cout<<"triangle: ";
		// 			for(unsigned int j=0;j<3;j++)
		// 				cout<<"("<<p_h[j].x()<<", "<<p_h[j].y()<<") ";
					
					for(unsigned int j=2;j<3+1;j++)
					{
						// recta definida per punts (j,j+1).
						if( p_h[j%3].x()>=0&&p_h[j%3].x()<=1&&p_h[j%3].y()>=0&&p_h[j%3].y()<=1) pts.push_back(Punt(p_h[j%3]));
						else
						{
		// 					cout<<"else"<<endl;
							double a=p_h[j%3].y()-p_h[(j+1)%3].y();
							double b=p_h[(j+1)%3].x()-p_h[j%3].x();
							double c=-1*(p_h[j%3].x()*a+p_h[j%3].y()*b);
		// 					cout<<a<<"x + "<<b<<"y + "<< c<<" = 0"<<endl;
							if(c*(b+c)<0) pts.push_back(Punt(0,-c/b,0)); // interseccio seg x=0 (0,0)-(0,1) <=> (0a+0b+c)*(0a+b+c)<0
							if((b+c)*(a+b+c)<0) pts.push_back(Punt(-(b+c)/a,1,0)); // interseccio seg y=1 (0,1)-(1,1) <=> (0a+1b+c)*(1a+b+c)<0
							if((a+b+c)*(a+c)<0) pts.push_back(Punt(1,-(a+c)/b,0)); // interseccio seg x=1 (1,1)-(1,0) <=> (1a+1b+c)*(1a+0b+c)<0
							if((a+c)*(c)<0) pts.push_back(Punt(-c/a,0,0)); // interseccio seg y=0 (1,0)-(0,0) <=> (1a+0b+c)*(0a+0b+c)<0
							double altre=a*p_h[(j+2)%3].x()+b*p_h[(j+2)%3].y()+c;
							extrem[0]=extrem[0]&&(c*altre>0);  // 00
							extrem[1]=extrem[1]&&((b+c)*altre>0);  //01
							extrem[2]=extrem[2]&&((a+b+c)*altre>0); //11
							extrem[3]=extrem[3]&&((a+c)*altre>0); //10
		// 					cout<<pts.size()<<endl;
						}
					}
					if(extrem[0]){ pts.push_back(Punt(0,0,0));}// cout<<" (0, 0) "<<endl;}
					if(extrem[1]) {pts.push_back(Punt(0,1,0));}//cout<<" (0, 1) "<<endl;}
					if(extrem[2]) {pts.push_back(Punt(1,1,0));}//cout<<" (1, 1) "<<endl;}
					if(extrem[3]) {pts.push_back(Punt(1,0,0));}//cout<<" (1, 0) "<<endl;}
		// 			cout<<"pts pintem: ";
		// 			for(unsigned int j=0;j<pts.size();j++)
		// 				cout<<"("<<pts[j].x()<<", "<<pts[j].y()<<") ";
		// 				cout<<endl;
					vector<Punt> pts_;
					for(unsigned int j=0;j<pts.size();j++)
					{ int k=0;
						while(k<j&&pts_[k]!=pts[j])k++;
						if(j==k) pts_.push_back(pts[j]);}
					if(pts_.size()>2)
					{
		// 					cout<<"pintar"<<endl;
						Poligon_Convex pol(pts_); // calcula la convex Hull del cjt de punts que li passem.
		// 					cout<<"CH feta"<<endl;
						vector<Punt> p_dibuix;
						p_dibuix=pol.getPunts();
		// 					cout<<"pts obtinguts"<<endl;
						glBegin(GL_POLYGON);
							for(unsigned int j=0;j<p_dibuix.size();j++)
								glVertex3f(p_dibuix[j].x()*lx,info_vis.y_positiu-ly*p_dibuix[j].y(),0);
						glEnd();
		// 					cout<<"pintat"<<endl;
					}
				}
			}
		}
	}
}
 
