#ifndef VISOR_WINDOW_H
#define VISOR_WINDOW_H

#include <qmainwindow.h>
#include <qvaluelist.h> 
#include <qaction.h>
#include <qgl.h>
#include <math.h>
#include <qsize.h>
#include <qmessagebox.h>
#include <qpoint.h>

#include "qimagedialog.h"
#include "visorterreny.h"
#include "configvisordialeg.h"
#include "corbesnivell.h"
#include "configcorbesdialeg.h"

class QToolBar;
class QPopupMenu;

/********************************************************************/
/*              class VisorWin: public QMainWindow                  */
/*   Classe que permet representar i gestionar el terreny en 2.5D   */
/********************************************************************/

class VisorWin : public QMainWindow
{
    Q_OBJECT
public:
    VisorWin();
    ~VisorWin();
    
    VisorTerreny *getVisor();   
    void obteNivellsIMostra();
    void mostraTerreny();

protected:
    void closeEvent( QCloseEvent * );

private slots:

    void allunyar();
    void apropar();

    void desaImatge();

    void closeWindow();

    void about();
    void aboutQt();

    void actualitza();   
    void configuraVisor();

    void canviaMode( QAction * );
    
    void calculVisioDiscretitzant( );
    void calculVisio( );

private:    
    QToolBar *fileTools;
    VisorTerreny *vgl;   
    
    bool modificat;     
    ConfigVisorInfo prefs;
    Nivells nivs;

    QAction * rotaAction;
    QAction * desplazaAction;
    QAction * visioAction;
    QAction * visio_variantAction;
    QAction * visualitzarAction;
};

#endif
